2018-06-11  Victor Toso  <me@victortoso.com>

	Update NEWS for v0.35 release
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2018-06-11  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: disable celt051 by default
	With spice-common commit 72b0d603e12, SPICE_CHECK_CELT051 will error
	out if celt051-devel is installed, but neither --enable-celt051 nor
	--disable-celt051 are specified. This could be a problem when running
	make distcheck, so this commit adds --disable-celt051 so that we never
	hit that error.

2018-06-11  Victor Toso  <me@victortoso.com>

	Update spice-common
	Christophe Fergeau (21):
	      quic: Remove configurable RLE_PRED
	      quic: Remove configurable PRED
	      quic: Get rid of QUIC_RGB #define
	      quic: Get rid of RLE_STAT #define
	      quic: Get rid of RLE #define
	      quic: Factor common code
	      quic: Introduce CommonState *state variable in templates
	      quic: s/decorrelate_drow/correlate_row
	      quic: Add macros to make quic_tmpl.c much closer to quic_rgb_tmpl.c
	      quic: Remove unused argument in uncompress_row{0, }
	      quic: Use channel->correlate_row in macros
	      quic: Add test case for compression/decompression
	      build: Ensure we link with -lm if needed
	      build: Disable celt 0.5.1 by default
	      build: By default, error out if Opus is missing
	      build: Use AM_COND_IF
	      build: Remove checks for functions which are never called
	      build: Remove bitops.h
	      build: Move client sources to libspice_common_client_la_SOURCES
	      meson: Support auto/true/false for optional dependencies
	      meson: Remove check for vfork

	Frediano Ziglio (21):
	      protocol: Add some documentation for inval_all_pixmaps message
	      Add --enable-extra-checks option
	      codegen: Add some comments
	      codegen: Removed unused get_type methods
	      protocol: Use a typedef to specify stream_id type
	      lz: Move ENCODE_PIXEL for RGB24 and RGB32 to a common place
	      Fix integer overflows computing sizes
	      Write a small test to test possible crash
	      Avoid integer overflow computing image sizes
	      Fix generation of Smartcard channel
	      test-overflow: Remove a leak in the test
	      marshaller: Remove initial underscore from static function
	      codegen: Remove duplicate client and server code from ChannelType::resolve
	      Check for messages with duplicate names inside a channel
	      Check for messages with duplicate values inside a channel
	      lz: Optimise SAME_PIXEL for RGB16
	      lz: Inline GET_{r,g,b} macros
	      quic: Remove 'no-inline' hack
	      quic: Remove some too strict asserts in hot paths
	      quic: Fix endianness encoding
	      quic: Use __builtin_clz if available

	Eduardo Lima (Etrunko) (8):
	      build: Remove FIXME_SERVER_SMARTCARD hack
	      Fix demarshaller code generator
	      Fix field names for Smartcard protocol structures
	      Fix cast to spice_marshaller_item_free_func function
	      Bump glib requirements to 2.38
	      test-quic: Fix -Wsign-compare warning
	      Add support for building with meson/ninja
	      Add .gitlab-ci.yml file

	Jonathon Jongsma (2):
	      Remove extra self parameter from member function
	      miLineArc(): initialize edge1, edge2

	Victor Toso (1):
	      messages: document limitation of id in StreamCreate

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	channel-usbredir: Fix crash on channel-up
	By adding a guard to not handle channel-up on SpiceUsbredirChannel in
	case struct usbredirhost wasn't initialized yet. Same guard is in
	place for the generic usbredir_handle_msg() function to avoid handling
	Server's message while Client's initialization is not done.

	As mentioned in commit 291f3e4419e6, this isn't a problem for
	graphical clients as some initialization is done to present the
	shareable usb devices to user.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1399838
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Revert "channel-usbredir: Fix crash on channel-up"
	This reverts commit 291f3e4419e6fb4077ae43a5e09eb1c37b9dd729.

	Follow up patch should address rhbz#1399838 mentioned in commit above
	in a different way.

	Major reason to revert is that the SpiceUsbDeviceManager object is
	kept in SpiceSession as an easy way to share it between different
	SpiceUsbredirChannel while SpiceSession itself does not use it. This
	causes problems on migration as we start a new session with a new
	SpiceUsbDeviceManager object while the previous one still exists.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1558043
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2018-06-08  Marc-André Lureau  <marcandre.lureau@redhat.com>

	.mailmap: add another Victor Toso alias

	Replace GET_PRIVATE macros with generated get_private
	Acked-by: Victor Toso <victortoso@redhat.com>

	Use new GObject define macros with private
	G_ADD_PRIVATE was added in 2.38 and older functions are getting deprecated:
	https://gitlab.gnome.org/GNOME/glib/merge_requests/7/commits

	Acked-by: Victor Toso <victortoso@redhat.com>

	widget: handle smooth-scroll events
	With touchpads and similar devices, scroll events are not emitted on
	Wayland, but only smooth-scroll events.

	There is some discussion about handling smooth-scroll events in Spice
	(see "Add horizontal mouse wheel support" thread), but it will mean
	support from various components. For compatibility reasons, in the
	meantime, let's synthetize the smooth-scroll events to regular scroll
	buttons to fix scrolling.

	Tested on f28, gnome-shell under X and wayland.

	Related to:
	https://bugzilla.redhat.com/show_bug.cgi?id=1386602

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2018-06-08  Victor Toso  <me@victortoso.com>

	build-sys: require spice-protocol 0.12.4
	This is mostly needed form client side optimizations on streaming
	mode. The following change introduced dependency of latest
	spice-protocol:

	 | commit 424397546463698c2912b15449ef5e94f2c39c12
	 | Author: Snir Sheriber <ssheribe@redhat.com>
	 | Date:   Thu Mar 8 15:57:31 2018 +0200
	 |
	 | Gstreamer: Use GstVideoOverlay if possible

	The spice-protocol commit for reference:

	 | commit 4250216bafd37905afe0e9ad8cb9beb4a0c89254
	 | Author: Frediano Ziglio <fziglio@redhat.com>
	 | Date:   Tue Nov 7 10:45:20 2017 +0000
	 |
	 | Allow to specify a surface will be streamed
	 |
	 | This flag will allow the client to perform some optimisations
	 | on output and buffering processing.
	 | Old clients will ignore this additional flag.

	Note that without bumping the requirement, the code would fail to
	build with:

	 | channel-display.c:1809:50: error: ‘SPICE_SURFACE_FLAGS_STREAMING_MODE’
	 | undeclared (first use in this function); did you mean ‘SPICE_DISPLAY_STREAMING_MODE’?
	 |      surface->streaming_mode = !!(create->flags & SPICE_SURFACE_FLAGS_STREAMING_MODE);
	 |                                                   ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-06-07  Jonathon Jongsma  <jjongsma@redhat.com>

	Add SpiceSession::disconnected signal
	Previously, an application was required to determine whether a session
	had been disconnected by listening for the SpiceSession::channel-destroy
	signal for each individual channel. The Application had to keep track of
	whether all channels had been destroyed.

	An additional difficulty is that when a SpiceSession::channel-destroy
	signal is emitted, the channel object has not been freed yet, so any
	shutdown/de-allocation actions have not yet happened. This became
	significant since virt-viewer exits the application in response to the
	last 'channel-destroy' signal, which means that the channel objects are
	never properly freed. This is particularly problematic for the usbredir
	channel, which might need to disconnect USB devices asynchronously, and
	if the application exits before that process has completed, the USB
	devices may not be available on the client machine.

	With this patch, the SpiceSession still emits the 'channel-destroy'
	signal for each channel when it is disconnected. But it also internally
	tracks which channels have been destroyed, and waits for them to be
	freed. When all channels are freed, it emits an additional
	'disconnected' signal.  An application can be confident that all
	channels have been freed by this point, and the application can exit
	safely.

	Acked-by: Marc-André Lureau <marcandre.lureau@gmail.com>

	Don't unref GAsyncResult in callback
	A GAsyncReadCallback function should not unref the GAsyncResult passed
	to it as an argument since it does not hold a reference. This could
	cause a double-free error (or a glib warning that it is not a valid
	GObject)..

	Acked-by: Marc-André Lureau <marcandre.lureau@gmail.com>

2018-06-07  Marc-André Lureau  <marcandre.lureau@redhat.com>

	gstaudio: specify the segment format to be time-based
	With gstreamer audio backend, the following criticals are printed:
	(virt-viewer:27631): GStreamer-CRITICAL **: gst_segment_to_running_time: assertion 'segment->format == format' failed

	Because the default appsrc segment format is byte-based, although an
	audio sink want a time-based segment.

	Fixes:
	https://gitlab.freedesktop.org/spice/spice-gtk/issues/39

	Acked-by: Victor Toso <victortoso@redhat.com>

2018-06-04  Frediano Ziglio  <fziglio@redhat.com>

	spice-channel: Fix endianness for SASL authentication
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	spice-channel: Allows to connect from a big endian machine
	Tested with a ppc64 machine.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	tests: Remove unused structure declaration
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2018-06-01  Marc-André Lureau  <marcandre.lureau@redhat.com>

	gtk-doc: fix a few warnings
	Fixes:
	../../src/channel-display.h:131: warning: Field description for SpiceDisplayChannelClass::streaming_mode is not used from source code comment block.
	./spice-gtk-unused.txt:1: warning: 1 unused declarations. They should be added to spice-gtk-sections.txt in the appropriate place.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-05-29  Snir Sheriber  <ssheribe@redhat.com>

	Gstreamer: Don't let overlay to handle windowing system events
	In case glimagesink is used (up to playbin) window system events
	do not propagate to the widget. This patch tells the overlay not
	to try handle window system events.
	This could happen when the only decoder available is nvdec.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-05-28  Uri Lublin  <uril@redhat.com>

	gst_decoder_queue_frame: always free frame if it is not inserted into a queue
	The decoder_queue_frame function now owns 'frame'.
	If frame is not inserted into a queue (and freed later)
	it must be freed before returning.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	mjpeg_decoder_queue_frame: free frame when dropping the frame
	The frame is dropped and is not inserted into a queue to be
	freed later.
	mjpeg_decoder_queue_frame owns the frame and must free it.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-05-24  Frediano Ziglio  <fziglio@redhat.com>

	channel-display: Avoid ABI incompatibility for streaming-mode signal
	Changing SpiceDisplayChannelClass structure causes ABI incompatibility.
	Having a field for streaming-mode signal is not planned to be used
	so remove it.

	Acked-by: Snir Sheriber <ssheribe@redhat.com>

2018-05-22  Victor Toso  <me@victortoso.com>

	widget: update comment on fixed gtk+ bug
	The bug was fixed in GTK+ 3.22. I'm updating the comment plus setting
	the !GTK_CHECK_VERSION() to track changes that can be removed after
	bumping the gtk+ library.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2018-05-09  Frediano Ziglio  <fziglio@redhat.com>

	ci: Install pyparsing correctly
	Now that spice-gtk is in Gitlab CI is run but using Fedora 28 is
	failing during configure phase with:

	  checking for PROTOCOL... yes
	  checking python3 module: six... yes
	  checking python3 module: pyparsing... no
	  checking python2 module: six... no
	  checking python2 module: pyparsing... yes
	  configure: error: Python modules six and pyparsing are required
	  configure: error: ./configure failed for spice-common
	  ERROR: Job failed: exit code 1

	Install Python 3 packages needed.

	Acked-by: Victor Toso <victortoso@redhat.com>

2018-05-09  Snir Sheriber  <ssheribe@redhat.com>

	Gstreamer: Use GstVideoOverlay if possible
	Currently when gstreamer is used to decode a full-screen
	stream sent from the server, the decoding frames are being
	forced to RBGA format and pushed using appsink to be scaled
	and rendered to screen.

	Today most of the gstreamer sinks supports the GstVideoOverlay
	interface which allows to render directly from the pipeline to
	a window by a given windowing system id (i.e. xid). This patch
	makes playbin to use this feature if possible.

	Setting the DISABLE_GSTVIDEOOVERLAY environment variable will
	make gstreamer to avoid of using the gstvideooverlay interface.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-05-04  Eduardo Lima (Etrunko)  <etrunko@redhat.com>

	Remove unused spice-channel-enums.h file
	This file has been deprecated a long ago, since the following commit:

	commit d27f761325b356c91bda1ca60186d4613d6933d2
	Author: Marc-André Lureau <marcandre.lureau@redhat.com>
	Date:   Tue Jan 25 14:22:51 2011 +0100

	    gtk: rename s/spice-channel-enums/spice-glib-enums

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-05-04  Christophe Fergeau  <cfergeau@redhat.com>

	win32: Convert locale dir from UTF-8 to local encoding
	As indicated in gtk+ win32 gtk_get_localedir [1], bindtextdomain() is not
	UTF-8 aware on win32, so it needs a filename in locale encoding

	[1] https://gitlab.gnome.org/GNOME/gtk/blob/master/gtk/gtkwin32.c#L187

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	usb: Remove unused spice_marshaller_add_by_ref_full() user data
	g_free() only expects a single argument, so it won't make use of the
	extra 'channel' arg which will be passed as user data.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	build-sys: Disable -Wcast-function-type
	With gcc 8.0.1 from Fedora 28, I'm getting warnings related to
	-Wcast-function-type in a few places. Most of these could be solved
	by adding an intermediate wrapper with the right number of args, but the
	g_source_set_callback() warning cannot be solved this way as the
	callback signature will vary depending on the source it's called on.

	../../src/spice-session.c: In function 'spice_session_init':
	../../src/spice-session.c:293:33: warning: cast between incompatible function types from 'pixman_bool_t (*)(pixman_image_t *)' {aka 'int (*)(union pixman_image *)'} to 'void (*)(void *)' [-Wcast-function-type]
	     s->images = cache_image_new((GDestroyNotify)pixman_image_unref);
	                                 ^
	../../src/gio-coroutine.c: In function 'g_coroutine_socket_wait':
	../../src/gio-coroutine.c:59:32: warning: cast between incompatible function types from 'gboolean (*)(GSocket *, GIOCondition,  void *)' {aka 'int (*)(struct _GSocket *, enum <anonymous>,  void *)'} to 'gboolean (*)(void *)' {aka 'int (*)(void *)'} [-Wcast-function-type]
	     g_source_set_callback(src, (GSourceFunc)g_io_wait_helper, self, NULL);
	                                ^
	(and a few more like these)

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-04-25  Eduardo Lima (Etrunko)  <etrunko@redhat.com>

	tests: Shut up warnings about unitialized struct fields
	Build complains about lots of unitialized fields in TestCase definition,
	for instance:

	../tests/session.c:276:11: warning: missing initializer for field ‘message’ of ‘TestCase {aka const struct <anonymous>}’ [-Wmissing-field-initializers]
	           "spice://[::192.9.5.5]:5910" },
	           ^~~~~~~~~~~~~~~~~~~~~~~~~~~~
	../tests/session.c:11:18: note: ‘message’ declared here
	     const gchar *message;
	                  ^~~~~~~
	../tests/session.c:282:11: warning: missing initializer for field ‘unix_path’ of ‘TestCase {aka const struct <anonymous>}’ [-Wmissing-field-initializers]
	           "password may be visible in process listings"},
	           ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-04-23  Victor Toso  <me@victortoso.com>

	spice-widget: remove old warning
	This log was introduced in 13f5ebbf07a3 to track the situation where
	the GdkCursor pointer would be invalid/NULL. That was possible if the
	caller passed a NULL for rgba pointer in cursor_set().

	Code has changed a bit since then, it isn't necessary to log a warn in
	the unlikely event of cursor_shape being NULL.

	Reported-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-04-20  Victor Toso  <me@victortoso.com>

	usb-device-widget: remove goto/label
	The 'end' label is used only once and can be replaced by moving the
	code into the existing 'if (!devices)'.

	For convenience this patch also:
	* Explicit check against NULL
	* Added curly brackets to the moved 'for'
	* Moved variable 'i' to inner scope

	Reviewed-by: Eduardo Lima (Etrunko) <etrunko@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-04-19  Frediano Ziglio  <fziglio@redhat.com>

	spice-widget: Fix use after free
	Before d567bfe65f010556f12c7ca5e95d0e480b2e4a70
	("spice-widget: fix leak of boxed type cursor-shape") the cursor was
	just leaked. Now is freed however mouse_pixbuf points to cursor
	data so when the cursor is freed mouse_pixbuf points to a dangling
	pointer. Retain the cursor as long as mouse_pixbuf is live.

	Acked-by: Victor Toso <victortoso@redhat.com>

2018-04-19  Victor Toso  <me@victortoso.com>

	channel-display: always name GHashFunc and GEqualFunc
	g_hash_table_new() allows to pass NULL for GHashFunc and GEqualFunc
	which defaults to g_direct_hash() and g_direct_equal().

	This is the only place in our code that uses NULL while in
	channel-main and channel-smartcard and spice-file-transfer-task we
	name it.

	Changing for consistency and clarity.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-04-17  Victor Toso  <me@victortoso.com>

	channel-display-mjpeg: remove verbose logs
	Those don't add any useful information.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-04-17  Eduardo Lima (Etrunko)  <etrunko@redhat.com>

	build: Remove check for pnp.ids path
	This looks like a leftover from the following commit, which removed the
	only reference for this file.

	commit 30986505ba6041c293c38cb4b7f4b618a59f4716
	Author: Marc-André Lureau <marcandre.lureau@redhat.com>
	Date:   Fri May 10 17:05:49 2013 +0200

	    Remove GnomeRR code

	    Changing client resolution is a bad idea, and never took up.
	    Remove some unmaintained experimental code.

	Acked-by: Victor Toso <victortoso@redhat.com>

2018-04-16  Frediano Ziglio  <fziglio@redhat.com>

	channel-display-gst: Protect timer_id with queue_mutex
	timer_id is supposed to be protected by this mutex, make sure this
	is true in spice_gst_decoder_reschedule.

	Acked-by: Snir Sheriber <ssheribe@redhat.com>

	spice-channel: Make some conditional code more readable
	Avoid confusing indentation.

	Acked-by: Snir Sheriber <ssheribe@redhat.com>

	channel-display-gst: Reduce contention on queues_mutex
	We don't need to lock the entire queues to create a frame.

	Acked-by: Snir Sheriber <ssheribe@redhat.com>

	channel-display: Update debug message
	The flags field in SpiceMsgSurfaceCreate does not only contains
	the primary flag.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	gio-coroutine: Remove only assigned self field
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	gio-coroutine: Make waitFuncs static
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	gio-coroutine: Fix C inheritance
	GConditionWaitSource should inherit from GSource so GSource
	should be the first field.

	GSource is
	struct _GSource
	{
	  /*< private >*/
	  gpointer callback_data;
	  ...
	};

	With GSource being opaque, the only thing which could cause issues
	was modifying GConditionWaitSource::self.
	However, GConditionWaitSource::self is precisely what we use as
	callback_data, and anyway the GSource probably sets callback_data after
	spice-gtk set GConditiionWaitSource::self. So this ends up all working
	even though this is wrong.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2018-04-05  Frediano Ziglio  <fziglio@redhat.com>

	spice-channel: Disable TLS v1.0
	TLS v1.0 is now considered insecure.
	The protocol is already disabled on the server side (cfr commit commit
	fac12737d "reds: Disable TLS 1.0").
	To avoid downgrade attacks disable it even on the client.

	Related: https://bugzilla.redhat.com/show_bug.cgi?id=1521053

	Acked-by: Victor Toso <victortoso@redhat.com>

2018-04-05  Victor Toso  <me@victortoso.com>

	channel-display: remove unneeded function
	The get_stream_id_by_stream() was introduced in 141c2d82 to debug
	GStreamer's pipeline. But with previous patch, we are moving the ID to
	the display_stream structure and can be accessible directly.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	channel-display: rename display_stream_destroy()
	This patch renames destroy_display_stream() to
	display_stream_destroy() to keep compatibility with
	display_stream_create()

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	channel-display: remove id parameter from helper function
	Instead of passing the id parameter for destroy_display_stream() which
	is only used for debug, let's store the id when creating the stream at
	display_stream_create().

	With the removal of Id parameter, we are using a gpointer for
	display_stream struct to comply with GDestroyNotify type and use this,
	for instance in g_clear_pointer() without warnings.

	Benefits of this patch:
	* We can drop a helper function in a follow up patch;
	* Function is now a GDestroyNotify type;

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-04-04  Victor Toso  <me@victortoso.com>

	spice-widget: fix leak of boxed type cursor-shape
	No valgrind on this one but a leak similar to previous patch.
	This one was introduced in e691954be459087

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	spice-widget: fix leak of boxed type cursor-shape
	Detected while testing valgrind on migration.

	> malloc (vg_replace_malloc.c:299)
	> g_malloc (in /usr/lib/libglib-2.0.so.0.5400.3)
	> spice_cursor_shape_copy (channel-cursor.c:99)
	> ??? (in /usr/lib/libgobject-2.0.so.0.5400.3)
	> g_object_get_valist (in /usr/lib/libgobject-2.0.so.0.5400.3)
	> g_object_get (in /usr/lib/libgobject-2.0.so.0.5400.3)
	> cursor_set (spice-widget.c:2653)
	> g_closure_invoke (in /usr/lib/libgobject-2.0.so.0.5400.3)
	> ??? (in /usr/lib/libgobject-2.0.so.0.5400.3)
	> g_signal_emit_valist (in /usr/lib/libgobject-2.0.so.0.5400.3)
	> g_signal_emit (in /usr/lib/libgobject-2.0.so.0.5400.3)
	> ??? (in /usr/lib/libgobject-2.0.so.0.5400.3)

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-03-16  Christophe Fergeau  <cfergeau@redhat.com>

	build: Remove SPICE_GTK_LOCALEDIR
	This became obsolete after 93b213e 'spicy-*: Remove translation support'

2018-03-15  Olivier Fourdan  <ofourdan@redhat.com>

	Use scancode instead of keycode names
	When running on Xwayland, the keycode mapping property is not available,
	which causes unknown keycode mapping errors and the keyboard doesn't
	work.

	Check for a known scancode (“XK_Page_Up”) which differs to distinguish
	between “xfree86” and “evdev” when the there is no keycode name.

	Reviewed-by: Daniel P. Berrangé <berrange@redhat.com>
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2018-03-02  Marc-André Lureau  <marcandre.lureau@redhat.com>

	tests: add spice+tls:// tests
	They couldn't not be introduced before, because the test needs both
	parsing and generation.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	uri: generate spice://host:port or spice+tls://host:port
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	uri: learn to parse spice+tls:// form
	spice:// has a weird scheme encoding, where it can accept both plain
	and tls ports with URI query parameters. However, it's not very
	convenient nor very common to use (who really want to mix plain & tls
	channels?).

	Instead, let's introduce the more readable form spice+tls://host:port
	This form will not accept 'port' or 'tls-port' query string parameter.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-03-02  Victor Toso  <me@victortoso.com>

	Don't exceed one statement per line
	Cosmetic change. One break was dropped on _default:_ label of switch

	Acked-by: Marc-André Lureau <marcandre.lureau@redhat.com>

2018-03-01  Victor Toso  <me@victortoso.com>

	channel-usbredir: avoid calling memcpy() will NULL src
	Code built with address sanitizer has runtime error:
	 > channel-usbredir.c:642:5: runtime error: null pointer passed
	 > as argument 2, which is declared to never be null

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-02-28  Victor Toso  <me@victortoso.com>

	spice-widget: Avoid promoting signed 1 on shift
	Address sanitizer runtime error:
	 > spice-widget.c:1433:12: runtime error: left shift of
	 > 1 by 31 places cannot be represented in type 'int'

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-02-16  Marc-AndrÃ© Lureau  <marcandre.lureau@redhat.com>

	session: warn with the original URI
	Before:
	(lt-spicy:18372): GSpice-WARNING **: 10:57:21.246: Double set of 'port' in URI 'spice://foo'

	After:
	(lt-spicy:18654): GSpice-WARNING **: 10:57:21.246: Double set of 'port' in URI 'spice://foo:23?port=24'

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-02-13  Marc-André Lureau  <marcandre.lureau@redhat.com>

	tests: add spice+unix:// URI checks
	For some reason, the URIs test didn't include spice+unix:// checks,
	probably because they came about the same time.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-01-31  Frediano Ziglio  <fziglio@redhat.com>

	build-sys: update spice-common submodule
	Import some fixes.

	Frediano Ziglio (2):
	      canvas: Fix some semi transparent drawing
	      canvas: Use SPICE_UNALIGNED_CAST to avoid -Wcast-align warnings

	Acked-by: Victor Toso <victortoso@redhat.com>

2018-01-30  Javier Celaya  <javier.celaya@flexvdi.com>

	Fix setting appsrc properties in i686 arch
	The "max-bytes" property of the appsrc GStreamer element expects a
	64-bit value. Calling:
	g_object_set(source, "max-bytes", 0, NULL);
	in a 32-bit architecture ends up with a wrong value, it must be cast to
	a gint64:
	g_object_set(source, "max-bytes", G_GINT64_CONSTANT(0), NULL);

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-01-30  Frediano Ziglio  <fziglio@redhat.com>

	channel-display: Removed only assigned dc field from _SpiceDisplayChannelPrivate
	This was used by GDI canvas rendering which has been removed from
	spice-common.

	Acked-by: Christophe de Dinechin <dinechin@redhat.com>

2018-01-24  Frediano Ziglio  <fziglio@redhat.com>

	GDI canvas cleanup
	GDI canvas support was removed from spice-common as not even
	compiling for a long time.
	This requires some changed to spice-gtk too.

	Frediano Ziglio (14):
	      canvas: Simplify code using spice_memdup
	      canvas: Remove possible leak on LZ decompression failure
	      lz: Avoid temporary variable
	      lz: Simplify code
	      lz: Remove unused encode_level and only assigned io_start
	      canvas: Move PixmanData to C file
	      canvas: Remove mutex field from PixmanData
	      canvas: Remove Windows bitmap allocation
	      canvas: Remove unused dc parameter from surface_create
	      canvas: Remove dc parameter from SwCanvas::put_image
	      canvas: Remove dc fields from CanvasBase and LzDecodeUsrData
	      canvas: Unify __surface_create_stride and surface_create_stride
	      canvas: Remove unused include header
	      canvas: Prevent some error compiling spice-gtk

	Pavel Grunt (1):
	      Remove GDI canvas

	Acked-by: Snir Sheriber <ssheribe@redhat.com>

2018-01-23  Paweł Pękala  <pawelbsd@gmail.com>

	Fix build with LibreSSL
	Some FreeBSD configurations can use LibreSSL instead of OpenSSL.
	The two libraries are really similar but need some minimal adjustment.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2018-01-11  Frediano Ziglio  <fziglio@redhat.com>

	build: Update spice-common
	This includes a LZ fix for paletted images.

	Frediano Ziglio (10):
	      quic: avoid crash on specific images
	      Make the compiler work out better way to write unaligned memory
	      test-marshallers: Use unaligned structure
	      test-marshallers: Test demarshalling
	      ring: Remove __ring_remove function
	      ring: Remove short living temporary variable
	      canvas_base: Allow to specify constant operations
	      proto: Add some documentation to stream_report message
	      protocol: Allow to specify a surface will be streamed
	      canvas-base: Fix width computation for palette images

	Acked-by: Marc-André Lureau <marcandre.lureau@redhat.com>

2018-01-08  Ting-Wei Lan  <lantw@src.gnome.org>

	build-sys: Workaround missing openssl.pc for FreeBSD
	FreeBSD has OpenSSL installed in base, but .pc files are not available.
	We can still successfully build spice-gtk by setting SSL_CFLAGS and
	SSL_LIBS variables manually, but openssl will still be recorded to
	Requires.private field of spice-client-glib-2.0.pc, causing problems for
	applications using spice-gtk. To workaround the issue, we do the check
	again without using SSL_CFLAGS and SSL_LIBS variables and put SSL_LIBS
	into Libs.private field when openssl.pc cannot be found.

	https://bugs.freedesktop.org/show_bug.cgi?id=104524

	build-sys: Enable ACL support on FreeBSD
	sys/acl.h works on both FreeBSD and Linux, so we should use it instead
	of acl/libacl.h, which only works on Linux.

	FreeBSD puts ACL functions in libc, so we should check whether ACL
	functions are available in libc before doing the check with -lacl.

	https://bugs.freedesktop.org/show_bug.cgi?id=104525

2018-01-04  Christophe Fergeau  <cfergeau@redhat.com>

	Implement GObject::constructed rather than ::constructor
	A few classes are implementing GObject::constructor, which is more
	cumbersome to use than ::constructed. Other classes use ::constructed
	rather than ::constructor. This commit removes the last uses of
	::constructor.

	Acked-by: Marc-André Lureau <marcandre.lureau@redhat.com>

	session: Remove unused spice_gtk_session_get_read_only prototype
	There is no such function implemented anywhere in the codebase.
	This was mistakenly added in 222e25a029.

	Acked-by: Marc-André Lureau <marcandre.lureau@redhat.com>

2017-12-20  Victor Toso  <me@victortoso.com>

	Fix clang's double-promotion warning
	Casting to gdouble instead to float to avoid the warning and perhaps
	increase the precision.

	spice-widget-egl.c:573:28: error: implicit conversion increases
	floating-point precision: 'float' to 'gdouble' (aka 'double')
	    tx = ((float)d->area.x / (float)d->egl.scanout.width);
	       ~  ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	spice-widget-egl.c:574:28: error: implicit conversion increases
	floating-point precision: 'float' to 'gdouble' (aka 'double')
	    ty = ((float)d->area.y / (float)d->egl.scanout.height);
	       ~  ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	spice-widget-egl.c:575:32: error: implicit conversion increases
	floating-point precision: 'float' to 'gdouble' (aka 'double')
	    tw = ((float)d->area.width / (float)d->egl.scanout.width);
	       ~  ~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	spice-widget-egl.c:576:33: error: implicit conversion increases
	floating-point precision: 'float' to 'gdouble' (aka 'double')
	    th = ((float)d->area.height / (float)d->egl.scanout.height);
	       ~  ~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Improve debug log for preferred video codec message
	The gst_opts[] array was moved to the -priv.h header
	inc96af50e2dd16b02b189e8 - Let's use it to improve debug messages.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2017-12-12  Jonathon Jongsma  <jjongsma@redhat.com>

	Inputs: fix documentation for spice_inputs_channel_motion()
	This function is used in server mode, and
	spice_inputs_channel_position() is used in client mode.

	Acked-by: Marc-André Lureau <marcandre.lureau@redhat.com>
	Acked-by: Victor Toso <victortoso@redhat.com>

2017-12-11  Jonathon Jongsma  <jjongsma@redhat.com>

	MainChannel: Fix incorrect deprecations
	Both spice_main_set_display() and spice_main_set_display_enabled() were
	deprecated in favor of the same functions with the spice_main_channel_
	prefix. However, these new functions were never introduced. Since these
	functions merely call spice_main_channel_update_display() with a
	constant TRUE argument for the last parameter, this is probably a good
	time to simply drop the _set_display* functions in favor of the
	nearly-identical _update_display* functions (which have one additional
	parameter which determines whether to send the update to the guest).

	Acked-by: Victor Toso <victortoso@redhat.com>

2017-10-20  Christophe de Dinechin  <dinechin@redhat.com>

	spicy: Add call of gst_deinit at program exit
	This is useful for some instrumentation, e.g. the leaks tracer,
	that perform some of their operations within gst_deinit.

	Without this patch, if you run spicy with
		GST_DEBUG="GST_TRACER:7" GST_TRACERS="leaks" spicy ...
	the leak tracer does not show any output, because it runs in gst_deinit.

	Reviewed-by: Marc-André Lureau <marcandre.lureau@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2017-10-03  Marie Stephanie Alesna  <istephielicious@gmail.com>

	Add pyparsing requirement to README and autogen.sh
	Also use --enable-python-checks in autogen.sh to check python2/3-pyparsing
	requirement for rebuilds from GIT.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-09-25  Matthew Francis  <mjay.francis@gmail.com>

	MainChannel: Fix introspection method bindings
	Reviewed-by: Marc-André Lureau <marcandre.lureau@redhat.com>
	Message-Id: <1505831641-28134-6-git-send-email-mjay.francis@gmail.com>

	InputsChannel: Fix introspection method bindings
	Reviewed-by: Marc-André Lureau <marcandre.lureau@redhat.com>
	Message-Id: <1505831641-28134-5-git-send-email-mjay.francis@gmail.com>

	RecordChannel: Fix introspection method bindings
	Reviewed-by: Marc-André Lureau <marcandre.lureau@redhat.com>
	Message-Id: <1505831641-28134-4-git-send-email-mjay.francis@gmail.com>

	DisplayChannel: Fix introspection method bindings
	Reviewed-by: Marc-André Lureau <marcandre.lureau@redhat.com>
	Message-Id: <1505831641-28134-3-git-send-email-mjay.francis@gmail.com>

	PortChannel: Fix introspection method bindings
	Reviewed-by: Marc-André Lureau <marcandre.lureau@redhat.com>
	Message-Id: <1505831641-28134-2-git-send-email-mjay.francis@gmail.com>

2017-09-04  Marc-André Lureau  <marcandre.lureau@redhat.com>

	webdav: remove the client if input stream is closed
	Instead of printing a warning when trying to read from a closed
	stream. It can happen that libsoup closes the pipe output stream while
	the input stream had no pending operation, in which case the close is
	successful and we shouldn't try to read from the stream anymore.

	Acked-by: Victor Toso <victortoso@redhat.com>

	tests/pipe: add write close/cancel tests
	And a few cleanups.

	Acked-by: Victor Toso <victortoso@redhat.com>

	giopipe: output wake up on peer close
	Similar to input is_readable(), return writable after a close, so an
	error is reported to the async write.

	Acked-by: Victor Toso <victortoso@redhat.com>

	giopipe: input return 0 and no error when peer is already closed
	The peer stream may be closed, but may have failed to close self,
	because it has pending operations. In this case indicate EOS on read
	rather than returning an error. self will be close eventually on
	dispose.

	Acked-by: Victor Toso <victortoso@redhat.com>

	test-pipe: /pipe/readcancel is supposed to test cancel
	Not to reproduce /pipe/readclose..

	Acked-by: Victor Toso <victortoso@redhat.com>

2017-08-23  Frediano Ziglio  <fziglio@redhat.com>

	build: Update spice-common
	This include some Quic changes, particularly a compile fix
	if no optimizations (-O0) are used.

	Christophe Fergeau (8):
	      log: Define G_LOG_DOMAIN as early as possible
	      canvas: Don't try to unref NULL pixman_image_t
	      quic: Use DEFevol constant rather than evol variable
	      quic: Use DEFwminext constant rather than wminext variable
	      quic: Use DEFwmimax constant rather than wmimax variable
	      quic: Use SPICE_VERIFY for static check
	      quic: Fix "corelate" typo
	      quic: Use i == 0 rather than !i

	Frediano Ziglio (13):
	      canvas-base: Do not attempt useless cast on stride adjustment
	      quic: constantify some variable
	      log: remove spice_static_assert macro
	      quic: Fix typo in function names
	      log: Forbid the usage of obsolete SPICE_LOG_DOMAIN
	      log: Force format in log macro to be a string
	      quic: fix typo corelate -> correlate
	      quic: fix typo golomb_deoding -> golomb_decoding
	      quic: remove only assigned num_channels field
	      quic: remove only assigned CommonState::encoder
	      quic: remove Channel::encoder
	      quic: use 32 bit for bppmask
	      quic: turn back some commented out checks as compile time

	Acked-by: Victor Toso <victortoso@redhat.com>

2017-08-17  Marc-André Lureau  <marcandre.lureau@redhat.com>

	channel: don't call memcpy with NULL dest
	If ncaps == 0, the array will be NULL after set_size().

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	channel: pass the size to store_caps
	Move g_array_set_size() there.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2017-08-16  Marc-André Lureau  <marcandre.lureau@redhat.com>

	channel: return "unknown" in spice_channel_type_to_string()
	This fixes the following gcc warning:

	spice-channel.c: In function ‘spice_channel_constructed’:
	spice-channel.c:144:41: error: ‘%s’ directive output may be truncated writing likely 20 or more bytes into a region of size 16 [-Werror=format-truncation=]
	     snprintf(c->name, sizeof(c->name), "%s-%d:%d",
	                                         ^~
	spice-channel.c:144:40: note: assuming directive output of 20 bytes
	     snprintf(c->name, sizeof(c->name), "%s-%d:%d",

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2017-08-10  Marc-André Lureau  <marcandre.lureau@redhat.com>

	Prefer g_new() over spice_new()
	spice_new() should probably be replaced by g_new() in all spice code
	that depend on glib.

	Acked-by: Victor Toso <victortoso@redhat.com>

	Use g_free() appropriately
	g_free() should be used in pair with g_malloc/new().

	There is only free() calls remaining for usbredir rules now.

	Acked-by: Victor Toso <victortoso@redhat.com>

	Remove wocky HTTP proxy
	That HTTP proxy code has been added to glib 2.43.92.

	Acked-by: Victor Toso <victortoso@redhat.com>

2017-08-10  Pavel Grunt  <pavelgrunt@gmail.com>

	widget: Ignore deprecation warnings for gdk_event_get_scancode
	It is available since Gtk+ 3.22
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2017-08-10  Marc-André Lureau  <marcandre.lureau@redhat.com>

	Remove vapi/spice-client-gtk-2.0.deps
	Left-over from v0.31-6-g0917002

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-08-01  Victor Toso  <me@victortoso.com>

	build-sys: bump glib requirement 2.36 -> 2.46
	At the moment:
	- Fedora 26 has 2.52
	- Fedora 25 has 2.50
	- Fedora 24 has 2.48
	- CentOS 7 has 2.46
	- Debian 9 has 2.50

	Acked-by: Marc-André Lureau <marcandre.lureau@redhat.com>

2017-08-01  Marc-André Lureau  <marcandre.lureau@redhat.com>

	build-sys: remove the spice-controller library
	The spice-controller was a small library to let NPAPI browser plugins
	communicate with the spice client. Due to usage of vala, the library
	could not promise ABI stability, and was also considerer a pretty
	poor implementation.

	Furthermore, major browser vendors began to phase out NPAPI support in
	2013, and some would like to see it gone by the end of this
	year (realistically, it may not happen though).

	As an alternative, remote-viewer (the first class Spice client)
	learned to connect with a file of mime type application/x-virt-viewer,
	as early as February 2013 with v0.5.5. I also proposed a DBus
	controller, and a simpler way to pass connection details via stdin.

	Acked-by: Victor Toso <victortoso@redhat.com>

2017-07-31  Victor Toso  <me@victortoso.com>

	display-gst: Improve h264 elements filtering
	This patch fixes the avdec_h264 element not being present on
	gstvideo_has_codec() which get all decoder elements from GstRegistry
	and filter them on our GstCaps in order to get the ones for given
	codec.

	The issue is around the filtering. The current GstCaps for h264 is not
	consider a subset of avdec_h264's capabilities and that will filter
	this element out of the list.

	The proposed solution for that is to set `subsetonly` parameter from
	gst_element_factory_list_filter() to false.

	While at it, the cap "stream-format=byte-stream" is less useful now
	because it isn't needed to play the stream - see 6fe88871240c53b8

	In my system, our debug shows:
	.. gstvideo_debug_available_decoders: From 228 video decoder elements,
	- 4 can handle caps   image/jpeg: jpegdec, nvdec, avdec_mjpeg, vaapijpegdec
	- 3 can handle caps  video/x-vp8: vaapidecodebin, vp8dec, avdec_vp8
	- 4 can handle caps video/x-h264: vaapidecodebin, avdec_h264, nvdec, vaapih264dec
	- 3 can handle caps  video/x-vp9: vaapidecodebin, vp9dec, avdec_vp9

	IRC log on #gstreamer around this issue:

	toso  Hi, I'm wondering if I'm getting the documentation wrong about
	      the meaning of gst_caps_is_subset()... isn't it "video/x-h264,
	      stream-format=3D(string)byte-stream" a subset of "video/x-h264,
	      alignment=3D(string)au, stream-format=3D(string){ avc, byte-stream }"=
	 ?
	__tim toso, no, because it's missing the alignment field
	__tim which means alignment could be anything
	__tim which means it  might not be au
	toso  that's a bit confusing, no?
	__tim it's not a strict subset :)
	toso  I really thought it would be a subset in this case.. meaning, we
	      don't care about the aligment on _is_subset
	__tim you can do can_intersect() if you don't care
	slomo it's an actual subset if you define the abscence of a field as
	      "the field can have every possible value"
	toso  __tim: problem is that it isn't a subset on calling
	      gst_element_factory_list_filter()
	toso  slomo: yeah, that was my assumption on the meaning of subset
	toso  so, just to confirm, this is the expected behavior and not a
	      bug, right? :)
	slomo yes
	__tim slomo, foo, bar=3D{1,2} is not a subset of  foo, bar=3D1  is it?
	slomo but if something does not work as expect for you, that might be
	      a bug :)
	slomo __tim: correct
	slomo __tim: but foo, bar=3D1 is a subset of foo, bar=3D{1,2}
	__tim yes
	slomo __tim: and foo, bar=3D1 is a subset of foo
	slomo __tim: and foo is not a subset of foo, bar=3D1
	__tim yes. yes.
	__tim andn the case we're talking about is basically  "foo" + "foo,
	      bar=3D1"
	slomo yes, the first is a superset of the second there
	slomo toso: if something does not work for you that might also be a
	      bug of course ;)
	__tim ok, so not a subset.
	__tim then we're on the same page I think :)
	toso  slomo: right, my point was that I would like to list the h264
	      decoders that are available and I was using `video/x-h264,
	      stream-format=3Dbyte-stream` as input for
	      gst_element_factory_list_filter() .. and avdec_h264 is the one
	      not showing because it needs the aligment
	toso  but as I got it wrong, I'll rethink on how to fix it
	slomo toso: pass FALSE as the last argument
	slomo and you can just use 'video/x-h264'
	slomo and with gst_element_factory_list_get_elements() you can make
	      sure to get only a list of video decoders to begin with
	toso  just gst_element_factory_list_get_elements() gives me like 220
	      elements
	toso  using _type_decoder | _type_media_video | _type_media_image
	slomo is that a problem?
	toso  trying to reduce that to actual decoding elements
	slomo they should be all actual video decoders
	slomo and with gst_element_factory_list_filter(list, 'video/x-h264',
	      GST_PAD_SINK, FALSE) you can then filter out all non-h264 ones
	      dv_	is it generally ok if an audio decoder messes with the
	      PTS/durations?
	toso  right, let me try that then
	toso  slomo, __tim many thanks :)

	Acked-by: Marc-André Lureau <marcandre.lureau@redhat.com>

2017-07-26  leaboy  <wlbleaboy@126.com>

	usbredir: fix deadlock on error
	The current code deadlocks when a USB error occurs, releasing the
	channel lock before the idle is called fixes this problem.

	More specifically when an error occurs, we queue a call to device_error
	in an idle, and switch to the main context. The device_error() calls
	spice_usbredir_channel_disconnect_device() which needs the channel to be
	unlocked as it calls spice_usbredir_channel_lock().

	Examples:
	- Redirect USB Storage device to the guest and copy some big file. While
	  copy is ongoing, unplug the USB Storage from the client machine;
	- Unplug the usb device from the client machine while the USB Storage
	  device is being identified in the guest.
	- With the auto-redirection option enabled, plug and unplug the USB
	  Storage Device frequently.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1353528
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-07-26  Frediano Ziglio  <fziglio@redhat.com>

	gstreamer: Take into account stride information
	Using hardware encoders/decoders is possible that the output
	stride of the image cannot be computed with a fixed formula
	(width * 4). GStreamer in this case should set GstVideoMeta
	information with the correct stride value.
	Consider this value if present.
	This fix a problem using NvEnc encoder and Intel decoder.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-07-25  Pavel Grunt  <pgrunt@redhat.com>

	Fix build without egl
	spice_display_widget_gl_scanout is defined only when building with egl
	 ./.libs/libspice-client-gtk-3.0.so: undefined reference to `spice_display_widget_gl_scanout'

	Fixes 977db3bb3da94def4c0e1d4087037303d250e158

2017-07-21  Pavel Grunt  <pgrunt@redhat.com>

	Add flatpak builder manifest file for spicy
	To give an example for creating flatpaks depending on spice-gtk

	How to build and run the flatpak:
	spicy uses GNOME SDK runtime, version 3.24. The runtime provides tools
	and libraries necessary to build the flatpak
	 $ flatpak remote-add --if-not-exists gnome https://sdk.gnome.org/gnome.flatpakrepo
	 $ flatpak install gnome org.gnome.Sdk//3.24

	To build and run the flatpak of spicy:
	 $ flatpak-builder spicy data/org.spicespace.spicy.json
	 $ flatpak build-export repo spicy
	 $ flatpak --user remote-add --no-gpg-verify --if-not-exists spice-repo repo
	 $ flatpak --user install spice-repo org.spicespace.spicy
	 $ flatpak run org.spicespace.spicy
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Revert "Ignore modifiers messages if no modifiers changed"
	This reverts commit 73cd553fb0fbd213b64d72f8b4289ed8a17fc6c0.
	 "This avoid keep sending modifiers changes if guest is not
	  synchronising the changes.

	  I consider this as an improving as this avoids client to try again
	  and again to force synchronisation however this does not prevent
	  every unwanted keystroke insertion which possibly can be a real
	  problem on some configurations.

	  For instance if guest do not handle caps lock as the client do
	  if client uses another modifiers (as num lock) this can force
	  inserting virtual caps keypress."

	It may be an optimization, but it complicates turning off
	the capslock once it is enabled. The bug is reproducible
	in rhel7/fedora guests.

	https://bugs.freedesktop.org/show_bug.cgi?id=101344
	Acked-by: Victor Toso <victortoso@redhat.com>

2017-07-21  Uri Lublin  <uril@redhat.com>

	gst: new_sample: remove redundant sample? condition
	Move the declaration and assignment of 'buffer' into
	the if (sample) block, where sample is not NULL.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-07-18  Pavel Grunt  <pgrunt@redhat.com>

	gst-audio: Do not update mmtime without real audio channel
	The fake channel has been introduced to get the audio volume by starting
	the gstreamer's audio pipeline and querring its volume info (see commit
	aa8d044417bbf60685f59163b874ecb4f157c3c9).

	Hovewer starting the pipeline updates the mmtime as a side effect. This
	may cause a (big) delay in displaying a video stream.

	Because the fake channel is only needed to get the volume info, make
	sure to not update the mm-time with it.

	Reported-by: Christophe de Dinechin <dinechin@redhat.com>
	Acked-by: Christophe de Dinechin <dinechin@redhat.com>

2017-07-18  Christophe de Dinechin  <dinechin@redhat.com>

	spice-gtk: Use time comparisons that still work after wraparound
	The mm timer is a millisecond timer that wraps around after ~49 days.
	All comparisons that look like a<b will fail once this happens.
	Instead, use signed ((int)(a-b)<0), which may fail if there is more than
	25 days between a and b (should not be happening under normal conditions),
	but is robust to the timer wrapping around.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-07-17  Christophe Fergeau  <cfergeau@redhat.com>

	cursor: Add sanity checks for hotspot x/y values
	The cursor hotspot values have to be inside the cursor bounding box,
	otherwise on X11 this may cause a crash of the application using
	spice-gtk.

	This is the client-side part of
	https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=864998

	build-sys: Lower gettext requirement
	spice-gtk currently requires gettext 0.19 which is a fairly recent
	release (not available in el7.3 and older, nor in ubuntu 14.04 LTS).
	They both have a gettext newer than 0.18.2, so we can require that.

	Requiring 0.18 or 0.18.1 is throwing automake errors because of our use
	of -Werror, so we side-step this by requiring 0.18.2.

2017-07-17  Pavel Grunt  <pgrunt@redhat.com>

	Do not update .po files with ./autogen.sh && make
	It is enough to update them just before the release (`make dist`)

	Reported-by: Victor Toso <victortoso@redhat.com>

2017-07-17  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: Update keycodemapdb submodule
	This brings in 2 bug fixes, one of these is important on RHEL7 to
	workaround an argparser bug with the python2 version it ships.

2017-07-14  Pavel Grunt  <pgrunt@redhat.com>

	gst: Fix build for GStreamer < 1.5.1
	GST_DEBUG_GRAPH_SHOW_FULL_PARAMS is available since that

2017-07-13  Marc-André Lureau  <marcandre.lureau@redhat.com>

	display-gst: fix format error
	../../src/channel-display-gst.c: In function 'handle_pipeline_message':
	../../src/channel-display-gst.c:289:75: error: format '%ld' expects argument of type 'long int', but argument 2 has type 'gint64 {aka long long int}' [-Werror=format=]
	         gchar *filename = g_strdup_printf("spice-gtk-gst-pipeline-debug-%ld-%s",
	                                                                         ~~^
	                                                                         %I64d
	                                           get_stream_id_by_stream(decoder->base.stream->channel,
	                                           ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	                                                                   decoder->base.stream),
	                                                                   ~~~~~~~~~~~~~~~~~~~~~

	Acked-by: Victor Toso <victortoso@redhat.com>

2017-07-13  Victor Toso  <me@victortoso.com>

	file-xfer: Inform client of errors on init of xfer
	With SpiceFileTransferTask we suggest that Spice clients watch
	(signal) SpiceMainChannel::new-file-transfer so they can follow the
	transfer's progress till the moment it is finished.

	The signal SpiceFileTransferTask::finished informs if an error happens
	to the application.

	This patch solves the problem of SpiceFileTransferTask::finished not
	being emitted when the agent is not connected nor when file-transfer
	is disabled in the host.

	We should first emit SpiceMainChannel::new-file-transfer followed up
	by SpiceFileTransferTask::finished, which is done by the function
	spice_file_transfer_task_completed().

	As channel-main chains up the "finish" signal by removing the
	SpiceFileTransferTask from its GHashTable, we have to change from
	GHashTableIter to a simple GList of keys.

	Related: https://bugzilla.redhat.com/show_bug.cgi?id=1373830
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-07-13  Yuri Benditovich  <yuri.benditovich@daynix.com>

	win-usb-dev: fix device arrival event logic
	https://bugzilla.redhat.com/show_bug.cgi?id=1425961
	If attached new device when one device with the same vid
	and pid already present, the notification is ignored and
	attached device is not redirected (if auto share set) and
	not displayed in USB devices widget.

	This commit reverts older commit f9631cd6f8, which was
	intended to solve problem when bus:addr is sometimes changed when
	using WinUSB. The same commit creates the limitation for automatic
	redirection of second device with the same pid:vid.
	Now the preferred backend for Spice-GTK on Windows is UsbDk.
	In case users of newer WinUSB will still need backward compatible
	behavior, consider backend-aware comparison procedure.

	A device is now identified again by its bus.addr instead of vid:pid.

	Message-Id: <1499232106-16448-1-git-send-email-yuri.benditovich@daynix.com>
	Acked-by: Uri Lublin <uril@redhat.com>
	[ Marc-André - Added commit comment from Uri's review. ]

2017-07-12  Marc-André Lureau  <marcandre.lureau@redhat.com>

	Release notes for v0.34

	build-sys: update po files
	As a result of make update-po (needed for make clean distcheck).

	build-sys: modernize gettext
	intltool and glib-gettext are somehow related, and upstream gettext
	should now support everything needed for GNOME projects.

	intltool support never really worked, and we removed some of its
	commented usage a while ago when dropping spicy desktop/mime.

	build-sys: use git.mk GITIGNORE_*

2017-07-11  Victor Toso  <me@victortoso.com>

	display-gst: Debug video pipeline on stream-start message
	On GST_MESSAGE_STREAM_START our stream is about to start and it seems
	a good moment to debug GStreamer pipeline if requested.

	That we can do with GST_DEBUG_BIN_TO_DOT_FILE() which iterates
	recursively in the whole pipeline and generates a dot file with all
	the information, the filename is:
	  spice-gtk-gst-pipeline-debug-$stream_id-$video_codec.dot

	One can generate png image out of this dot file with the command:
	  dot -Tpng -oimage.png spice-gtk-gst-pipeline-debug.dot

	Note that GST_DEBUG_BIN_TO_DOT_FILE() will only work if Gstreamer was
	configured with --gst-enable-gst-debug and the environment variable
	GST_DEBUG_DUMP_DOT_DIR was properly set.

	Full example:

	1) GST_DEBUG_DUMP_DOT_DIR=/tmp remote-viewer ...
	2) dot -Tpng -oimage.png spice-gtk-gst-pipeline-debug.dot

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	channel-display: keep one struct array for video-codecs data
	On channel-display.c, for each SpiceVideoCodecType we need:
	 - Its enum type;
	 - The associated capability;
	 - A name;

	On channel-display-gst.c, for each SpiceVideoCodecType we need:
	 - Associated decoding elements for the pipeline;
	 - Associated GstCaps, also for the video pipeline;

	Follow up patch will need the associated name for given
	SpiceVideoCodecType.

	Moving gst_opts[] array to channel-display-priv.h to be reused. This
	should also make slightly simpler when supporting a new video codec in
	the future.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-07-11  Pavel Grunt  <pgrunt@redhat.com>

	usb-manager: Fix docstring annotation
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-07-10  Victor Toso  <me@victortoso.com>

	display-gst: Use Playbin for GStreamer 1.9.0 onwards
	The Playbin can provide the full pipeline which reduces the
	overall maintenance in the code as we don't need to track which
	decoder can work with our stream type.

	We need to maintain the GstCaps per SPICE_VIDEO_CODEC_TYPE in order to
	tell Playbin the type of data we expect. This much should be covered
	by spice-protocol and very likely we will need to extend it in the
	future to allow more settings that might not possible to verify at
	runtime.

	This patch keeps previous code for compatibility reasons.

	Note that we have to wait Playbin to emit "source-setup" in order to
	configure GstAppSrc with the capabilities of input stream. If in the
	unlikely event of frames arriving while GstAppSrc is not setup, we
	will drop those frames.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	display-gst: check GstRegistry for decoding elements
	With this patch, we can find all the elements in the registry that are
	video decoders which can handle the predefined GstCaps.

	Main benefits are:
	- We don't rely on a predefined list of GstElements. We don't need to
	  update them;
	- debugging: It does help to know what the registry has at runtime;

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	display-gst: move "caps=" from struct to pipeline
	This way we have a map of the necessary GstCaps to a given
	SPICE_VIDEO_CODEC_TYPE.

	This patch is also a preparatory patch to:

	- Identify which GstElements in GstRegistry can handle this GstCaps

	- Use Playbin as wrapper to all elements beside GstAppSrc and
	  GstAppSink. In this case, we should rely on GstCaps to reduce
	  typefind errors as we should know what kind of data is expected

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	display-gst: include capabilities for h264
	As the comment states, incomplete GstCaps for h264 could trigger
	errors in h264parse element, such as:

	  gst_h264_parse_set_caps: video/x-h264 caps without
	  codec_data or stream-format

	This would make h264parse to ignore the capabilities that were set.

	As spice-server is encoding as byte-stream it should be fine to set
	this value here too.

	Any other errors to h264 format should either be reported to
	GStreamer or fixed by improving the spice-protocol.

	The follow up patch will identify elements in GstRegistry based on
	GstCaps so this is a necessary change to have.

	This is also a preparatory patch to use Playbin element to create the
	pipeline. Without this, Playbin or typefind will fail to recognize the
	stream as H264.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	display-gst: remove SPICE_GSTVIDEO_AUTO check
	The intention behind SPICE_GSTVIDEO_AUTO environment variable was to
	easily test the decoding elements given by GStreamer while using the
	decodebin element in our pipeline.

	The usage of decodebin was disabled by default as it could trigger
	different issues such as the usage of unstable vaapi elements [0].

	[0] See: https://bugs.freedesktop.org/show_bug.cgi?id=90884

	A follow-up patch will use playbin to create the pipeline. Playbin is
	very similar to decodebin but it'll provide the whole pipeline which
	should bring less maintenance to spice-gtk.

	Further notes:
	- Vaapi elements are more stable now and it should not be a problem to
	  use it.
	- At this moment, there is no automatic enforcement from spice-gtk to
	  make usage of any video-codecs besides mjpeg. Application would need
	  to send preferred-video-codec-type message to trigger video decoding
	  with GStreamer.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	display-gst: check codec type before creating decoder
	Inserting this check in channel-display-gst.c as the GStreamer decoder
	is the only one handling all the different video formats supported by
	spice-protocol.

	If a unsupported/bad codec type value was sent, spice-gtk will fail to
	create the decoder and any messages related to this stream-id will be
	ignored.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-06-30  Pavel Grunt  <pgrunt@redhat.com>

	spice-channel: Factor out code for storing caps
	Acked-by: Victor Toso <victortoso@redhat.com>

2017-06-29  Pavel Grunt  <pgrunt@redhat.com>

	spice-channel: Store the caps correctly
	The commit babe5630d5d3242b1d186cccdd5b4d51debe78e9 forgot to update
	position of the caps pointer making remote caps to not be stored.

	That cause strange behavior in remote-viewer - it always opened window
	for each remote display.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-06-26  Pavel Grunt  <pgrunt@redhat.com>

	usb-device-widget: Fix parent class type
	The widget is defined as GTK_TYPE_BOX, use GtkBox instead of GtkVBox.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2017-06-22  Jakub Janků  <janku.jakub.jj@gmail.com>

	main: Handle file-xfer detailed errors
	Log appropriate error messages when we receive
	VD_AGENT_FILE_XFER_STATUS_SESSION_LOCKED,
	VD_AGENT_FILE_XFER_STATUS_VDAGENT_NOT_CONNECTED,
	VD_AGENT_FILE_XFER_STATUS_DISABLED.
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-06-20  Christophe de Dinechin  <dinechin@redhat.com>

	Remove warning about unused variable when building on macOS
	On macOS, neither of the two cases implemented in set_mouse_accel applies.
	We get the following eror message:

	  CC       spice-widget.lo
	spice-widget.c:944:26: error: unused variable 'd' [-Werror,-Wunused-variable]
	    SpiceDisplayPrivate *d = display->priv;

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Avoid clang warnings on casts with stricter alignment requirements
	For example, something like this:
	    uint8_t  *p8;
	    uint32_t *p32 = (uint32_t *) p8;

	generates a warning like this:
	  spice-channel.c:1350:10: error: cast from 'uint8_t *' (aka 'unsigned char *') to
	      'uint32_t *' (aka 'unsigned int *') increases required alignment from 1 to
	      4 [-Werror,-Wcast-align]

	The warning indicates that we end up with a pointer to data that
	should be 4-byte aligned, but its value may be misaligned. On x86,
	this does not make much of a difference, except a relatively minor
	performance penalty. However, on platforms such as older ARM, misaligned
	accesses are emulated by the kernel, and support for them is optional.
	So we may end up with a fault.

	The intent of the fix here is to make it easy to identify and rework
	places where actual mis-alignment occurs. Wherever casts raise the warning,
	they are replaced with a macro:

	- SPICE_ALIGNED_CAST(type, value) casts value to type, and indicates that
	  we believe the resulting pointer is aligned. If it is not, a runtime
	  warning will be issued if you configure with --enable-alignment-warnings.

	- SPICE_UNALIGNED_CAST(type, value) casts value to type, and indicates that
	  we believe the resulting pointer is not always aligned. A debug message
	  is issued if you configure with --enable-alignment-warnings.

	Any code using SPICE_UNALIGNED_CAST may need to be revisited in order
	to improve performance, e.g. by using memcpy. A few easy fixes have been
	made in his patch.

	Add check for macOS and macOS specific define to allow ucontext

	Remove trailing space

2017-06-20  Pavel Grunt  <pgrunt@redhat.com>

	Unrealize egl display only if it has context
	Avoids a critical to be logged when closing remote-viewer:
	 "gl_make_current: assertion 'd->egl.context_ready' failed"

	Allow to build without X11 gdk backend

2017-06-15  Marc-André Lureau  <marcandre.lureau@redhat.com>

	option: deprecate a few esoteric options from --spice group
	I propose to deprecate the options that have very unclear results, or
	that are unimplemented by drivers. They were added for historical
	reasons, mostly to match with spicec options, but aren't
	user-friendly. Some of them could be moved in spicy options or a new
	debug/tune option group. For now, mark them as deprecated so they can
	be removed in a future release.

	Imho, --spice-preferred-compression is a good candidate too, although
	users may be more familiar with this option, at least the 'off' case
	may have a clear impact.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-06-15  Snir Sheriber  <ssheribe@redhat.com>

	Grab keyboard based on focus in windows client
	Currently the client grabs keyboard based on session focus, on windows
	environment gtk sends grab_broken if wm_killfocus is received (when
	focus is changed) while the application has the grab. It means that
	when grab is based on the session, clicking inside focusless window
	will cause wm_killfocus to be sent towards the focused window, this
	will generate grab_broken event which follows by no grab at all.

	This patch expands the solution presented in 143ebfd to work also on
	windows client without causing grab_broken event.
	This is implemented a bit differently from linux, if on mouse entrance
	session already has focus, focus will be set to the current window,
	this will generate focus events that will release and take grab again
	without grab_broken event.

	Resolves: rhbz#1429611
	Related: rhbz#1275231

	Acked-by: Victor Toso <victortoso@redhat.com>

2017-06-15  Marc-André Lureau  <marcandre.lureau@redhat.com>

	util: replace SPICE_BYTESWAP16 with GUINT16_SWAP_LE_BE
	SPICE_BYTESWAP* macros where introduced at a time when spice didn't
	depend on glib (that feels quite long ago). Those macros seem to be
	copied & adapted from glib.

	In any case, that's the only direct user in spice-gtk, we can use the
	glib version instead, so one day SPICE_BYTESWAP* could eventually be
	removed.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	build-sys: replace SPICE_DEPRECATED with G_DEPRECATED
	The generic G_DEPRECATED* macros got introduced in 2.32, and spice-gtk
	depends on 2.36. We can drop our own.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	build-sys: remove -DSPICE_DISABLE_ABORT
	spice-gtk doesn't use spice_abort().

	SPICE_DISABLE_ABORT was mostly used to change default abort behaviour
	on criticals in spice-common, but since it works fine without this
	flag since 2012 (commit 05a203af120016), we can safely remove that
	unused define from spice-gtk.

	Acked-by: Victor Toso <victortoso@redhat.com>

	widget: switch 'display' type to DisplayChannel*
	This avoids the long casts. The Channel* type is less commonly used.

	Acked-by: Victor Toso <victortoso@redhat.com>

	widget: call gl-draw when skipping draw
	It's a bad idea to hold the GL scanout for a long time, especially in
	error cases. (fwiw, qemu has 1s tolerance before complaining, and the
	guest is most likely going to hang meanwhile, stuck on the GPU)

	Acked-by: Victor Toso <victortoso@redhat.com>

	widget: skip spice_egl_resize_display() if context is not ready
	And call spice_egl_resize_display() when initializing the context.

	The display must not call spice_egl_resize_display() if the egl/gl
	context isn't ready. set_egl_enabled() is called whenever we get gl
	drawing command from spice server. But the egl/gl context may not be
	ready at that time. That function must still be run to switch the
	display to GL, but has to delay any GL call to after the GL context is
	realized.  Add spice_egl_resize_display() there, to do the remaining
	egl setup.

	This fixes the "Couldn't find current GL or GLX context" error for me
	on X11. I thought first it was somehow related to commit a395ac59447de
	"spice-widget: init egl only after first gl_scanout", but reverting it
	didn't solve the problem, there are other timing changes, probably at
	gtk level.

	Acked-by: Victor Toso <victortoso@redhat.com>

	egl: add a precondition on gl_make_current()
	To ease with debugging GL issues.

	Acked-by: Victor Toso <victortoso@redhat.com>

2017-06-07  Frediano Ziglio  <fziglio@redhat.com>

	fix check for 16 bit cursor mask
	The size was computed using a 32 bit image while the cursor was
	just 16 bit. This caused the usage of some invalid bit mask (the
	bit mask is used to understand where the cursor is transparent).
	This was clearly visible as the mouse cursor was usually mostly
	black with some apparently random transparent pixels.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-05-31  Jakub Janků  <janku.jakub.jj@gmail.com>

	main: Handle lack of free space for file transfer
	Agent can send FileXferStatusMessage with result
	VD_AGENT_FILE_XFER_STATUS_NOT_ENOUGH_SPACE together with info about
	amount of available free space when the file to transfer is too large
	and the client announces support of this result by sending
	VD_AGENT_CAP_FILE_XFER_DETAILED_ERRORS

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-05-31  Frediano Ziglio  <fziglio@redhat.com>

	Use cursor->data instead of row data
	data and cursor->data contains the same data (see the memcpy
	above) but data is not aligned to uint32_t and require also
	additional casts. Using cursor->data avoid these issues.

	Acked-by: Marc-André Lureau <marcandre.lureau@redhat.com>

	Remove link_msg from _SpiceChannelPrivate
	The field is used only to initialize a buffer allocated
	inside spice_channel_send_link

	Acked-by: Marc-André Lureau <marcandre.lureau@redhat.com>

2017-05-31  Christophe de Dinechin  <dinechin@redhat.com>

	Avoid warning about snprintf on non-Linux platforms
	Without #include <stdio.h>, calls to snprintf in the file
	cause a warning. The file <unistd.h> is left aside on purpose,
	since src/usbutil.c may be compiled on Windows where this
	file does not exist.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2017-05-29  Pavel Grunt  <pgrunt@redhat.com>

	widget: Return early on cursor set without shape
	A cursor pixbuf is required in other functions to work properly
	Acked-by: Victor Toso <victortoso@redhat.com>

2017-05-26  Pavel Grunt  <pgrunt@redhat.com>

	widget: Set cursor during construction
	In a multimonitor environment can easily happen that a cursor is set
	before some of the SpiceDisplays are created. IOW the first created
	SpiceDisplay has the cursor but others don't.

	To avoid the issue set the initial cursor using the "cursor" property
	of the SpiceCursorChannel.

	Resolves:
	https://bugzilla.redhat.com/show_bug.cgi?id=1411380
	Acked-by: Victor Toso <victortoso@redhat.com>

	Deprecate "cursor-set" signal
	Use cursor notify instead

	Related:
	https://bugzilla.redhat.com/show_bug.cgi?id=1411380

	Acked-by: Victor Toso <victortoso@redhat.com>

	cursor: Add cursor shape property
	It provides information about the remote cursor similar to the signal
	"cursor-set". The benefit over the signal is that the property can be
	queried at any time.

	Users of the "cursor-set" signal should migrate to "notify::cursor".

	Related:
	https://bugzilla.redhat.com/show_bug.cgi?id=1411380

	Acked-by: Victor Toso <victortoso@redhat.com>

2017-05-25  Victor Toso  <me@victortoso.com>

	gtk-session: move variables to internal scope
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	gtk-session: move atom's debug
	We already iterate in all n_atoms and get its name with
	gdk_atom_name(), let's move the debug there too;

	While at it, move the generic SPICE_DEBUG of the function to the top.
	It should help us identify when the function was triggered but not
	used due the early returns.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	gtk-session: do an early check of clipboard grab
	As we will not be doing anything in case clipboard is already grabbed

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	gtk-session: use clear variable for array's size
	By using 'num_types' variables, we have a clear variable with a clear
	purpose: It will track the number of VD_AGENT_CLIPBOARD types we are
	storing in types[] array.

	This new variable helps:
	- removing one 'for' loop which was counting the number stored types;
	- doing fewer iterations in one 'for' loop

	A few extra comments were included to clarify what the logic should be
	doing and a extra debug was included to point out situations where the
	desktop has sent us valid clipboard data but none will be sent the
	guest.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2017-05-23  Victor Toso  <me@victortoso.com>

	spicy: add gstreamer options to command line
	So we can see all available options with spicy --help-gst and set them
	as command line argument.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-05-16  Christophe Fergeau  <cfergeau@redhat.com>

	glz: Remove unused DECODE_TO_SAME array
	This also removes the generation of unneeded _decode methods once this
	array is removed (this causes some warnings otherwise).

	DECODE_TO_SAME was used in the old client, but was never used when this
	code was moved over to spice-gtk.

2017-05-16  Pavel Grunt  <pgrunt@redhat.com>

	doc: Rename argument to match docstring
	Otherwise it appears in undocumented symbols.

	Fixup to f076dd11ce4c83b09350e372307c23c486905d34
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2017-05-15  Pavel Grunt  <pgrunt@redhat.com>

	doc: Display properties of spice-gtk classes
	It is done by putting their symbols in appropriate sections

	doc: Describe spice_usb_device_manager_disconnect_device_async

	doc: Describe spice_gl_scanout_free

	doc: Remove invalid parameter of property
	Probably copy'n'pasted from the signal description

	doc: Set correct label
	Otherwise it does not appear in the generated documentation

2017-05-12  Pavel Grunt  <pgrunt@redhat.com>

	configure: Fix typo in epoxy checking
	Acked-by: Victor Toso <victortoso@redhat.com>

2017-05-09  Francois Gouget  <fgouget@codeweavers.com>

	streaming: Separate the network code from the display_stream management
	This makes it easier to reuse display_streams for other types of
	video streams should the need arise.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	streaming: Remove the video decoder's dependency on SpiceMsgIn messages
	This improves the separation between networking and the video decoding
	components.
	It also makes it easier to reuse the latter should the client one day
	receive video streams through other messages.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	streaming: Rename SpiceFrame to SpiceGstFrame in the GStreamer decoder
	This emphasizes that this structure is specific to the GStreamer
	decoder.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	streaming: Move SpiceMsgIn parsing to display_handle_stream_create()
	This regroups all the parsing in one place and makes the rest of the
	display_stream code independent from the network messaging details.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	streaming: Document the GStreamer decoding process
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2017-05-09  Christophe de Dinechin  <dinechin@redhat.com>

	build: Check for epoxy/egl.h availability
	This header is not present on OSX. This added check allows to make the
	EGL code conditionally compiled depending on egl.h availability rather
	than only disabling it for win32 builds.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-05-02  Christophe de Dinechin  <dinechin@redhat.com>

	Fix unsatisfied symbol from export list if USE_USBREDIR is not set
	Without this fix, we get the following error message on macOS:

	Undefined symbols for architecture x86_64:
	  "_spice_usb_device_get_libusb_device", referenced from:
	     -exported_symbol[s_list] command line option

	The function is defined under `#ifdef USE_USBREDIR`, but is always exported
	in spice-glib-sym-file.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-04-26  snir sheriber  <ssheribe@redhat.com>

	Remove redundant space from error message
	Acked-by: Victor Toso <victortoso@redhat.com>

2017-04-20  Yuri Benditovich  <yuri.benditovich@daynix.com>

	usb-device-manager: Do not hide devices on client if USB redirection disabled
	https://bugzilla.redhat.com/show_bug.cgi?id=1431137
	When auto sharing of USB devices is enabled in remote-viewer's configuration
	file, Windows spice client hides connected USB devices on client machine even
	if USB redirection is disabled by --spice-disable-usbredir.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-04-18  Victor Toso  <me@victortoso.com>

	file-xfer: Fix bad filename encoding
	Manual for G_FILE_ATTRIBUTE_STANDARD_NAME states:
	 > The name is the on-disk filename which may not be in any known
	 > encoding, and can thus not be generally displayed as is.

	Considering a file named "ěščřžýáíé", if we use
	G_FILE_ATTRIBUTE_STANDARD_NAME to get the file name, we will have the
	following 72 bytes long string:
	"\xc4\x9b\xc5\xa1\xc4\x8d\xc5\x99\xc5\xbe\xc3\xbd\xc3\xa1\xc3\xad\xc3\xa9"

	This is a regression introduced at 4647ac9a2a72c98b6841180ccf5f8d

	Possible solutions are:
	1) Using G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME attribute;
	2) Using g_file_info_get_attribute_byte_string() function;
	3) Using the g_file_get_basename() which was used before 4647ac9a2a72c9

	Using option 2 based on better long term solution.
	This give us the correct 18 bytes long utf-8 string to "ěščřžýáíé"

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1440206
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-04-11  Marc-André Lureau  <marcandre.lureau@redhat.com>

	Add default .gitpublish profile
	Can be quite handy for git-publish users like me.
	(https://github.com/stefanha/git-publish)

	Acked-by: Victor Toso <victortoso@redhat.com>

	build-sys: update git.mk
	Reviewed-by: Victor Toso <victortoso@redhat.com>

	build-sys: update spice-common submodule
	- log: Follow spice style guidelines for #include in log.h
	- log: Add missing stdio.h include
	- build-sys: don't dist spice-protocol.html

	Acked-by: Victor Toso <victortoso@redhat.com>

2017-03-28  Victor Toso  <me@victortoso.com>

	audio: debug audio codec when audio stream starts
	We already debug a few parameters but the audio codec is missing.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1436249
	Acked-by: Marc-André Lureau <marcandre.lureau@redhat.com>

2017-03-28  Marc-André Lureau  <marcandre.lureau@redhat.com>

	Revert "build-sys: update git.mk"
	This reverts commit 243357cbc18db92b2b301c4c89ee9431fd12e0b1.

	Revert "build-sys: remove intltool"
	This reverts commit c13b3eb0c4773edbe2d26a8f9732f305eeb342ce.

	build-sys: remove intltool
	It never really worked, and we removed some of its commented usage a
	while ago when dropping spicy desktop/mime.

	build-sys: update git.mk

2017-03-27  snir sheriber  <ssheribe@redhat.com>

	authentication: Handle failed spice authentication
	Changing the name of the failures handling function (spice
	and sasl authentication failures are now treated separately)
	and display more suitable spice authentication failure error
	message.

	Resolves: rhbz#1365736

	authentication: Handle failed SASL authentication separately
	Move SASL authentication failures handling to a separate
	function.

	Multiple error messages asking for username\password were
	removed because they are not necessarily the reason for the
	failure (avoiding similar issue as in rhbz#1365736).
	Letting the user know about required username\password
	should be achieved by setting specific Gerror's error code
	and enabling\disabling the username\password fields
	accordingly by the application.

2017-03-27  Pavel Grunt  <pgrunt@redhat.com>

	widget: Always call gtk_widget_show_all
	Since spice-gtk 0.32 SpiceDisplay widget internally has changed
	from the GtkDrawingArea to a GtkContainer.

	Per gtk_widget_show documentation:
	 "Remember that you have to show the containers containing a widget,
	  in addition to the widget itself, before it will appear onscreen."

	Let's always call gtk_widget_show_all, not just for gtk+ >= 3.16
	otherwise you may get a blackscreen with spice-gtk compiled against
	an old gtk+ version.

	Fixes:
	https://bugs.freedesktop.org/show_bug.cgi?id=100251

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-03-27  Victor Toso  <me@victortoso.com>

	channel-webdav: include comment about message handling
	Channel-webdav does not handle any other message besides
	SPICE_MSG_SPICEVMC_DATA it wants to let SpiceVmcInputStream handle it
	and the same to deal when sending data to the server with
	SPICE_MSGC_SPICEVMC_DATA using SpiceVmcOutputStream.

	The other Spice messages are dealt in its parent class channel-port
	and handled in channel-webdav handling port-event signal.

	This patch also renames webdav_handle_msg -> webdav_handle_data_msg
	for the reason described above.

	Reviewed-by: Marc-André Lureau <marcandre.lureau@redhat.com>

2017-03-24  Pavel Grunt  <pgrunt@redhat.com>

	Use macro for more precise widget debugs
	DISPLAY_DEBUG provides information about channel and monitor ids.
	In case of multimonitor it helps to identify the owner of the debug
	message.
	Acked-by: Victor Toso <victortoso@redhat.com>

	widget: Extend mouse mode debug
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2017-03-23  Pavel Grunt  <pgrunt@redhat.com>

	widget: Use deprecated function to ungrab device
	Avoid broken grab (alt+tab not working), regression since
	 ef7a6fa1798c8e53c0b77330b398a78181cf90e5

	Currently it is not possible to ungrab just keyboard/mouse
	using GdkSeat functions:
	 https://bugzilla.gnome.org/show_bug.cgi?id=780133
	Use deprecated gdk_device_ungrab to do it

	Acked-by: Snir Sheriber <ssheribe@redhat.com>

2017-03-13  Victor Toso  <me@victortoso.com>

	Revert "channel-display: new stream-video-codec-type property"
	This reverts commit 00f56647a97a95342f235ef6d107ac8216aa9e49.

	As this take no consideration to multiple streams.

	Acked-by: Marc-André Lureau <mlureau@redhat.com>

	Revert "spicy: improve status label with stream information"
	This reverts commit 9a7ae78aa94f4eada3fa85e9fd7dfac681aadd6d.

	As we are going to revert 00f56647a97a95 "channel-display: new
	stream-video-codec-type property"

	Acked-by: Marc-André Lureau <mlureau@redhat.com>

	spicy: improve status label with stream information
	By using stream-video-codec-type property, we can display which
	video-codec is being used.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	spicy: keep status of mouse/agent on server mode
	So we can still check the agent status even in server mode.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	channel-display: new stream-video-codec-type property
	This is a per channel-display property that stores and notifies the
	video-codec type being used if a stream is being used or 0 if there is
	no ongoing stream.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-03-13  Pavel Grunt  <pgrunt@redhat.com>

	README: Update link to virt-viewer
	Acked-by: Snir Sheriber <ssheribe@redhat.com>

2017-03-13  snir sheriber  <ssheribe@redhat.com>

	Adding test to gitlab ci
	Disable some capabilities and try make

	Add .gitlab-ci.yml

2017-03-10  Victor Toso  <me@victortoso.com>

	gstaudio: Remove fixed TODOs about setting record volume
	* directsoundsrc doesn't support IDirectSoundBuffer_SetVolume

	This was fixed by 1b564bfb8b0db in gst-plugins-bad, see:
	https://bugzilla.gnome.org/show_bug.cgi?id=744383

	* pulsesrc doesn't support volume property, it's all coming!

	This was fixed by 1f4bb687940f87a0 in gst-plugins-good, see:
	https://bugzilla.gnome.org/show_bug.cgi?id=595055

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-03-10  Pavel Grunt  <pgrunt@redhat.com>

	main: Handle disabled file transfer
	File transfer can be disabled by the server or agent, it is
	signalized by the VD_AGENT_CAP_FILE_XFER_DISABLED set.

	Do not try to transfer files when the capability is set.

	Related: rhbz#1373725

	Acked-by: Victor Toso <victortoso@redhat.com>

	build-sys: Use AM_PATH_PYTHON to find PYTHON interpreter
	It is more suitable for the task than AC_PATH_PROGS
	Also it prevents us from forcing a version of Python

	https://www.gnu.org/software/automake/manual/html_node/Python.html

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>
	Acked-by: Marc-André Lureau <mlureau@redhat.com>

	m4: Drop unused AM_CHECK_PYTHON_HEADERS
	Unused since we dropped python bindings
	0917002c48a0a5deb615d120a0e5997eefc89fd4
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Update submodules
	Allow to compile without warnings with the new OpenSSL
	Add missing import in the keymap generator

	spice-common:
	Frediano Ziglio (1):
	      region: Avoid possible memory corruption

	Jonathon Jongsma (1):
	      Document REGION_TEST_* bitmasks

	Sebastian Andrzej Siewior (1):
	      ssl: Use ASN1_STRING_get0_data instead of ASN1_STRING_data

	keycodemapdb:
	Daniel P. Berrange (1):
	      Add ability to generate Perl POD docs for key map names & values

	Pavel Grunt (1):
	      keymap-gen: Import sys
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	dist: Keep generated keymaps
	spice-gtk does not have to require python

	Regression since 271222e2217bf82644d87649b43b920240430f8

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-03-10  Christophe Fergeau  <cfergeau@redhat.com>

	doc: Mention python in the git build requirements

	doc: Remove perl(Text::CSV) references
	It's no longer used since commit e271222e "Switch over to using
	keycodemapdb submodule"

2017-03-06  Victor Toso  <me@victortoso.com>

	spicy: use gboolean for GtkSettings properties
	As gboolean is 4 bytes long while bool is 1 byte, valgrind will complain
	about it.

	Invalid write of size 4
	   at 0xAE9F4FB: value_lcopy_boolean (gvaluetypes.c:78)
	   by 0xAE7CFD3: g_object_get_valist (gobject.c:2236)
	   by 0xAE7D40B: g_object_get (gobject.c:2324)
	   by 0x40758F: keyboard_grab_cb (spicy.c:566)
	   by 0xAE753E4: g_closure_invoke (gclosure.c:804)
	   by 0xAE87431: signal_emit_unlocked_R (gsignal.c:3635)
	   by 0xAE9005E: g_signal_emit_valist (gsignal.c:3391)
	   by 0xAE9043E: g_signal_emit (gsignal.c:3447)
	   by 0x4E4A6FB: try_keyboard_grab (spice-widget.c:889)
	   by 0x4E4CAB1: focus_in_event (spice-widget.c:1834)
	   by 0x9325E70: _gtk_marshal_BOOLEAN__BOXEDv (gtkmarshalers.c:131)
	   by 0xAE75561: _g_closure_invoke_va (gclosure.c:867)

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-03-06  Daniel P. Berrange  <berrange@redhat.com>

	Switch over to using keycodemapdb submodule
	Consume the keymaps.csv file from a git submodule instead of having
	a private copy. This makes it easier to ensure all users of the keymap
	(libvirt, gtk-vnc, spice-gtk, and eventually QEMU) to have a consistent
	set of data.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-03-06  Pavel Grunt  <pgrunt@redhat.com>

	spicy: Add dialog for precise resizing
	It helps when testing whether the guest resizes to requested resolution

	Acked-by: Victor Toso <victortoso@redhat.com>

2017-03-02  Victor Toso  <me@victortoso.com>

	spice_channel_read_wire: move variables to internal scope
	And avoid single line if plus comment

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	spice_channel_read_wire: prefer while(TRUE) instead of goto
	Although this is likely to be a single loop iteration based on the
	implementation of g_coroutine_socket_wait(), using goto to reiterate
	in the code should be avoided based on spice style recommendation.

	This also make it easier to add follow up changes that can increase
	the loop iterations.

	This patch changes:
	 * The reread label with a while(TRUE);
	 * The goto keyword with continue;

	All other changes are only related to new indentation.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	spice-channel: move out non blocking logic of _flush_wire()
	This patch introduces spice_channel_flush_wire_nonblocking() helper
	without changing any logic.

	Related: https://bugs.freedesktop.org/show_bug.cgi?id=96598
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	spice-channel: move out non blocking logic of _read_wire()
	This patch introduces spice_channel_read_wire_nonblocking() helper
	without changing any logic.

	Related: https://bugs.freedesktop.org/show_bug.cgi?id=96598
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-03-02  Pavel Grunt  <pgrunt@redhat.com>

	spice-display: Check validity of cursor before unref
	Since 62f9144d6c5ac06cd76b76176644622c43c08541 the mouse cursor
	is created when the widget is realized. The unref must be prevented.

	The issue can happen when connecting using remote-viewer to
	a multimonitor VM.

2017-03-01  Victor Toso  <me@victortoso.com>

	display-mjpeg: free queue
	24 bytes in 1 blocks are definitely lost in loss record 4,300 of 14,518
	   at 0x4C2DB9D: malloc (vg_replace_malloc.c:299)
	   by 0xB12C5B8: g_malloc (gmem.c:94)
	   by 0xB144B12: g_slice_alloc (gslice.c:1025)
	   by 0xB14513D: g_slice_alloc0 (gslice.c:1051)
	   by 0x50EE096: create_mjpeg_decoder (channel-display-mjpeg.c:310)
	   by 0x50B5ACC: display_handle_stream_create (channel-display.c:1230)
	   by 0x50AAEE3: spice_channel_handle_msg (spice-channel.c:3014)
	   by 0x50A7AE4: spice_channel_recv_msg (spice-channel.c:2024)
	   by 0x50A829D: spice_channel_iterate_read (spice-channel.c:2262)
	   by 0x50A84B0: spice_channel_iterate (spice-channel.c:2300)
	   by 0x50A926B: spice_channel_coroutine (spice-channel.c:2588)
	   by 0x50F0D10: coroutine_trampoline (coroutine_ucontext.c:63)

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-02-27  Victor Toso  <me@victortoso.com>

	gtk-session: initialize array without memset
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	gtk-session: check if retrieving clipboard data failed
	In case of failure, the GdkAtom *atoms will be set to NULL.
	Including this check to an early return.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	gtk-session: always reply to agent's clipboard request
	This fixes a regression from 7b0de6217670e0f668aff2949f

	We need to reply back to the agent all clipboard requests even in case
	of failure otherwise it will have a pending request. The following
	error message can be seen afterwards, in the linux agent, when client
	sends down some clipboard data:

	 > clipboard: selection requests pending on clipboard ownership
	 > change, clearing

	An easy way to reproduce this is:
	1-) In client, copy image from lo-draw (selection or ctrl+c)
	2-) In guest, paste it to GEdit (mouse3 our ctrl+v)
	3-) Move to the client
	4-) Move back to the guest
	5-) see error on vdagent logs

	The reason for failure is that client's clipboard contains different
	data type (image) then what was requested from guest's editor (text)

	While at it, include extra debug message as it might be hard to
	identify why clipboard did not work.

	Resolves: rhbz#1409854
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-02-27  Francois Gouget  <fgouget@codeweavers.com>

	spicy: Spicy uses GTK+ and must link with it
	This avoids having the linker complain that gtk_toggle_action_get_type()
	or some other GTK+ API is undefined.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	spicy-stats: spicy-stats uses libgobject so link with it
	This avoids having the linker complain that g_signal_connect_data() or
	some other GObject API is undefined.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-02-22  Victor Toso  <me@victortoso.com>

	gtk-session: Use GWeakRef
	The custom WeakRef structure was introduced in 9baba9fd89 (2012) to
	fix rhbz#743773. Since glib 2.32, GWeakRef was introduced and it
	behaves similarly to our WeakRef.

	Moving to GWeakRef to remove some code which exists in glib.

	Note that I'm keeping two utility functions:
	- get_weak_ref(gpointer object): which returns a newly allocated
	  GWeakRef, initialized with @object;
	- free_weak_ref(gpointer pdata): which frees the GWeakRef and returns
	  the original object or NULL. It also takes care of an extra
	  reference to the object.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-02-21  Pavel Grunt  <pgrunt@redhat.com>

	gtk: Avoid deprecated gdk_pointer_grab
	gdk_pointer_grab() was deprecated in 3.0 for gdk_device_grab()
	but that was also deprecated for gdk_seat_grab() in 3.20

	Acked-by: Victor Toso <victortoso@redhat.com>
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	gtk: Avoid deprecated gdk_keyboard_grab
	gdk_keyboard_grab() was deprecated in 3.0 for gdk_device_grab()
	but that was also deprecated for gdk_seat_grab() in 3.20

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	gtk: Use gdk_device_warp
	gdk_display_warp_pointer has been deprecated since Gtk 3.0

	In Wayland gdk_device_warp is noop making server mouse mode
	unusable, see: https://bugzilla.redhat.com/show_bug.cgi?id=1285378

	Acked-by: Victor Toso <victortoso@redhat.com>

	gtk: Use gdk_window_get_device_position
	gdk_window_get_pointer has been deprecated since Gtk 3.0

	Introduce helper functions for getting the display's pointing
	device and modifiers to keep the update_mouse_mode simple

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	gtk: Use gdk_cursor_new_from_name
	gdk_cursor_new has been deprecated since Gtk 3.16

	A difference is that the helper function for creating the cursor
	returns early if the widget is not realized.

	Also allow to hide the cursor under Wayland

	Acked-by: Victor Toso <victortoso@redhat.com>

2017-02-20  Pavel Grunt  <pgrunt@redhat.com>

	gtk-session: Set value directly
	Related Coverity warning:
	 spice-gtk-0.33.53-7cb7-dirty/src/spice-gtk-session.c:920:9: note:
	 Value stored to 'new_len' during its initialization is never read
	 #    int new_len = *len;
	 #        ^~~~~~~   ~~~~
	 #  918|   {
	 #  919|       char *conv = NULL;
	 #  920|->     int new_len = *len;
	 #  921|
	 #  922|       if (spice_main_agent_test_capability(self->priv->main,
	 VD_AGENT_CAP_GUEST_LINEEND_CRLF)) {

	There is no need for the "new_len" variable

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>
	Acked-by: Victor Toso <victortoso@redhat.com>

2017-02-17  Christophe Fergeau  <cfergeau@redhat.com>

	channel: Move local variables to inner block
	Less things to keep track of when taking a quick look at the code flow
	of the spice_channel_load_ca() method.

2017-02-14  Pavel Grunt  <pgrunt@redhat.com>

	keymaps.csv: Add missing columns
	Allow easier processing by scripts and csv editors

	With

	  git diff HEAD^ --word-diff --word-diff-regex='[^[:space:]]'

	you can easily see that there's no difference beside the added
	columns at the end and with a

	  perl -pe 's.[^,\n]..sg' src/keymaps.csv | uniq

	you can see all rows have the same amount of columns

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2017-02-08  Jonathon Jongsma  <jjongsma@redhat.com>

	Spicy: cancel file transfer when dialog is closed
	Clicking the 'X' to close the file transfer dialog did not actually
	cancel the ongoing file transfer, and resulted in a bunch of critical
	warnings on the terminal. Make the delete-event explicitly cancel all
	ongoing file transfers.

2017-02-08  Victor Toso  <me@victortoso.com>

	file-xfer: avoid g_hash_table_iter_* when changing the GHashTable
	Using g_hash_table_iter_init() and g_hash_table_iter_next() here is
	bad as spice_file_transfer_task_completed() will emit "finished"
	signal from SpiceFileTransferTask resulting in the original GHashTable
	to be changed in file_transfer_operation_task_finished()

	Debug will show:
	  GSpice-DEBUG: spice-file-transfer-task.c:303 File bigfile2 xfer
	  failed: Agent connection closed

	  WARNING **: Agent connection closed

	  GLib-CRITICAL **: g_hash_table_iter_next: assertion 'ri->version ==
	  ri->hash_table->version' failed

	Reported-by: Pavel Grunt <pgrunt@redhat.com>
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	spicy: implement preferred video codec type
	Similar to preferred video compression, a radio button showing mjpeg,
	vp8, vp9 and h264 in case server has the proper [0] capability

	[0] SPICE_DISPLAY_CAP_PREF_VIDEO_CODEC_TYPE

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	channel-display: implement preferred video codec msgc
	* SPICE_MSGC_DISPLAY_PREFERRED_VIDEO_CODEC_TYPE

	This message was introduced in protocol 0.12.13 to establish client
	side preference on video codec to be used in streams.

	At this moment, we only introduce a new API [0] to select *the*
	preferred video codec for client; In a later time, it should be
	possible to use this message upon connection in order to to give
	higher priority for video codecs with better performance and with
	hardware decoding capabilities.

	[0] spice_display_change_preferred_video_codec_type()

	Note that host preference for encoding is expected to be considered
	first then the client's preference.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-02-06  Pavel Grunt  <pgrunt@redhat.com>

	streaming: Unify codec checking
	Avoid copy-pasting to add a new codec

	Acked-by: Victor Toso <victortoso@redhat.com>

	build-sys: Add VP9 check
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2017-01-31  Frediano Ziglio  <fziglio@redhat.com>

	Add support for VP9
	Acked-by: Victor Toso <victortoso@redhat.com>

2017-01-31  Victor Toso  <me@victortoso.com>

	Update spice-common
	Frediano Ziglio (1):
	      protocol: Add support for VP9 video codec

	Victor Toso (1):
	      protocol: add preferred video codec message

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2017-01-31  Marc-André Lureau  <marcandre.lureau@redhat.com>

	usb: remove disconnect_device() deprecation warning
	Use a static function instead of the deprecated public function.

	The usage of the function seems to be fine for sync case, since the
	device was already removed, but I added a TODO just in case someone
	looks at this code.

	Acked-by: Victor Toso <victortoso@redhat.com>

	Give a hint about spice_usb_device_manager_disconnect_device() deprecation
	Acked-by: Victor Toso <victortoso@redhat.com>

	audio: fix deprecation warning
	Use a private function to avoid the spice_audio_new() deprecation
	warning.

	Acked-by: Victor Toso <victortoso@redhat.com>

	Revert "audio: Remove spice_audio_new() from the public header"
	This reverts commit c6d9fa1c4af03d9875bf503ce6eabc9e7b52acc3.

	There is no rush to remove a deprecated API from public headers. It's
	better to do that when the whole library breaks API/ABI altogether.

	Acked-by: Victor Toso <victortoso@redhat.com>

	pygtk: remove bindings leftover
	PyGtk 2.0 got removed in 0917002c48a0a5deb615d120a0e5997eefc89fd4,
	remove some remaining files.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-01-24  Pavel Grunt  <pgrunt@redhat.com>

	doc: Remove SpiceGtkBox
	Removed from code in a7565265532f6abec0fd3c6d843683b58eee070a

2017-01-23  Pavel Grunt  <pgrunt@redhat.com>

	keymap: Add missing keys for XF86 and X11
	Broadway backend keymap (vncdisplaykeymap_x112xtkbd.c) was missing
	the "shift" variants of many keys, like:
	 !,@,#,$,%,^,&,*,(,),...
	making its usage very limited. This change allow us to use it at least
	with the EN_US keyboard layout.

	Keys were taken from `xmodmap -pk`.

	To reproduce the issue:
	 brodwayd
	 GDK_BACKEND=broadway spicy
	 firefox 127.0.0.1:8080

	Also add F11/F12/102nd key to XF86 making them available in:
	 vncdisplaykeymap_xorgxwin2xtkbd.c
	 vncdisplaykeymap_xorgkbd2xtkbd.c

	Resolves:
	https://bugs.freedesktop.org/show_bug.cgi?id=99407
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-01-23  Victor Toso  <me@victortoso.com>

	Move spicy tools to its own folder
	So we can have the tools and the libraries in different folders.

	In the src/Makefile.am I've only removed the lines related to the
	tools but not all lines were copied into tools/Makefile.am as we
	don't really need them. Other lines were adjusted to have the paths
	correctly;

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-01-19  Francois Gouget  <fgouget@codeweavers.com>

	streaming: Fix a race condition in the GStreamer frame display queue
	When a frame is late we schedule its display right away with
	g_timeout_add(0, ...).  This scheduling is done in one of the GStreamer
	thread, and the display_frame() callback will be called from the main
	thread. This can result in display_frame() being called before
	g_timeout_add() returns. This would cause the timer_id being reset
	before schedule_frame() had set it so that it would then never be reset.
	So from that point schedule_frame() would always think a frame was being
	displayed and thus would not schedule any more frames resulting in a
	video freeze.

	display_frame() now takes the queues mutex before resetting timer_id
	eliminating the race.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2017-01-11  Sebastian Andrzej Siewior  <sebastian@breakpoint.cc>

	ssl: Use accessors rather than direct struct access
	In OpenSSL 1.1.0, the struct fields are private so we can no longer
	directly access them.

	The accessors are not available in previous OpenSSL releases, so we need
	to add compat helpers.

	ssl: Rework our custom BIO type
	This commit changes to an actual new BIO method rather than reusing an
	existing BIO method, and overriding only the fields that we need.
	The approach before this commit would be causing issues with OpenSSL
	1.1.0 as some of the fields we access have become opaque.

	ssl: Stop creating our own X509_LOOKUP_METHOD
	OpenSSL 1.1.0 does not seem to provide API to do that anymore.

	There is no need to create a custom lookup to begin with. This method
	here has no callbacks implemented and is doing nothing. The way I
	understand it, it is used to retrieve a `lookup' object which provides a
	certificate store.  The SSL ctx provides also such a store.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2017-01-09  Frediano Ziglio  <fziglio@redhat.com>

	streaming: Allows protocol to have more codecs
	The source file contains a list of fixed codecs for streaming.
	This list is tested to include all codecs from spice-protocol.
	If spice-protocol is extended to add more codecs this file starts
	failing to compile due to missing codecs.
	This patch allow to compile supporting less codecs than the
	ones listed in spice-protocol.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-12-22  Victor Toso  <me@victortoso.com>

	win-usb: remove usbclerk
	As we have UsbDk integration now which is well maintained upstream.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-12-19  Victor Toso  <me@victortoso.com>

	Ignore warnings about unavailable function around webdav
	We do an extra check in configure to enable webdav and build everything
	with a PHODAV variable check.

	The warnings below are false positive and can be ignored while we don't
	bump the requirements.

	giopipe.c:481:5: warning: ‘g_simple_io_stream_new’ is deprecated: Not
	available before 2.44 [-Wdeprecated-declarations]

	giopipe.c:482:5: warning: ‘g_simple_io_stream_new’ is deprecated: Not
	available before 2.44 [-Wdeprecated-declarations]

	channel-webdav.c:317:5: warning: ‘g_output_stream_write_all_finish’ is
	deprecated: Not available before 2.44 [-Wdeprecated-declarations]

	channel-webdav.c:339:9: warning: ‘g_output_stream_write_all_async’ is
	deprecated: Not available before 2.44 [-Wdeprecated-declarations]

	channel-webdav.c:375:5: warning: ‘g_inet_socket_address_new_from_string’
	is deprecated: Not available before 2.40 [-Wdeprecated-declarations]

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-12-09  Pavel Grunt  <pgrunt@redhat.com>

	Adjust to spice_marshaller_add_ref rename
	It was renamed in the spice-common submodule

	Submodule update contains following changes:

	Francois Gouget (1):
	      codegen: Fix compatibility with Python 2.6

	Frediano Ziglio (9):
	      Start adding protocol file documentation
	      Start writing some documentation on protocol
	      Extended protocol documentation
	      More work on attribute protocol documentation
	      Fix BNF notation in documentation
	      Add protocol documentation for "channel" and "protocol"
	      Define a new SPICE_VERIFY macro
	      Detect LZ4_compress_fast_continue function
	      marshaller: Remove deprecated replacement functions

	Jonathon Jongsma (1):
	      Marshaller: rename _add_ref() to _add_by_ref()

	Pavel Grunt (5):
	      codegen: Do not generate extra null check
	      silence -Wunused-parameter
	      spice-deps: Fix accidently deleted comment
	      spice-deps: Make LZ4 check depending on function
	      spice-deps: Set python version based on modules availability

	Victor Toso (6):
	      build-sys: requires liblz4 129 or newer
	      Fix gitignore with new docs folder
	      canvas-base: use helper to get surface
	      canvas-base: group ifdef and defined together
	      canvas-base: remove user data from CanvasBase
	      sw-canvas: remove unused defines

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-12-08  Christophe Fergeau  <cfergeau@redhat.com>

	spicy: Disable deprecation warnings
	It still uses GtkUIManager and GtkAction

	Acked-by: Francois Gouget <fgouget@codeweavers.com>

2016-12-08  Francois Gouget  <fgouget@codeweavers.com>

	build-sys: Enable deprecation warnings instead of ignoring them entirely
	For Spice-gtk most deprecation issues come from changes outside Spice
	(GLib) and thus should not be treated as errors to not break
	compilation for users who have newer third-party libraries.
	However they must be visible otherwise Spice developers will not be
	aware of them and thus will not fix them before breakage happens.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	gtk: Temporarily ignore the keyboard/mouse grabbing deprecation warnings
	Note that the *_IGNORE_DEPRECATIONS macros are treated as separate
	statements by the compiler so they need to be put in a proper code block
	where appropriate.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-12-02  Francois Gouget  <fgouget@codeweavers.com>

	streaming: Stop streaming if frames cannot be decoded
	Report the stream as invalid if the frames cannot be decoded. This will
	force the server to send regular screen updates instead.

	Acked-by: Victor Toso <victortoso@redhat.com>

	streaming: Report invalid streams to the server
	The error is sent using the existing client stream report message where
	the dropped frame count is maxed out while the received frame count is
	zero. Servers that recognize it can then switch to sending regular
	screen updates for that area so the client is not stuck with a frozen
	area on the screen.
	This can be useful in case the client is unable to decode the stream for
	some reason like a bug in the GStreamer plugins, the decoder not liking
	odd video dimensions, etc.

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-12-01  Victor Toso  <me@victortoso.com>

	channel-usbredir: Fix crash on channel-up
	SpiceSession does not initialize its SpiceUsbDeviceManager object on
	startup that could lead to a race condition where channel-usbredir is
	requested to flush data while it is uninitialized.

	In a few places, spice_usb_device_manager_get() is called as in
	usb-device-widget.c and spice-gtk-session.c but not used in
	spicy-stats, making the tool to crash on startup if it encounters an
	usbredir channel.

	 #0 in usbredirhost_write_guest_data (host=0x0) at usbredir/usbredirhost/usbredirhost.c:876
	 #1 in spice_usbredir_channel_up (c=0x643830) at channel-usbredir.c:821
	 #2 in spice_channel_up (channel=0x643830) at spice-channel.c:1238
	 #3 in spice_channel_recv_auth (channel=0x643830) at spice-channel.c:1225
	 #4 in spice_channel_coroutine (data=0x643830) at spice-channel.c:2580
	 #5 in coroutine_trampoline (cc=0x642ec0) at coroutine_ucontext.c:63
	 #6 in continuation_trampoline (i0=6565568, i1=0) at continuation.c:55

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1399838

	Reported-by: Michael Cullen <michael@cullen-online.com>
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	channel-main: demote log level from warning to debug
	The volume-async happens when agent announce its capabilities. It is
	common that we don't have a playback stream being played at this time
	and it is even harder for a record stream.

	If the audio back-end does not cache the last volume used or if this
	is the first time the application is launched, this message will be
	seen.

	Failing to get playback or record volume async on startup is very
	common making this warning too worrisome for users.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-11-16  Victor Toso  <me@victortoso.com>

	Revert "win-usb-dev: report error to g_udev_client_new()"
	This reverts commit eba83a7056d4213b60466f692a03e515115b0826.

	This is breaking build in linux as it relies on the actual GUdevClient
	API. Let's simply revert and find a different way to get the error.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-11-15  Victor Toso  <me@victortoso.com>

	win-usb-dev: improve warning message
	With the actual reason for failure. This might help to identify why
	code might be crashing or failing.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	win-usb-dev: let _finalize() do libusb_exit()
	This fixes a hang in mingw-spice-gtk when the GUdevClient fails to
	initialize due to problems in the UsbDk installation.

	Before this patch, libusb_exit() was being called twice:
	- At g_udev_client_initable_init(), after failure with priv->ctx as
	  argument
	- At g_udev_client_finalize() as g_udev_client_initable_init() failure
	  implies the object failed to initialize and it is terminated. Here
	  it was being called with NULL as priv->ctx was set to NULL in
	  g_udev_client_initable_init()

	Resolves: https://bugs.freedesktop.org/show_bug.cgi?id=98686
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	usb-device-manager: handle failures from g_udev_client_new()
	As we must handle when GUdevClient creation can fail otherwise code
	might crash.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	channel-usbredir: handle failure from SpiceUsbDeviceManager
	As spice_usb_device_manager_get() can be NULL
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	win-usb-dev: report error to g_udev_client_new()
	Otherwise application will not be able to know the reason for failure.
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	win-usb-dev: make usage of early return
	No need for if else here.
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-11-14  Victor Toso  <me@victortoso.com>

	file-xfer: do not send unnecessary 0 bytes messages
	This fixes the situation when VDAgent receives 0 byte message
	regarding a file-transfer operation that was terminated in the
	previous message.

	This makes the VDAgent to send a STATUS_ERROR after STATUS_SUCCESS to
	client.

	Resolves: https://bugs.freedesktop.org/show_bug.cgi?id=97227

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-11-14  Frediano Ziglio  <fziglio@redhat.com>

	usb: Allow to compile if LZ4 is disabled
	spice_usbredir_channel_get_spice_usb_device is used only if LZ4
	is enabled so avoid to define if not used as this cause a
	compile error.

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-11-14  Pavel Grunt  <pgrunt@redhat.com>

	vncdisplaykeymap: Include missing headers
	Causing build failures on win32
	 .libs/vncdisplaykeymap.o: In function `vnc_display_keymap_gdk2xtkbd_table':
	  /builddir/build/BUILD/spice-gtk-0.33.19-efbfd/build_win32/src/../../src/vncdisplaykeymap.c:198: undefined reference to `GDK_IS_WIN32_WINDOW'
	 collect2: error: ld returned 1 exit status

	Regression from 9ff67a108bb76e50a2c85a5054e6521088df1800
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Adjust include header to new location of macros
	minor & major macros were moved to sysmacros.h

	usbutil.c: In function ‘spice_usbutil_get_sysfs_attribute’:
	usbutil.c:110:14: warning: ‘__major_from_sys_types’ is deprecated:
	  In the GNU C Library, `major' is defined by <sys/sysmacros.h>.
	  For historical compatibility, it is currently defined by
	  <sys/types.h> as well, but we plan to remove this soon.
	  To use `major', include <sys/sysmacros.h> directly.
	  If you did not intend to use a system-defined macro `major',
	  you should #undef it after including <sys/types.h>.
	  [-Wdeprecated-declarations]
	              major(stat_buf.st_rdev), minor(stat_buf.st_rdev), attribute);

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-11-10  Christophe Fergeau  <cfergeau@redhat.com>

	gtk-session: Fix typo in comment

2016-10-31  Francois Gouget  <fgouget@codeweavers.com>

	build-sys: Use spice-protocol's deprecation macros
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	build-sys: Remove SPICE_NO_DEPRECATED
	The new policy is that deprecation warnings should not be disabled
	globally or even per-file with SPICE_NO_DEPRECATED. Instead they should
	either be fixed, or ignored locally with
	G_GNUC_{BEGIN,END}_IGNORE_DEPRECATIONS.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	audio: Remove spice_audio_new() from the public header
	It has been deprecated for long enough.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	gdk: Ignore clipboard_get()'s deprecation warnings
	Its implementation is modeled after gtk_dialog_run() which still uses
	these deprecated thread functions.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	vncdisplaykeymap: Remove obsolete GTK+ 2 compatibility macros
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	gtk: Ignore GLib's too-new warnings where we explicitly check its version
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	gtk: Remove an obsolete comment
	The GTK+ compatibility code has been gathered in a single file long ago
	and support for GTK+ 2 has been dropped anyway.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-10-21  Francois Gouget  <fgouget@codeweavers.com>

	spicy: GtkTable is deprecated so use GtkGrid instead
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	spicy: Avoid gtk_hbutton_box_new(); it is deprecated
	Spice-Gtk requires GTK+ > 3.12 which has gtk_button_box_new().

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	spicy: Avoid gtk_vbox_new(); it is deprecated
	Spice-Gtk requires GTK+ > 3.12 which has gtk_box_new().

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-10-20  Victor Toso  <me@victortoso.com>

	channel-display-gst: use a static array for gst options
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	channel-display-gst: style changes in create_pipeline
	Move declaration of variable to top and break big g_strdup_printf
	line.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-10-19  Pavel Grunt  <pgrunt@redhat.com>

	test-session: Fix comparison
	The test was not executed because G_N_ELEMENTS is 0 for the pointer

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-10-17  Pavel Grunt  <pgrunt@redhat.com>

	test-session: Add IPv6 tests

	test-session: Test invalid URIs

	test-session: Also test hostname, username and password

	test-session: Test alternative way for setting port
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-10-17  Victor Toso  <me@victortoso.com>

	clipboard: Fix crash by handling error
	As manual states below, text could be NULL for different reasons and
	we should handle that. I've included a debug message to help
	identifying possible regressions from wayland's clipboard.

	This crash is a regression from 7b0de6217670e0f668aff2949f

	 "The text parameter to callback will contain the resulting text if
	 the request succeeded, or NULL if it failed. This could happen for
	 various reasons, in particular if the clipboard was empty or if the
	 contents of the clipboard could not be converted into text form."

	Resolves: rhbz#1384676

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-10-07  Marc-André Lureau  <marcandre.lureau@redhat.com>

	spicy: fix reset of terminal when quit
	Only restore the terminal if it was actually saved.

	Acked-by: Victor Toso <victortoso@redhat.com>

	usb: fix libusb_get_active_config_descriptor()
	I wrongly replaced "assert(!get_active_config())" with
	"if (!get_active_config())" in the previous commit.

2016-10-07  Snir Sheriber  <ssheribe@redhat.com>

	Avoid compression of isochronous devices
	Device is considered isochronous if one of its endpoints is
	defined as isochronous transfer, in that case data transfer
	over the usbredir channel will not be compressed
	(it is assumed that there is a strong correlation between
	isochronous devices and devices which their data is usually
	compressed)

	E.g.
	Camera/mic device will usually be recognised as isochronous
	while storage devices won't

	Message-Id: <1475766822-26809-2-git-send-email-ssheribe@redhat.com>

2016-10-06  Marc-André Lureau  <marcandre.lureau@redhat.com>

	Update NEWS for 0.33 release
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	build-sys: bump spice-glib version
	New symbols in spice-glib, bump before release.

	spicy: only watch stdin if testing org.spice.spicy port
	This fixes starting spicy with a shell in the background with &, spicy
	would hang in tcsetattr().

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-10-05  Victor Toso  <me@victortoso.com>

	tests: fix -Wall -Wextra compiler warnings
	With -Wall a few -Wunused-variable and -Wunused-but-set-variable;
	With -Wextra lots of -Wunused-parameter and a few -Wsign-compare.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-10-03  Victor Toso  <me@victortoso.com>

	tests: set binaries to have 'test' name prefix
	To follow test-spice-uri and test-file-transfer standard.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-09-14  Pavel Grunt  <pgrunt@redhat.com>

	widget: Inform about transfer failure
	Call spice_main_file_copy_finish to get result of the transfer

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-09-09  Pavel Grunt  <pgrunt@redhat.com>

	Remove trailing semicolon

2016-09-07  Frediano Ziglio  <fziglio@redhat.com>

	Ignore modifiers messages if no modifiers changed
	This avoid keep sending modifiers changes if guest is not
	synchronising the changes.

	I consider this as an improving as this avoids client to try again
	and again to force synchronisation however this does not prevent
	every unwanted keystroke insertion which possibly can be a real
	problem on some configurations.

	For instance if guest do not handle caps lock as the client do
	if client uses another modifiers (as num lock) this can force
	inserting virtual caps keypress.

	Acked-by: Marc-André Lureau <mlureau@redhat.com>

2016-09-07  Christophe Fergeau  <cfergeau@redhat.com>

	spicy: fix 'tabled' typo
	Acked-by: Marc-André Lureau <mlureau@redhat.com>

2016-09-02  Pavel Grunt  <pgrunt@redhat.com>

	clipboard: Return early if check_clipboard_size_limits() fails
	b0a2ff4 "clipboard: Add fixup_clipboard_text helper"
	mistakenly removed some early returns when text conversion fails for
	some reason. This commit readds it.

	util: Remove unused GError parameter
	The parameter is removed from functions:
	 get_line
	 spice_convert_newlines
	 spice_unix2dos
	 spice_dos2unix

	It was introduced in 75f1ea3ee9c4dbd6c5f27896caee07792bbdbba4
	but never used

	Acked-by: Marc-André Lureau <mlureau@redhat.com>
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-09-01  Jonathon Jongsma  <jjongsma@redhat.com>

	Translate file transfer error messages
	If we are to ever display error messages to a user in a UI, they need to
	be translated.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-09-01  Pavel Grunt  <pgrunt@redhat.com>

	file-transfer: Add guards to public functions
	Acked-by: Victor Toso <victortoso@redhat.com>

	file-transfer: Add documentation for public functions
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-09-01  Christophe Fergeau  <cfergeau@redhat.com>

	clipboard: Use gtk_clipboard_request_text for text data
	Currently, when the agent asks us for VD_AGENT_CLIPBOARD_UTF8_TEXT data,
	spice-gtk looks up for the first X11 target which would provide it with
	UTF8_TEXT data, and uses that for the clipboard request. This means we
	will use UTF8_STRING as the target for gtk_clipboard_request_contents().

	However, some applications who can copy and paste text do not
	necessarily support the UTF8_STRING target. This is the case for Motif
	applications which support the STRING target however. It turns out gtk+
	also provides a gtk_clipboard_request_text() method which will try
	several targets (UTF8_TEXT, COMPOUND_TEXT, TEXT), and will ensure the
	returned string is UTF-8, so we can use that when the agent asks us for
	some text data.

	This fixes https://bugzilla.redhat.com/show_bug.cgi?id=1348624

	clipboard: Add fixup_clipboard_text helper
	This makes clipboard_received_cb a bit shorter, and will be useful
	in the next commit.

2016-08-31  Jonathon Jongsma  <jjongsma@redhat.com>

	Add ability to get sizes from SpiceFileTransferTask
	If a client is handling multiple SpiceFileTransferTasks at one time,
	it's not currently possible to provide a single overall progress to the
	user. The only information that the client can get is the percentage
	progress. This patch adds two new properties:
	 - total-bytes: the size of the file transfer task in bytes
	 - transferred-bytes: the number of bytes already transferred

	This allows a client UI to calculate the combined progress for all
	ongoing transfer tasks and present it to the user. Two convenience
	functions were added to retrieve these values:
	 - spice_file_transfer_task_get_total_bytes()
	 - spice_file_transfer_task_get_transferred_bytes()

2016-08-30  Marc-André Lureau  <marcandre.lureau@redhat.com>

	build-sys: remove PKG_PREREQ
	I added it to make sure AC_SUBST happened, but apparently AC_SUBST
	happens with very old pkg-config versions too, no need to check
	pkg-config pkg.m4 version.

2016-08-26  Christophe Fergeau  <cfergeau@redhat.com>

	mouse: Fix pointer grabbing in server mode
	Trying to click on spice-gtk window while in server mode should result
	in a pointer grab. This is currently failing, with the cursor wrapping
	to the top left corner of the window instead without being grabbed.

	This is caused by our use of gtk_event_box_set_above_child(),
	when clicking on the SpiceWidget, the grab is implicitly taken by
	the window which is above the event box (which is an internal
	GtkEventBox input-only GdkWindow). Then when we call gdk_pointer_grab()
	on the GtkEventBox::window, we get a grab-broken event indicating the
	grab was transferred from the internal input-only window to
	GtkEventBox::window (see gtk+ bug
	https://bugzilla.gnome.org/show_bug.cgi?id=769635#c2 for a detailed
	explanation).

	This commit ignores grab-broken events when the GdkWindow who got the
	grab corresponds to the one we called gdk_pointer_grab() on.
	An alternative would be to call gdk_pointer_grab() on the GdkWindow
	which received the button-press-event, but the call chain between
	button_event() and the eventual gdk_pointer_grab() call, so it would be
	not so elegant to pass the correct GdkWindow all the way.

2016-08-26  Marc-André Lureau  <marcandre.lureau@redhat.com>

	widget: set keypress-delay to 0 on unix socket
	There is no strong need for keypress-delay on local connection (not
	verified: unless the system is heavily loaded, in which case the VM will
	probably be stuck too and may or not repeat the key when running).

	The benefit of removing keypress-delay is that games or interfaces that
	require "realtime" responses, such as FPS, are slightly better without
	the 100ms input delay.

	Acked-by: Victor Toso <victortoso@redhat.com>

	widget: make set_keypress_delay a function
	So the widget can call it without going through g_object_set().

	Acked-by: Victor Toso <victortoso@redhat.com>

	channel: add read-only socket property
	Channel users (such as spice widget) may want to know some connection
	details. Instead of exposing various connection properties, we may as
	well just have a GSocket property, with a strong warning on usage.

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-08-25  Marc-André Lureau  <marcandre.lureau@redhat.com>

	build-sys: simplify checking for x11
	We no longer need the gtk+-quartz/win32 check, however we can simplify
	the x11 check if building gtk+-x11

	Acked-by: Victor Toso <victortoso@redhat.com>

	build-sys: require recent pkg-config
	So we can drop the AC_SUBST for _CFLAGS & _LIBS variable (since 0.24
	but there is no clean way to check that before PKG_PREREQ in 0.29,
	released last year)

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-08-22  Francois Gouget  <fgouget@codeweavers.com>

	streaming: Fix the VideoDecoder queue_frame() documentation
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-08-19  Ian Stakenvicius  <axs@gentoo.org>

	Add missing libX11 reference to build system
	GTK on its own is not enough to ensure libX11 is properly linked with
	libspice-client-gtk.  This patch adds X11_LIBS to SPICE_GTK_LIBADD_COMMON
	(and X11_CFLAGS to a relevant section as well) in src/Makefile.am, and
	performs an approriate pkg-config based check to determine the correct
	values in configure.ac when not building for win32 or quartz.

	For more info see http://bugs.gentoo.org/585118

2016-08-19  Frediano Ziglio  <fziglio@redhat.com>

	Add Italian .po file.
	Acked-by: Marc-André Lureau <mlureau@redhat.com>

	Initialise gettext library properly
	This will allow internationalisation to work correctly.

	Acked-by: Marc-André Lureau <mlureau@redhat.com>

2016-08-16  Pavel Grunt  <pgrunt@redhat.com>

	Do not require epoxy for Windows
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	widget: Fix rendering issues with CSD on Windows
	Replace GDK_WINDOW_HWND by gdk_win32_window_get_impl_hwnd() which gets
	the HWND directly, without any side effects.

	Related:
	https://bugzilla.redhat.com/show_bug.cgi?id=1352216

	Acked-by: Fabiano Fidêncio <fabiano@fidencio.org>

2016-08-12  Francois Gouget  <fgouget@codeweavers.com>

	streaming: Create the pipeline at the same time as the GStreamer decoder
	This lets create_gstreamer_decoder() fail if it cannot create the
	pipeline it needs, allowing the caller to try fallbacks.
	This also means the pipeline has the same lifetime as the decoder which
	makes it possible to remove a check in queue_frame().

	Acked-by: Victor Toso <victortoso@redhat.com>

	streaming: Don't crash if the stream creation fails
	Note that this implies closing the stream before receiving any frame.

	Acked-by: Victor Toso <victortoso@redhat.com>

	streaming: Don't crash if no frame was received before closing the stream
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-08-12  Jonathon Jongsma  <jjongsma@redhat.com>

	Improve file transfer error messages
	In preparation for potentially displaying error messages to a user in a
	UI, I thought I'd improve the messages slightly.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Fix docs for SpiceFileTransferTask::progress
	This property actually represents a fractional value from 0 to 1.0, not
	a percentage between 0 and 100.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-08-11  Francois Gouget  <fgouget@codeweavers.com>

	streaming: Check the stream id in display_update_stream_report() too
	It's safer and more consistent than assuming the caller has done the
	check already.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-08-10  Pavel Grunt  <pgrunt@redhat.com>

	vmcstream: Do not disconnect cancellable in coroutine
	It is disconnected when spice_vmc_input_stream_read_all_finish()
	is called.

	Silence many warnings appearing with webdav:
	 GLib-GObject-WARNING **: gsignal.c:2635: instance '0x7fe658015c40' has no handler with id '13555'

	Acked-by: Victor Toso <victortoso@redhat.com>

	channel-webdav: Remove extra SpiceWebdavChannel parameter
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-08-10  Victor Toso  <victortoso@redhat.com>

	file-transfer: improve GHashTable with value_destroy_func
	By using g_hash_table_new_full() we can unref its value which is the
	SpiceFileTransferTask. This makes the code a little bit simpler as
	nowhere we use the xfer-task after removing it from hash table.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	file-transfer: increase reference for channel-main
	SpiceMainChannel uses the SpiceFileTransferTask reference given in the
	hash table provided by spice_file_transfer_task_create_tasks(). That
	means SpiceFileTransferTask is not holding a reference for itself but
	it relies on it due the async calls it provides.

	This patch increases the reference of each SpiceFileTransferTask for
	the hash table which will be unref'ed by channel-main in
	file_transfer_operation_task_finished(); the original reference is
	kept to SpiceFileTransferTask to be freed after the finish signal is
	emitted on spice_file_transfer_task_close_stream_cb().

	This patch fixes some critical warnings as we have two g_object_unref
	but only one reference.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	channel-main: make debug helpful in case of failures
	Debug should come before the g_return_if_fail() otherwise we lose
	important debug data.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	channel-main: improve code to use FileTransferOperation
	Since commit b26818d0e00666 we are grouping all transferred files per
	operation (drag and drop); That leaded to some design flaws in the
	code. The changes suggested in this patch are (in execution order):

	* On spice_file_transfer_task_read_async()
	- Passing FileTransferOperation data so in the callback and in further
	  function calls, we don't need to look for this;

	Note that FileTransferOperation is not freed while any of its
	SpiceFileTransferTask exists and by design they are never finished
	while on pending state, so file_xfer_read_async_cb() should have a
	valid FileTransferOperation pointer.

	* On file_xfer_read_async_cb()
	- Removed unnecessary variables;

	* On file_xfer_flush_async()
	- Using SpiceFileTransferTask as parameter which can retrieve the
	  SpiceMainChannel and the GCancellable;
	- Using SpiceFileTransferTask as source_object for GTask with
	  FileTransferOperation as user_data which is helpful for its
	  callback;

	* On file_xfer_flush_finish() and file_xfer_data_flushed_cb()
	- Using SpiceFileTransferTask as parameter and source_object check for
	  GTask

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	file-transfer: Move initializations to _task_new()
	This was a request introduced at f6b3b697093a16de to be done after
	moving the SpiceFileTransferTask code to its own file.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-08-05  Christophe Fergeau  <cfergeau@redhat.com>

	wocky: Pass GTask around instead of ConnectAsyncData
	Now that the ConnectAsyncData we need is set as GTask data, we can pass
	around the GTask rather than the ConnectAsyncData instance, and remove
	the GTask pointer from it. We can get the ConnectAsyncData from the
	GTask when needed using g_task_get_task_data().

	wocky: Set ConnectAsyncData instance as GTask data
	Currently, the ConnectAsyncData instance is leaked if for example
	we trigger one codepath calling g_task_return_error(). If we
	associate it with the GTask with g_task_set_task_data(),
	this kind of leak will be avoided.

	wocky: Simplify wocky_http_proxy_connect_finish()
	Rather than returning the whole ConnectAsyncData struct with
	g_task_return_pointer(), we can return only the GIOStream object as this
	is what we are interested in.

	This has the side-effect of fixing a ConnectAsyncData leak as after
	calling g_task_propagate_pointer() the old code had ownership of the
	ConnectAsyncData instance but was never freeing it.

	The leak is:
	==20010== 4,348 (56 direct, 4,292 indirect) bytes in 1 blocks are definitely lost in loss record 20,762 of 20,999
	==20010==    at 0x4C2DA60: calloc (vg_replace_malloc.c:711)
	==20010==    by 0xD0F6EB0: g_malloc0 (gmem.c:124)
	==20010==    by 0x75C0978: wocky_http_proxy_connect_async (wocky-http-proxy.c:359)
	==20010==    by 0xCB4E22C: g_socket_client_connected_callback (gsocketclient.c:1548)
	==20010==    by 0xCB57342: g_task_return_now (gtask.c:1107)
	==20010==    by 0xCB579E5: g_task_return (gtask.c:1165)
	==20010==    by 0xCB4FB1C: g_socket_connection_connect_callback (gsocketconnection.c:236)
	==20010==    by 0xCB47160: socket_source_dispatch (gsocket.c:3543)
	==20010==    by 0xD0F1702: g_main_dispatch (gmain.c:3154)
	==20010==    by 0xD0F1702: g_main_context_dispatch (gmain.c:3769)
	==20010==    by 0xD0F1AAF: g_main_context_iterate.isra.29 (gmain.c:3840)
	==20010==    by 0xD0F1B5B: g_main_context_iteration (gmain.c:3901)
	==20010==    by 0xCB7D58C: g_application_run (gapplication.c:2381)
	==20010==    by 0x41571C: main (remote-viewer-main.c:42)

2016-08-03  Christophe Fergeau  <cfergeau@redhat.com>

	spicy: Fix spice_file_transfer_task_get_filename leak
	It was wrongly annotated as (transfer none)

	An alternative would be to store what is returned by
	g_file_get_basename() in SpiceFileTransferTask and return that, this
	would allow to make spice_file_transfer_task_get_filename() (transfer
	none) without leaking memory.

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-08-03  Victor Toso  <victortoso@redhat.com>

	channel-main: avoid race around file-transfer flush
	This patch avoids a race condition. The race happens when we mark the
	xfer-task as completed by receiving VD_AGENT_FILE_XFER_STATUS_SUCCESS
	message while the flush callback was not yet called.

	The flush callback is file_xfer_data_flushed_cb() and it might not be
	called immediately after data is flushed.

	The race can be verified while transferring several small files at
	once. I can see it often with more then 50 files in one transfer
	operation.

	This fix implies that SpiceMainChannel should check in its async
	callbacks if given SpiceFileTransferTask is completed.

	This patch introduces spice_file_transfer_task_is_completed (internal)
	to help check if spice_file_transfer_task_completed() was called or
	not.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-08-03  Christophe Fergeau  <cfergeau@redhat.com>

	file-transfer: avoid potential leaks
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-08-03  Victor Toso  <victortoso@redhat.com>

	file-transfer: Fix SpiceFileTransferTask::error leak
	The self->error is the error set for the file-transfer and it will be
	propagated with the "finish" signal. As this is transfer none pointer,
	we should not lose its reference on g_task_return_error and we should
	clear it out afterwards.

	40 (16 direct, 24 indirect) bytes in 1 blocks are definitely lost in
	loss record 7,489 of 14,298
	 at 0x4C2BBAD: malloc (vg_replace_malloc.c:299)
	 by 0xB5090E8: g_malloc (gmem.c:94)
	 by 0xB51F8A2: g_slice_alloc (gslice.c:1025)
	 by 0xB4EFCC5: g_error_new_literal (gerror.c:471)
	 by 0xB4EFFAD: g_set_error_literal (gerror.c:619)
	 by 0xAF13397: g_cancellable_set_error_if_cancelled (gcancellable.c:314)
	 by 0xAF630C8: g_task_propagate_error (gtask.c:1519)
	 by 0xAF63CD8: g_task_propagate_int (gtask.c:1652)
	 by 0x50863F5: spice_file_transfer_task_read_finish (spice-file-transfer-task.c:477)
	 by 0x5093239: file_xfer_read_async_cb (channel-main.c:1811)
	 by 0xAF62F38: g_task_return_now (gtask.c:1121)
	 by 0xAF63775: g_task_return (gtask.c:1179)

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-08-03  Christophe Fergeau  <cfergeau@redhat.com>

	file-transfer: Fix SpiceFileTransferTask::file_stream leak
	g_file_read_finish() is (transfer full) so we must release the ref
	we got in _dispose() as it's not done anywhere else in the code.

	Acked-by: Victor Toso <victortoso@redhat.com>

	file-transfer: Fix GTask leaks
	The file transfer code calls g_*_async() methods with a GTask as the
	user_data argument. It needs to own a reference to the GTask for the
	duration of the async call to keep the GTask alive, however it was never
	releasing it when it no longer needs it (that is, after calling
	g_task_return_*).

	Some of the leaks fixed by this patch are:

	* GTask leak after flush
	11,232 bytes in 54 blocks are definitely lost in
	loss record 14,018 of 14,071
	 at 0x4C2BBAD: malloc (vg_replace_malloc.c:299)
	 by 0xC14A0E8: g_malloc (gmem.c:94)
	 by 0xC1608A2: g_slice_alloc (gslice.c:1025)
	 by 0xC160ECD: g_slice_alloc0 (gslice.c:1051)
	 by 0xBEDBD11: g_type_create_instance (gtype.c:1857)
	 by 0xBEBD7DA: g_object_new_internal (gobject.c:1781)
	 by 0xBEBF11C: g_object_newv (gobject.c:1928)
	 by 0xBEBF89B: g_object_new (gobject.c:1621)
	 by 0xBBA4424: g_task_new (gtask.c:693)
	 by 0x6F8C3C0: file_xfer_flush_async (channel-main.c:899)
	 by 0x6F8C3C0: file_xfer_read_async_cb (channel-main.c:1826)
	 by 0xBBA3F38: g_task_return_now (gtask.c:1121)
	 by 0xBBA4775: g_task_return (gtask.c:1179)

	* GTask leak from spice_main_file_copy_async()
	208 bytes in 1 blocks are definitely lost in
	loss record 13,708 of 15,093
	 at 0x4C2BBAD: malloc (vg_replace_malloc.c:299)
	 by 0xC14A0E8: g_malloc (gmem.c:94)
	 by 0xC1608A2: g_slice_alloc (gslice.c:1025)
	 by 0xC160ECD: g_slice_alloc0 (gslice.c:1051)
	 by 0xBEDBD11: g_type_create_instance (gtype.c:1857)
	 by 0xBEBD7DA: g_object_new_internal (gobject.c:1781)
	 by 0xBEBF11C: g_object_newv (gobject.c:1928)
	 by 0xBEBF89B: g_object_new (gobject.c:1621)
	 by 0xBBA4424: g_task_new (gtask.c:693)
	 by 0x6F8EF55: spice_main_file_copy_async (channel-main.c:3084)

	Acked-by: Victor Toso <victortoso@redhat.com>

	test-file-transfer: Don't leak GError
	Acked-by: Victor Toso <victortoso@redhat.com>

	test-file-transfer: Don't leak GFileInfo
	The GFileInfo returned by spice_file_transfer_task_init_task_finish()
	must be unref'ed when no longer needed.

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-07-29  Victor Toso  <victortoso@redhat.com>

	file-transfer: remove unused function for debug
	This is here due bad rebase. It was removed and replaced by patch
	f6072e678ea5 but not removed from 1af22e9652ddcbdd426cd "file-xfer:
	move to spice-file-transfer-task.c", so the function is there, unused.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-07-29  Pavel Grunt  <pgrunt@redhat.com>

	session: Fix IPv6 by using g_network_address_parse
	It supports quoting the address with []

	Regression since ea37f06eaa11b6307c797895aeb85d87d142625a

	Fixes:
	https://bugzilla.redhat.com/show_bug.cgi?id=1361478

2016-07-29  Christophe Fergeau  <cfergeau@redhat.com>

	vmc: Fix leak in spice_vmc_output_stream_write_finish()
	We own a reference on the GAsyncResult returned by
	g_task_propage_pointer() so we have to g_object_unref() it when we no
	longer need it.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2016-07-29  Fabiano Fidêncio  <fidencio@redhat.com>

	vmcstream: set the right result for the task
	This bogus code was introduced when switching to GTask API. Seems that
	while writing those patches I just overlooked this part and set the wrong
	result for the task. As part of the problems introduced (and now fixed)
	you can notice that no output stream was being sent to the guest.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-07-28  Pavel Grunt  <pgrunt@redhat.com>

	webdav: Do not reuse cancellable
	Create it on SPICE_PORT_EVENT_OPENED

	From g_cancellable_reset documentation:
	 Note that it is generally not a good idea to reuse an existing
	 cancellable for more operations after it has been cancelled once,
	 as this function might tempt you to do. The recommended practice is
	 to drop the reference to a cancellable after cancelling it, and let it
	 die with the outstanding async operations. You should create a fresh
	 cancellable for further async operations

	In our case reusing the cancellable leads to a crash:
	 #0  0x00007ffff1662940 in g_task_return_error () at /lib64/libgio-2.0.so.0
	 #1  0x00007ffff1662b60 in g_task_return_new_error () at /lib64/libgio-2.0.so.0
	 #2  0x00007ffff57916e0 in read_cancelled (cancellable=<optimized out>, user_data=<optimized out>) at vmcstream.c:182
	 #3  0x00007ffff1391555 in g_closure_invoke () at /lib64/libgobject-2.0.so.0
	 #4  0x00007ffff13a4062 in signal_emit_unlocked_R () at /lib64/libgobject-2.0.so.0
	 #5  0x00007ffff13acf5f in g_signal_emit_valist () at /lib64/libgobject-2.0.so.0
	 #6  0x00007ffff13ad33f in g_signal_emit () at /lib64/libgobject-2.0.so.0
	 #7  0x00007ffff16100d8 in g_cancellable_cancel () at /lib64/libgio-2.0.so.0
	 #8  0x00007ffff5775c01 in port_event (self=0xc7af60, event=1) at channel-webdav.c:512
	 #9  0x00007ffff1391555 in g_closure_invoke () at /lib64/libgobject-2.0.so.0
	 #10 0x00007ffff13a445d in signal_emit_unlocked_R () at /lib64/libgobject-2.0.so.0
	 #11 0x00007ffff13acf5f in g_signal_emit_valist () at /lib64/libgobject-2.0.so.0
	 #12 0x00007ffff577479a in emit_main_context (opaque=0x7fffa5fff8d0) at gio-coroutine.c:200
	 #13 0x00007ffff10b7847 in g_idle_dispatch () at /lib64/libglib-2.0.so.0
	 #14 0x00007ffff10bade2 in g_main_context_dispatch () at /lib64/libglib-2.0.so.0
	 #15 0x00007ffff10bb160 in g_main_context_iterate.isra () at /lib64/libglib-2.0.so.0
	 #16 0x00007ffff10bb20c in g_main_context_iteration () at /lib64/libglib-2.0.so.0
	 #17 0x00007ffff1677d2d in g_application_run () at /lib64/libgio-2.0.so.0
	 #18 0x000000000041031a in main (argc=2, argv=0x7fffffffd928) at remote-viewer-main.c:42

	Fixes:
	https://bugs.freedesktop.org/show_bug.cgi?id=97113

2016-07-28  Lukas Venhoda  <lvenhoda@redhat.com>

	spice-widget: init egl only after first gl_scanout
	When using GtkDrawingArea and EGL was not used, it was still initialized.
	This produced warning messages on systems where EGL is not supported.

	Move spice_egl_init from drawing_area_realize to gl_scanout.

	Fixes:
	https://bugs.freedesktop.org/show_bug.cgi?id=95254

2016-07-28  Marc-André Lureau  <marcandre.lureau@redhat.com>

	misc: code style
	Brace on new line for functions, 4 spaces indent, seperate end block

	usbredir: fix leaks introduced by lz4 patch
	While reviewing lz4 patch, I found that there are potential leaks. This
	is untested, fyi. It would be nice if someone could confirm with running
	ASAN for example.

	Reviewed-by: Snir Sheriber <ssheribe@redhat.com>

2016-07-27  Frediano Ziglio  <fziglio@redhat.com>

	Handle pause key correctly
	Windows does not like Pause key sent with same scancodes as Break.
	Although is the same physical key the two functions send two completely
	different set of codes. On key press a E1 1D 45 sequence is generated
	while on key release a E1 9D C5 is generated. Also some hardware
	keyboards send press+release at the same time on key press (nothing on
	release).
	Tested with Linux and Windows clients.
	Tested with Linux, Windows and DOS guests.
	On Windows guest VK_PAUSE was not arriving correctly.

	An additional send_pause function was added to avoid to change the
	normal flow too much. This as the keymap table (generated from
	src/keymaps.csv) can hold only one scancode while this key generate two
	scancodes (ie E1-1D and 45) for each event.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-07-26  Frediano Ziglio  <fziglio@redhat.com>

	Support more extension codes
	Not only E0 prefix but also E1 and E2.
	They are used in some special cases, one is the pause key.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-07-14  Jonathon Jongsma  <jjongsma@redhat.com>

	SpiceWidget: limit scope of 'area' variable
	'area' was being set within the 'else' branch, but was not actually
	used. So just move the declaration of 'area' within the if statement
	where it is actually used. This potentially avoids "set-but-not-used"
	warnings when GDK_WINDOWING_X11 is not defined.

2016-07-14  Eduardo Lima (Etrunko)  <etrunko@redhat.com>

	configure: Add ${top_builddir}/spice-common to COMMON_CFLAGS
	This fixes the build when done out of the tree, because of recent commit
	in spice-common with auto-generated files.

2016-07-13  Eduardo Lima (Etrunko)  <etrunko@redhat.com>

	Use correct variable to print if LZ4 support is to be built.

2016-07-11  Snir Sheriber  <ssheribe@redhat.com>

	Usbredir: enable lz4 compression
	Compressed message type is CompressedData which contains compression
	type (1 byte) followed by the uncompressed data size (4 bytes-exists
	only if data was compressed) followed by the compressed data

	If SPICE_SPICEVMC_CAP_DATA_COMPRESS_LZ4 capability is available &&
	data_size > COMPRESS_THRESHOLD && !AF_LOCAL data will be sent
	compressed otherwise data will be sent uncompressed (as well if
	compression has failed)

	Update required spice-protocol to 0.12.12

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-07-11  Victor Toso  <victortoso@redhat.com>

	Update spice-common submodule

2016-07-07  Marc-André Lureau  <marcandre.lureau@redhat.com>

	util: fix off-by-one array access
	Thanks to ASAN, I found this off-by-one memory access in the unix2dos
	code:

	/util/unix2dos: =================================================================
	==23589==ERROR: AddressSanitizer: heap-buffer-overflow on address 0x60200000dd2f at pc 0x00000040428e bp 0x7ffd6fc31b90 sp 0x7ffd6fc31b80
	READ of size 1 at 0x60200000dd2f thread T0
	    #0 0x40428d in spice_convert_newlines /home/elmarco/src/spice/spice-gtk/src/spice-util.c:355
	    #1 0x40443a in spice_unix2dos /home/elmarco/src/spice/spice-gtk/src/spice-util.c:382
	    #2 0x401eae in test_unix2dos /home/elmarco/src/spice/spice-gtk/tests/util.c:69
	    #3 0x7fb8bcd81983  (/lib64/libglib-2.0.so.0+0x6e983)
	    #4 0x7fb8bcd81b4e  (/lib64/libglib-2.0.so.0+0x6eb4e)
	    #5 0x7fb8bcd81d5d in g_test_run_suite (/lib64/libglib-2.0.so.0+0x6ed5d)
	    #6 0x7fb8bcd81d80 in g_test_run (/lib64/libglib-2.0.so.0+0x6ed80)
	    #7 0x402cce in main /home/elmarco/src/spice/spice-gtk/tests/util.c:207
	    #8 0x7fb8bc755730 in __libc_start_main (/lib64/libc.so.6+0x20730)
	    #9 0x401818 in _start (/home/elmarco/src/spice/spice-gtk/tests/util+0x401818)

	0x60200000dd2f is located 1 bytes to the left of 4-byte region [0x60200000dd30,0x60200000dd34)
	allocated by thread T0 here:
	    #0 0x7fb8c10421d0 in realloc (/lib64/libasan.so.3+0xc71d0)
	    #1 0x7fb8bcd61f1f in g_realloc (/lib64/libglib-2.0.so.0+0x4ef1f)

	SUMMARY: AddressSanitizer: heap-buffer-overflow /home/elmarco/src/spice/spice-gtk/src/spice-util.c:355 in spice_convert_newlines

	doc: fix unused warning
	Fix gtk-doc warning by ignoring the new private header.

	./spice-gtk-unused.txt:1: warning: 12 unused declarations.They should be
	added to spice-gtk-sections.txt in the appropriate place.

	While at it, fix grabsequence header incorrect file name.

2016-07-07  Victor Toso  <victortoso@redhat.com>

	tests: file-transfer agent cancel
	Agent only can only send error or cancel from a transfer operation
	after it was initialized. From SpiceFileTransferTask point of view,
	error and cancellation is an GError with different code so testing
	only cancel seems enough.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	tests: file-transfer cancel on read async
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	tests: file-transfer cancel on task init
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	tests: file-transfer include simple tests
	This only includes a simple test for file-transfer with a small
	summary of the possible situations of the test.

	As the test is specifically for SpiceFileTransferTask, we don't create
	a SpiceMainChannel.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	file-xfer: move to spice-file-transfer-task.c
	This patch moves:
	* GObject boilerplate
	* External API related to SpiceFileTransferTask
	* Internal API needed by channel-main
	* Helpers that belong to this object

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	main: use xfer_task instead of task or self
	Another patch to rename variable and keep consistency across
	channel-main. Let's avoid task which is common for GTask and self for
	non SpiceMainChannel objects

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	file-xfer: move debug to SpiceFileTransferTask
	This debug information is simple way to check that the file-transfer
	is not stalled. Now that we are using the read-async functions, we can
	move this debug info there and avoid accessing object internals in
	channel-main.c

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	file-xfer: Keep namespace of private function
	Rename:
	* file_xfer_close_cb -> spice_file_transfer_task_close_stream_cb

	As this will be private to SpiceFileTransferTask

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	file-xfer: call user callback once per operation
	SpiceFileTransferTask has a callback to be called when operation
	ended. Til this patch, we were setting the user callback which means
	that in multiple file-transfers, we were calling the user callback
	several times.

	Following the same logic pointed from 113093dd00a1cf10f6d3c3589b7 this
	is a SpiceMainChannel operation and it should only call the user
	callback when this operation is over (FileTransferOperation now).

	Highlights:
	* Now using GTask to set user callback and callback_data
	* Handling error on FileTransferOperation:
	- It is considered an error if no file was successfully transferred due
	  cancellations or any other kind of error;
	- If any file failed due any error, we will consider the operation a
	  failure even if other files succeed.

	Note also that SpiceFileTransferTask now does not have a callback and
	callback_data. The xfer_tasks has ended after its "finish" signal is
	emitted.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	file-xfer: call progress_callback per FileTransferOperation
	Before this patch, the progress_callback is being called from
	SpiceFileTransferTask each time that some data is flushed to the agent
	of this given xfer-task. The progress value is computed by iterating
	on all available xfer-tasks.

	This patch intend to fix/change:

	* The progress_callback should be called only with information related
	  to the FileTransferOperation of given xfer-task; This was also
	  suggested by 113093dd00a1cf10f6d3c3589b7589a184cec081;

	* In case a SpiceFileTransferTask is cancelled or has an error, we
	  remove the remaining bytes (not sent) of this file from the
	  transfer_size;

	* The progress_callback should not be done from SpiceFileTransferTask
	  context by (proposed) design. As the transfer operation starts in
	  spice_main_file_copy_async(), FileTransferOperation should handle
	  these calls.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	file-xfer: inform agent of errors only when task finished
	No need to inform of a problem under
	spice_file_transfer_task_completed() as the task will be finalized and
	we can send the error to the agent there.

	This change is related to split SpiceFileTransferTask from
	channel-main.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	file-xfer: a FileTransferOperation per transfer call
	Each call to spice_main_file_copy_async will now create a
	FileTransferOperation which groups all SpiceFileTransferTasks of the
	copy operation in a GHashTable.

	To ease the review process, this first patch introduces the structure
	and organize the logic around the four following helpers:

	* spice_main_channel_reset_all_xfer_operations
	* spice_main_channel_find_xfer_task_by_task_id
	* file_transfer_operation_free
	* file_transfer_operation_task_finished

	The _task_finished function is the new callback for "finished" signal
	from SpiceFileTransferTask.

	The file_xfer_tasks GHashTable is now mapped as:
	 (key) SpiceFileTransferTask ID -> (value) FileTransferOperation

	This patch leaves a FIXME regarding progress_callback which will be
	addressed in a later patch in this series.

	This change is related to split SpiceFileTransferTask from
	channel-main.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	file-xfer: create helper function to send progress
	This is an intermediary step for the following patches to make the
	changes more clear and easy to follow.

	In file_xfer_send_progress(), I've renamed the variable self to
	xfer_task as this is not SpiceFileTransferTask function.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	file-xfer: improve helper function to queue agent message
	This patch changes:
	* rename function: file_xfer_queue -> file_xfer_queue_msg_to_agent
	  As it makes more clear what this helper function does;
	* Use buffer provided by spice_file_transfer_task_read_finish()
	  instead of accessing SpiceFileTransferTask's private structure

	This change is related to split SpiceFileTransferTask from
	channel-main.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	main: do not check for xfer-task errors
	The errors related to SpiceFileTransferTask can be present:
	* before the flush happens, on spice_file_transfer_task_read_async()
	* during the async flush:
	  - cancel from user which is handled by file_xfer_flush_async
	  - cancel/error from agent, handled on main_agent_handle_xfer_status()

	file_xfer_flush_finish() should not check internal errors of
	SpiceFileTransferTask and only be worried about errors regarding the
	flush itself.

	Note that with or without this patch, in case of errors from agent, we
	don't stop the flushing; it is only cancelled from user cancellation.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	main: let channel-main handle file-xfer messages
	By separating SpiceFileTransferTask from channel-main, we could choose
	where to put the handler for messages. With the approach based on
	spice_file_transfer_task_read_async(), we cannot have it under
	spice-file-transfer-task.c due the need of callback and userdata on
	_read_async.

	It is much easier to keep this in channel-main and do not move any
	VDAgent.

	This patch reverts 349a52ca2d6af4b31a4f51c38a3292c04460953c changes
	but it does rename:
	- function file_xfer_handle_status -> main_agent_handle_xfer_status
	- variables task to xfer_task

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	main: to let SpiceFileTransferTask handle errors
	* on VD_AGENT_FILE_XFER_STATUS_CAN_SEND_DATA, if the file-transfer is
	  on pending state, spice_file_transfer_task_read_async() will call the
	  callback with error set.

	* on VD_AGENT_FILE_XFER_STATUS_SUCCESS, if the file-transfer is on
	  pending state, spice_file_transfer_task_completed() will set the
	  error for this task.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	file-xfer: introduce functions to read file async
	Introduced functions (private):
	* void   spice_file_transfer_task_read_async()
	* gssize spice_file_transfer_task_read_finish()

	For a better abstraction of how to read from SpiceFileTransferTask and
	handle its data, following the design of other objects like GFile and
	GInputStream.

	Due to the logic changes involved, some functions were created or
	renamed to better address or match its place and purpose:

	* spice_file_transfer_task_read_stream_cb
	  Callback for the actual read from GInpustStream; This is handling
	  the SpiceFileTransferTask bits only;

	* file_xfer_read_cb -> file_xfer_read_async_cb
	  Renamed to match _read_async() function; This is handling the data
	  from reading the file by flushing it to the agent.

	As the _read_async() uses GTask, the error handling is done on the
	channel-main's callback, after _read_finish() is called.

	This change is related to split SpiceFileTransferTask from
	channel-main.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	file-xfer: introduce functions to init task async
	Introduced functions (private):
	* void       spice_file_transfer_task_init_task_async()
	* GFileInfo *spice_file_transfer_task_init_task_finish()

	The init process of SpiceFileTransferTask does initialize its
	GFileInputStream (for reading the file) and also its GFileInfo
	(necessary to protocol in order to start the file-transfer with agent)

	Due the logic changed involved, some functions were renamed to better
	match its place and purpose:

	* file_xfer_info_async_cb -> file_xfer_init_task_async_cb
	  It is channel-main's callback for each _init_task_async()

	* file_xfer_read_async_cb -> spice_file_transfer_task_read_file_cb
	* file_xfer_info_async_cb -> spice_file_transfer_task_query_info_cb
	  Both should be private to SpiceFileTransferTask now.

	As the _init_task_async() uses GTask, some error handling was moved to
	channel-main's after _init_task_finish() is called.

	This change is related to split SpiceFileTransferTask from
	channel-main.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	file-xfer: introduce _create_tasks()
	We can split from file_xfer_send_start_msg_async() the logic in
	creating the SpiceFileTransferTasks; The rest of the function can be
	handled at spice_main_file_copy_async().

	The new function, spice_file_transfer_task_create_tasks() returns a
	GHashTable to optimize the access to a SpiceFileTransferTask from its
	task-id, which is what we receive from the agent.

	This change is related to split SpiceFileTransferTask from
	channel-main.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	file-xfer: get functions for SpiceFileTransferTask
	In order for channel-main to interact with each SpiceFileTransferTask
	for the file-transfer operation, the following functions are
	introduced:
	* spice_file_transfer_task_get_id
	* spice_file_transfer_task_get_channel
	* spice_file_transfer_task_get_cancellable

	Note that "id" property is public and could be acquired by
	g_object_get but having the helper function is more practical.

	This change is related to split SpiceFileTransferTask from
	channel-main.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	file-xfer: task-id to start with 1
	As this is unsigned, we can let 0 be in case of error

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-30  Christophe Fergeau  <cfergeau@redhat.com>

	usb-device-manager: Avoid USB event thread leak
	This is a follow-up of the previous commit ('usb-channel: Really stop
	listening for USB events on disconnection').

	Since the USB event thread has to be stopped when we destroy the
	associated SpiceUsbDeviceManager, spice_usb_device_manager_dispose()
	should force event_thread_run to FALSE even if
	spice_usb_device_manager_stop_event_listening() was not enough. When
	this happens, this means that there is a bug in the internal users of
	spice_usb_device_manager_start_event_listening(), but with this change,
	we'll at least warn about it, and avoid a thread leak/potential future
	crash.

	usb-channel: Really stop listening for USB events on disconnection
	When using USB redirection, it's fairly easy to leak the thread handling
	USB events, which will eventually cause problems in long lived apps.
	In particular, in virt-manager, one can:
	- start a VM
	- connect to it with SPICE
	- open the USB redirection window
	- redirect a device
	- close the SPICE window
	-> the SpiceUsbDeviceManager instance will be destroyed (including the
	USB context it owns), but the associated event thread will keep running.
	Since it's running a loop blocking on libusb_handle_events(priv->context),
	the loop will eventually try to use the USB context we just destroyed
	causing a crash.

	We can get in this situation when redirecting a USB device because we
	will call spice_usb_device_manager_start_event_listening() in
	spice_usbredir_channel_open_device(). The matching
	spice_usb_device_manager_stop_event_listening() call is supposed to
	happen in spice_usbredir_channel_disconnect_device(), however by the
	time it's called in the scenario described above, the session associated
	with the channel will already have been set to NULL in
	spice_session_channel_destroy().

	The session is only needed in order to get the SpiceUsbDeviceManager
	instance we need to call spice_usb_device_manager_stop_event_listening()
	on. This patch stores it in SpiceChannelUsbredir instead, this way we
	don't need SpiceChannel::session to be non-NULL during device
	disconnection.

	This should fix the issues described in
	https://bugzilla.redhat.com/show_bug.cgi?id=1217202
	(virt-manager) and most
	likely https://bugzilla.redhat.com/show_bug.cgi?id=1337007 (gnome-boxes)
	as well.

	usb: Update outdated GSimpleAsyncResult comment
	It's still true after the switch to GTask.

	usbredir: Use atomic for UsbDeviceManager::event_thread_run
	This variable is accessed from 2 different threads (main thread and USB
	event thread), so some care must be taken to read/write it.

2016-06-30  Marc-André Lureau  <marcandre.lureau@redhat.com>

	usbredir: mark some functions as internal
	For the sake of making clear those are not exported.

2016-06-30  Christophe Fergeau  <cfergeau@redhat.com>

	usbredir: Fix GTask leak
	spice_usbredir_channel_disconnect_device_async() creates a GTask and
	then calls g_task_run_in_thread(). This method will take the reference
	it needs on the GTask, it does not take ownership of the passed-in
	GTask. This means we need to unref the GTask we created after calling
	g_task_run_in_thread(), otherwise we are going to leak the GTask, as
	well as the channel it's associated with.
	Since it's an USB redir channel, this also causes some USB device
	manager/USB event thread leaks.

2016-06-21  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Update NEWS for 0.32 release

2016-06-21  Pavel Grunt  <pgrunt@redhat.com>

	session: Keep brackets around ipv6 hostname
	According to rfc2732:
	"To use a literal IPv6 address in a URL, the literal address should be
	enclosed in "[" and "]" characters."

	Resolves: rhbz#1331777

	Acked-by: Marc-André Lureau <mlureau@redhat.com>

	session: Removed write-only variable
	Acked-by: Marc-André Lureau <mlureau@redhat.com>

2016-06-21  Marc-André Lureau  <marcandre.lureau@redhat.com>

	mailmap: fix my name

2016-06-21  Victor Toso  <victortoso@redhat.com>

	main: channel-main to increase file-transfer reference
	This is a minor fix in the logic as in both situations (with or
	without the patch) the reference count for the SpiceFileTransferTask
	object is the same.

	The change is interesting as SpiceFileTransferTask is created but on
	g_file_read_async() it increases its reference count while
	c->file_xfer_tasks keeps the original one.

	It should be the other way around.
	Acked-by: Marc-André Lureau <marcandre.lureau@gmail.com>

	main: assign variable after check for null
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-06-20  Christophe Fergeau  <cfergeau@redhat.com>

	build: Fix _DEPENDENCIES use
	We want to trigger rebuild of libspice-client-gtk-3.0.la or
	libspice-client-glib-2.0.la whenever the corresponding symbol file
	changes.
	However _DEPENDENCIES is not the right way of handling that as it will
	disable automatic automake dependency generation.
	This was not causing issues mainly because _DEPENDENCIES was mispelt as
	_DEPEDENCIES.

	Quoting automake manual:
	https://www.gnu.org/software/automake/manual/automake.html#index-EXTRA_005fmaude_005fDEPENDENCIES-1
	« The EXTRA_*_DEPENDENCIES variable may be useful for cases where you
	merely want to augment the automake-generated _DEPENDENCIES variable
	rather than replacing it. »

	So this commit switches to use EXTRA_*_DEPENDENCIES rather than
	*_DEPENDENCIES.

2016-06-20  Marc-AndrÃ© Lureau  <marcandre.lureau@redhat.com>

	build-sys: fix win32 build
	Commit 0fafbe3 broke the build on win32, because it accesses
	d->egl.enabled. Add a helper function and fix the build.

	Reported-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	vncdisplaykeymap: fix -Werror=tautological-compare
	vncdisplaykeymap.c: In function 'vnc_display_keymap_gdk2xtkbd_table':
	vncdisplaykeymap.c:223:14: error: self-comparison always evaluates to true [-Werror=tautological-compare]
	  if (GDK_IS_WIN32_WINDOW(window)) {

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-06-20  Marc-André Lureau  <marcandre.lureau@redhat.com>

	widget: fix keyboard ungrab after click
	Since the switch to a container widget (gtkstack then gtkeventbox), the
	grab may be lost when clicking on the display. Since events are treated
	at the top level container, set widget "above-child" to trap all of them
	to solve this.

	Fixes:
	https://bugs.freedesktop.org/show_bug.cgi?id=96595

	Reported-by: Frediano Ziglio <fziglio@redhat.com>
	Tested-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2016-06-20  Marc-André Lureau  <marcandre.lureau@gmail.com>

	widget: use scanout offset when using virgl
	Ignoring the display area offset doesn't work nicely with virgl. Imho,
	this condition is wrong even in QXL case.

2016-06-17  Alexandru Visarion  <viorel.visarion@gmail.com>

	channel-main: Fix spice_main_file_copy_async annotation
	Without (array zero-terminated=1), one null terminated array
	parameter is translated into a single element, so its binding
	isn't usable.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-06-16  Frediano Ziglio  <fziglio@redhat.com>

	widget: Disable IME context on display widget
	This prevent Windows to handle IME on the widget which cause the
	application to not receive keyboard events.

	To test this issue set keyboard layout to Japanese and Microsoft
	IME (the default one). Set the input method to full katakana, assure
	your remote-viewer is using this method and start pressing
	alphabetical keys. On the guest (open a terminal, an editor or
	a word processor to make easier) you won't see any character.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-06-15  Christophe Fergeau  <cfergeau@redhat.com>

	main: Don't delay update_display_timer(0) for up to 1 second
	When using remote-viewer --full-screen with a VM/client with multiple
	monitors, a race can be observed during auto-configuration. First, the
	client monitors config is sent to the guest:
	(remote-viewer:19480): GSpice-DEBUG: channel-main.c:1166 main-1:0: sending new monitors config to guest
	(remote-viewer:19480): GSpice-DEBUG: channel-main.c:1183 main-1:0: monitor #0: 1920x1080+0+0 @ 32 bpp
	(remote-viewer:19480): GSpice-DEBUG: channel-main.c:1183 main-1:0: monitor #1: 1920x1080+1920+0 @ 32 bpp

	Then we receive messages from the agent which trigger a call to
	update_display_timer(0)

	This should cause the current monitors state to be sent to the server
	very soon after this call. However, in the racy case, this is delayed
	for nearly a second, and timer_set_display() ends up being called at the
	wrong time, when information about the first display channel have been
	received from the server, but not the second one.

	When this happens, we inform the server that only one monitor is active,
	then the server sends a MonitorsConfig message with 2 monitors (first
	request we sent), and then with just 1 monitor (second request we sent).

	This causes remote-viewer to show one fullscreen black window indicating
	"Connected to server" on one monitor and a working fullscreen window on
	the second monitor.

	update_display_timer(0) schedules a timeout to be run with
	g_timeout_add_seconds(0). However, g_timeout_add_seconds() schedules
	timers with a granularity of a second, so the timeout we scheduled with
	g_timeout_add_seconds() may fire up to 1 second later than when we
	called it, while we really wanted it to fire as soon as possible.
	Special-casing update_display_timer(0) and using g_timeout_add() in that
	case avoid this issue. In theory, the race could probably still happen
	with a very very bad timing, but in practice I don't think it will be
	possible to trigger it after this change.

	https://bugzilla.redhat.com/show_bug.cgi?id=1323092

2016-06-15  Alexander Bokovoy  <abokovoy@redhat.com>

	sasl: fix SASL GSSAPI by allowing NULL username
	SASL GSSAPI module will try to negotiate authentication based on the
	credentials in the default credentials cache. It does not matter if
	SPICE knows username or not as SASL negotiation will pass through the
	discovered name from the GSSAPI module.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2016-06-13  Frediano Ziglio  <fziglio@redhat.com>

	Remove some warnings compiling for Windows
	GetLastError returns a DWORD which is a "unsigned long" on Windows
	so use "%lu" formatting instead of "%u".

	Acked-by: Marc-André Lureau <mlureau@redhat.com>

2016-06-13  Pavel Grunt  <pgrunt@redhat.com>

	channel-display: Remove deprecated init functions
	They are called at the construct time since spice-common commit:
	5b6be16b37370bb774aa3c2a7d5c41791fdc3a1e

	tests-uri: Define g_assert_nonnull
	It is available since Glib 2.40

	Require gtk+ 3.12
	Allow to use gtk_stack_get_child_by_name

2016-06-13  Frediano Ziglio  <fziglio@redhat.com>

	widget: Do not mix function linkage
	This prevents a possible crash on windows 32 bit.
	The linkage of UnhookWindowsHookEx is WINAPI which is __stdcall while
	callback for g_clear_pointer is C. This could cause stack pointer
	corruption depending on compiler flags.
	On __stdcall linkage function change the stack pointer while returning
	from a function removing the parameters. On C linkage function leave
	the stack pointer unchanged. So if the compiler call a __stdcall
	function as a C function it expect the stack pointer to be unchanged
	causing the pointer to be inconsistent by an offset.

2016-06-09  Frediano Ziglio  <fziglio@redhat.com>

	widget: Do not ignore unsupported keys from keyboard
	If Windows layout does not support a given key the resulting virtual code
	is set to 0xFF. To avoid losing this raw key (causing the key not been
	sent to remote machine) detect this condition and handle the key.
	The check for raw scancode is there to understand if we can handle
	correctly the key in following code.
	This problem can happen for instance using a 106 key Japanese keyboard
	while the layout is set in English; in this case keys like CONVERT not
	forwarded correctly.

	Some note on how to reproduce and test this problem.

	Physical way:
	1- get a 106 key Japanese keyboard for your Windows client machine;
	2- setup your client to English keyboard layout;
	3- connect to a Linux machine (no matter the distro or version or
	   keyboard configuration);
	4- open "xinput test-xi2 <device>" command on Linux (device is
	   the "AT" device in this case);
	5- press CONVERT or other keys not present on an English keyboard.

	Virtual way (Windows machine on a VM):
	- set machine remote to VNC;
	- assure Qmeu has lock-key-sync=off option to vnc;
	- connect to Windows machine with a VNC client (I suggest TigerVNC
	  as remote-viewer do some keyboard insertion);
	- do steps 2, 3, 4 above
	- press the CONVERT key. If you don't have you can simulate, either
	  - change VNC client code to insert scancode 0x70 instead of another
	    key and press this key;
	  - disconnect main VNC client and use some tool to inject keys
	    (I use a modifier version of vncdotool).

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-06-06  Francois Gouget  <fgouget@codeweavers.com>

	streaming: Use the frame dimensions reported by the video decoder
	The dimensions sent by the remote end are redundant and should not be
	trusted.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-06-06  Pavel Grunt  <pgrunt@redhat.com>

	widget: Avoid using GDK_GRAB_FAILED defined in Gtk 3.16.
	The returned value from do_pointer_grab() is treated as a boolean - grab
	was successful or not. Change the function to return a boolean value.

	Reported-by: Eduardo Lima (Etrunko) <etrunko@redhat.com>
	Acked-by: Eduardo Lima (Etrunko) <etrunko@redhat.com>

	mingw: Fix -Werror format & missing-prototypes
	-Wmissing prototypes were enabled in d5e3a4a5c34fc4408298e824872c4ed511b4bb3c
	format warnings were added in da8ecf1f95382e8c12fd14915f471a3e76e4b178

2016-06-03  Pavel Grunt  <pgrunt@redhat.com>

	spicy: Do not show underscore in label
	Acked-by: Eduardo Lima (Etrunko) <etrunko@redhat.com>

2016-06-02  Pavel Grunt  <pgrunt@redhat.com>

	spice-uri: Add ipv6 support
	Just basic support -  http://user:password@[host]:port

	Resolves: rhbz#1335239

	spice-uri: Validate uri scheme
	Related: rhbz#1335239

	Acked-by: Victor Toso <victortoso@redhat.com>

	spice-uri: Check if port is in allowed range
	Use g_ascii_strtoll because it helps to detect overflow.

	Related: rhbz#1335239

	Acked-by: Victor Toso <victortoso@redhat.com>

	spice-uri: Do not allow empty port string
	Related: rhbz#1335239

	Acked-by: Victor Toso <victortoso@redhat.com>

	spice-uri: Reset SpiceURI before parsing
	Avoid using old values after parsing a new uri.

	Related: rhbz#1335239

	tests: Add test for SpiceURI
	Related: rhbz#1335239

2016-06-01  Francois Gouget  <fgouget@codeweavers.com>

	streaming: Tweak the GStreamer decoder to avoid a compiler warning
	We check that there is a matching frame in the queue before popping the
	old ones. So we know the inner loop will find a match and thus that
	frame will not be NULL. But figuring that out is too hard for the
	compiler.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>
	Reported-by: Marc-André Lureau <marcandre.lureau@gmail.com>

2016-06-01  Marc-André Lureau  <marcandre.lureau@gmail.com>

	build-sys: update manywarnings.m4
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	build-sys: -Wshift-overflow=2
	manywarnings.m4 update will bring new flags that fail with some
	glib/gst headers.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Fix many -Werror=format warnings
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	build-sys: remove -Wmissing-declarations
	The warning doesn't show up anymore.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-06-01  Victor Toso  <victortoso@redhat.com>

	channel: avoid crash on spice_channel_wakeup due NULL channel
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	tests: fix build with smartcard enabled
	In file included from
	../spice-common/common/client_marshallers.h:29:0,
	from ../src/spice-channel-priv.h:35,
	from ../src/spice-file-transfer-task-priv.h:28,
	from file-transfer.c:3:
	../spice-common/common/messages.h:45:23: fatal error: libcacard.h: No such file or directory
	compilation terminated.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-05-31  Marc-André Lureau  <marcandre.lureau@gmail.com>

	doc: fix unused declarations
	Fix all the gtk-doc: "unused declarations. They should be added to
	spice-gtk-sections.txt in the appropriate place."

	doc: add some missing block comments

	Fix non gtk-doc comments
	Fixes the following warning:
	../../src/vmcstream.c:124: warning: Symbol name not found at the start of the comment block.
	../../src/win-usb-driver-install.c:347: warning: Symbol name not found at the start of the comment block.

	build-sys: remove some gtk+ 2.0 warnings flags
	As we dropped gtk+ 2.0 anyway.

	build-sys: enable -Wmissing-prototypes
	Turns out it is possible to fix the warnings now.

2016-05-31  Pavel Grunt  <pgrunt@redhat.com>

	Update README
	Remove gtk2 related stuff.
	Recommend dnf for installing dependencies.

	spice-uri: Mark parameter as unused
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-05-28  Marc-André Lureau  <marcandre.lureau@gmail.com>

	main: remove unneeded gtk-doc comments
	They are no longer in the doc, and not really useful anyway

	main: remove SpiceFileTransferTaskPrivate
	The struct is already private

2016-05-27  Victor Toso  <victortoso@redhat.com>

	file-xfer: make handle_status agnostic of channel-main
	This make possible to rename the function to
	spice_file_transfer_task_handle_status as a handler for
	VDAgentFileXferStatusMessage for a specific task.

	This change is related to split SpiceFileTransferTask from
	channel-main.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-05-25  Francois Gouget  <fgouget@codeweavers.com>

	streaming: Constify the video stream's dest and clip parameters
	They are only supposed to be changed when receiving the relevant server
	message.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-05-25  Pavel Grunt  <pgrunt@redhat.com>

	file-transfer-task: Hide internals of SpiceFileTransferTask
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	file-trasfer-task: Protect header include
	As stated in the commit d2f33178c40ac51b1c8b1bf796a328631d9869c7 Glib
	applications should only include "spice-client.h".

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2016-05-25  Marc-André Lureau  <marcandre.lureau@gmail.com>

	egl: fix delayed widget realize
	When the display is not yet realized, spice_display_widget_gl_scanout()
	will fail because the egl context is not ready. The display is never
	marked ready because the egl.image (and egl.scanout) is not set, and
	some clients, such as virt-viewer will not realize the widget until the
	display is ready.

	Deal with gl scanout updates when the widget is not yet realized, and
	mark the display as ready when egl is enabled (when last display draw
	signal is from gl).

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	gtk: remove unneeded check
	spice_cairo_draw_event() can deal with d->canvas.surface == NULL.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	gtk: rename spicex_* functions
	spice-gtk used to have x11/shm backend, now it's only cairo

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	gtk: move canvas related data in its own structure
	Group canvas related data to a sub-structure.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	egl: bind the scanout texture
	glEGLImageTargetTexture2DOES() changes the current bound texture. If
	the last texture bound is the cursor, update_scanout() will modify the
	cursor texture, instead of the display.

	Fix regression from commit 3539ac6212d506128bd38aad032e0363e78cb4f6.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	display: lower to debug gstreamer codec support
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-05-25  Pavel Grunt  <pgrunt@redhat.com>

	spice-widget: Use correct enum value
	GDK_GRAB_BROKEN is not GdkGrabStatus value, but GdkEventType

2016-05-24  Pavel Grunt  <pgrunt@redhat.com>

	Update spice-common submodule
	Fixes lz decompression crash:
	https://bugzilla.redhat.com/show_bug.cgi?id=1285469

	Christophe Fergeau (5):
	      Remove 2 unused vfuncs from client_marshallers.h
	      tests: Fix glib version check
	      log: Clamp SPICE_DEBUG_LEVEL if it's too high
	      log: Use SPICE_CONSTRUCTOR_FUNC
	      log: Make sure glib threading is initialized

	Eduardo Lima (Etrunko) (2):
	      Fix build in systems with Glib version older than 2.38
	      2/2] Add check for openssl

	Fabiano Fidêncio (7):
	      coverity: avoid use after free
	      coverity: avoid resource leak
	      coverity: avoid dereference after null check
	      coverity: avoid division or modulo by zero
	      coverity: remove unused value
	      coverity: remove structurally dead code
	      Use g_getenv() instead of getenv()

	Frediano Ziglio (6):
	      Cap logging level to the valid bounds
	      tests: exit on SIGABRT
	      define SPICE_CONSTRUCTOR_FUNC and SPICE_DESTRUCTOR_FUNC macros
	      use macro to define constructor function
	      fix 16 bpp LZ image decompression
	      Explicitly specify size of SpiceMsgSmartcardData

	Lin Ma (1):
	      build-sys: Define opengl GL_LIBS and GL_CFLAGS in generated Makefile.in

	Pavel Grunt (3):
	      Define canvas_fix_alignment when is used
	      test-logging: Include stdlib.h for _Exit()
	      Remove GL support

	Update .mailmap

2016-05-23  Marc-André Lureau  <marcandre.lureau@gmail.com>

	egl: set current context, fix multiple display
	On X11, each widget has its own context. Make sure we are using the
	widget associated context when using gl.

	With gtk 3.16, glEGLImageTargetTexture2DOES() can be called during
	update scanout, since we can call gtk_gl_area_make_current(). On < 3.16,
	do it before drawing.

	Fixes:
	https://bugzilla.redhat.com/show_bug.cgi?id=1337721

	Acked-by: Pavel Grunt <pgrunt@redhat.com>
	Acked-by: Victor Toso <victortoso@redhat.com>

	egl: don't terminate display
	This is global to the display connection: all egl resources will be
	released, including those from other widgets or from the application.

	Fix spice/virgl display being rendered black after another widget
	display is destroyed.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>
	Acked-by: Victor Toso <victortoso@redhat.com>

	egl: don't destroy wayland egl context
	The egl context is from Gtk on Wayland. Destroy it only on X11.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>
	Acked-by: Victor Toso <victortoso@redhat.com>

	egl: only swap buffers on x11
	Gtk does it for us already with GtkGlArea.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	channel: check if channel has a session
	Since 8943d2329, the channel may be disconnected from the session
	before it's destroyed. In this case, session is NULL.

	Fixes some critical with virt-manager when closing a display:

	(virt-manager:20451): GSpice-CRITICAL **: spice_session_is_for_migration: assertion 'SPICE_IS_SESSION(session)' failed

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	util: remove STATIC_MUTEX macros
	They are no longer needed since 0a9ec4ec0.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-05-19  Frediano Ziglio  <fziglio@redhat.com>

	Spice-widget: Use new gdk_event_get_scancode if available
	This new Gdk API allows in Windows to retrieve the raw scancodes sent
	by Windows.
	This allows us to do some translations getting the right value without
	many hacks and supporting all possible layouts.
	Windows convert the scancodes into virtual key codes. The translation is
	1 -> N based on different condition. Also a single virtual key code can
	be originated from different scancodes. This make quite complicated
	(if not impossible) to get the original scancode from the hardware_keycode
	field (which in Windows is the virtual key).
	The additional check for native_scancode after calling this function
	allows to support key injection.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-05-18  Francois Gouget  <fgouget@codeweavers.com>

	streaming: Use decodebin as a fallback for the GStreamer video decoder
	This means future video codecs may be supported automatically.
	One can also force usage of decodebin by setting $SPICE_GSTVIDEO_AUTO.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	streaming: Probe GStreamer before advertising support for a codec
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	streaming: Allow disabling support for the builtin MJPEG video decoder
	This makes it possible to test the GStreamer video decoder with MJPEG
	streams.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	streaming: Add a GStreamer video decoder for MJPEG, VP8 and h264
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	streaming: Let the video decoder queue, schedule and drop the frames
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-05-16  Victor Toso  <victortoso@redhat.com>

	file-xfer: fix segfault on agent disconnection
	We are checking self->priv->error but accessing the argument GError *
	which is NULL and leads to a segfault.

	Program received signal SIGSEGV, Segmentation fault.
	spice_file_transfer_task_completed (self=self@entry=0x7fffd0006f00, error=0x0) at channel-main.c:2963
	2963            VDAgentFileXferStatusMessage msg = {
	(gdb) bt
	 #0  spice_file_transfer_task_completed (self=self@entry=0x7fffd0006f00, error=0x0) at channel-main.c:2963
	 #1  in file_xfer_data_flushed_cb (source_object=0x7cc1d0, res=0x953390, user_data=user_data@entry=0x7fffd0006f00) at channel-main.c:1857
	 #2  in g_task_return_now (task=0x953390) at gtask.c:1108
	 #3  in g_task_return (task=0x953390, type=<optimized out>) at gtask.c:1166
	 #4  in flush_foreach_remove (key=<optimized out>, value=<optimized out>, user_data=<optimized out>) at channel-main.c:928
	 #5  in g_hash_table_foreach_remove_or_steal (hash_table=0x70cea0, func=func@entry=0x7ffff5616f10 <flush_foreach_remove>, user_data=user_data@entry=0x0, notify=notify@entry=1) at ghash.c:1492
	 #6  in g_hash_table_foreach_remove (hash_table=<optimized out>, func=func@entry=0x7ffff5616f10 <flush_foreach_remove>, user_data=user_data@entry=0x0) at ghash.c:1538
	 #7  in file_xfer_flushed (success=0, channel=0x7cc1d0) at channel-main.c:936
	 #8  spice_main_channel_reset_agent (channel=0x7cc1d0) at channel-main.c:466
	 #9  set_agent_connected (channel=0x7cc1d0, connected=connected@entry=0) at channel-main.c:1572
	 #10 in spice_main_channel_reset (channel=0x7cc1d0, migrating=0) at channel-main.c:485
	 #11 in spice_channel_coroutine (data=0x7cc1d0) at spice-channel.c:2564
	 #12 in coroutine_trampoline (cc=0x7cb860) at coroutine_ucontext.c:63
	 #13 in continuation_trampoline (i0=<optimized out>, i1=<optimized out>) at continuation.c:55
	 #14 in ?? () from /lib64/libc.so.6
	 #15 in ?? ()
	 #16 in ?? ()
	Backtrace stopped: Cannot access memory at address

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2016-05-13  Victor Toso  <victortoso@redhat.com>

	file-xfer: fix file path leak
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2016-05-13  Pavel Grunt  <pgrunt@redhat.com>

	doc, gir: Clarify availability of skip spice_get_option_group
	Commit c288627110bbec1aba48b0bf91ce7ab4b12f70b3 made the function
	available for other languages through gobject introspections. Mention
	the change in the function description.
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-05-12  Pavel Grunt  <pgrunt@redhat.com>

	spicy: Add option to control syncing modifiers
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	spice-gtk-session: Add sync modifiers property
	It will help in cases where syncing modifiers keys is complicated:
	 * not working leds for modifiers keys
	 * different keyboard layout on the guest side
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-05-10  Victor Toso  <victortoso@redhat.com>

	spicy: fix leak of transfer hash table
	184 (88 direct, 96 indirect) bytes in 1 blocks are definitely lost in
	loss record 10,025 of 11,515 at 0x4C28BF6: malloc
	(vg_replace_malloc.c:299)
	 by 0x9D33218: g_malloc (gmem.c:94)
	 by 0x9D49D02: g_slice_alloc (gslice.c:1025)
	 by 0x9D1CCBD: g_hash_table_new_full (ghash.c:711)
	 by 0x406196: connection_new (spicy.c:1693)
	 by 0x405BFE: main (spicy.c:1852)

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-05-10  Marc-André Lureau  <marcandre.lureau@redhat.com>

	spicy: add toggle mouse mode menu
	This is just for testing, the UI could be different in better clients.

	Acked-by: Victor Toso <victortoso@redhat.com>

	main: do not always request client mouse mode
	Whenever the mouse mode changed on the server, spice-gtk was requesting
	client mode. Instead keep the last requested mode and request it
	whenever it's possible.

	Reviewed-by: Victor Toso <victortoso@redhat.com>

	gtk: add spice_main_request_mouse_mode()
	Send a SpiceMsgcMainMouseModeRequest message to request a mouse mode.

	This allows to switch between client/absolute and server/relative mouse
	modes.

	This is necessary for some applications that require pointer
	re-positioning, which we can't provide through a remote protocol easily
	with client pointer (no such hardware-level message exists afaik).

	Reviewed-by: Victor Toso <victortoso@redhat.com>

2016-05-09  Francois Gouget  <fgouget@codeweavers.com>

	streaming: Rename num_drops_on_receive to arrive_late_count
	The frame may not get dropped once that's left up to video decoders.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	streaming: Optimize handling of the decoded frame buffer
	The MJPEG decoder does not need a zero-filled buffer.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	streaming: Enable adding alternative video decoders
	This replaces the original channel-display-mjpeg API with a VideoDecoder
	base class which can be reimplemented by other decoders.
	Furthermore this moves the MJPEG-specific state information from the
	display_stream struct to a derived class of VideoDecoder.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-05-04  Visarion-Mingopol Alexandru  <viorel.visarion@gmail.com>

	doc,gir: Don't skip spice_get_option_group()
	There is no reason to not include the spice_get_option_group
	method in the generated bindings, as it can be useful.

	It was removed in the commit 2db9b8dd037e22d2b04e8e2aeecfd685524b7fef,
	for the reason of causing warnings, but no warnings show up now.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2016-05-04  Marc-André Lureau  <marcandre.lureau@gmail.com>

	gtk: fix server-mode mouse
	Since switching to gtkstack, server-side mouse mode has some issues with
	grabs. There seems to be some grab gtk+ issue, but it seems to fall
	under the API user responsability to have its own window when dealing
	with pointer grabs. And gtk+ commit 9d0e8401c (Turn stack into no-window
	widget) made things worse.

	Making the widget an eventbox solves the grab issue.

	Fixes:
	https://bugs.freedesktop.org/show_bug.cgi?id=94764

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-05-03  Victor Toso  <victortoso@redhat.com>

	spice-channel: fix small leak
	182 bytes in 1 blocks are definitely lost in loss record 9,048 of 9,889
	at 0x4C2A988: calloc (vg_replace_malloc.c:711)
	by 0xB5F4270: g_malloc0 (gmem.c:124)
	by 0x7320678: spice_channel_recv_link_hdr (spice-channel.c:1312)
	by 0x7320678: spice_channel_coroutine (spice-channel.c:2543)
	by 0x7355A4E: coroutine_trampoline (coroutine_ucontext.c:63)
	by 0x7355802: continuation_trampoline (continuation.c:55)

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	spicevmc: don't disconnect on "cancel"
	spicevmc was designed so its _finish functions should always be called;
	With the gtask integration both _finish functions are trying to
	disconnect the GCancellable even in the 'cancel' context which leads to
	a deadlock as explained in the documentation.

	Resolves: https://bugs.freedesktop.org/show_bug.cgi?id=95032
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-05-02  Pavel Grunt  <pgrunt@redhat.com>

	channel: Abort migration in delayed unref
	When channel is unref'ed during migration migrate_channel_event_cb
	is called causing a crash by coroutine yielding to nonexistent channel.

	The delayed_unref happens for the target host channel and will only occur
	when the migration process fails.

	As comment in spice_channel_coroutine says:
	  Co-routine exits now - the SpiceChannel object may no longer exist,
	  so don't do anything else now unless you like SEGVs

	Related: rhbz#1318574
	Acked-by: Victor Toso <victortoso@redhat.com>

	Do not use deprecated GtkStock
	Use labels or named icons

	Deprecated since Gtk 3.10
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-05-02  Fabiano Fidêncio  <fidencio@redhat.com>

	coverity: identical code for different branches
	Acked-by: Victor Toso <victortoso@redhat.com>

	coverity: avoid out of bounds access
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-04-27  Pavel Grunt  <pgrunt@redhat.com>

	channel-main: Use CHANNEL_DEBUG for migration events
	To show which channel got an error or an unhandled event
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-04-22  Javier Celaya  <javier.celaya@flexvdi.com>

	Spice-widget: Allow smaller widget with scaling enabled
	When resize-guest-to-match-window-size is disabled, the size request
	(minimum size) of the spice widget is set to the current guest
	resolution. The client window cannot be made smaller, even with
	scale-display enabled.

	This patch sets a size request of 640x480 when either
	resize-guest-to-match-window-size OR scale-display are enabled, making
	it posible to shrink the window and scale down the display.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-04-18  Takao Fujiwara  <tfujiwar@redhat.com>

	Send Hangul key in KR keyboard
	Korean keyboard assigns Hangul key on the position of Right Alt and
	Left Alt and Hangul keys have the different scancodes but MapVirtualKey()
	returned the same scancode and could not use Hangul key on Linux desktop.

	The fix is to send the right scancode of VK_HANGUL.

	Send key release event for some keys in JP keyboard
	With the previous fix, WM_KEYDOWN of Alt+Zenkaku_Hankaku (VK_KANJI) can
	be sent with spice-gtk but Alt+Zenkaku_Hankaku does not send the WM_KEYUP
	event in Windows and it caused Linux desktop freeze with unlimited key
	press events.

	The proposed fix is to send the key release event in spice-gtk.

	VK_DBE_ALPHANUMERIC, VK_DBE_HIRAGANA, VK_DBE_ROMAN are applied the
	similar fixes.

	Send Zenkaku_Hankaku key in JP keyboard
	Zenkaku_Hankaku key has the different virtual-key codes between WM_KEYDOWN
	and WM_KEYUP and MapVirtualKey() cannot get the scancode from virtual-key
	code of WM_KEYDOWN (VK_DBE_DBCSCHAR) and spice-gtk didn't send the key
	press events and caused the desktop freeze with unlimited key release
	events.

	The fix is to get the scancode from virtual-key code of WM_KEYUP
	(VK_DBE_SBCSCHAR) and Zenkaku_Hankaku key works fine.

	Alt + Zenkaku_Hankaku key also has the different virtual-key code and
	MapVirtualKey() cannot get the scancode from the virtual-key and
	spice-gtk didn't send the key press events and Alt+Zenkaku_Hankaku
	could not be used.

	The fix is to get the scancode from virtual-key code of Zenkaku_Hankaku key
	(VK_DBE_SBCSCHAR).

	VK_CAPITAL, VK_DBE_ROMAN are also applied the similar fixes.

2016-04-15  Pavel Grunt  <pgrunt@redhat.com>

	channel-main: Move variable to block where is needed

	channel-main: Add helper function for getting audio
	Avoid repeating the same code and having a SpiceSession variable
	defined when is not really needed.
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-04-08  Jonathon Jongsma  <jjongsma@redhat.com>

	Ensure that file transfers get cancelled
	When canceling a file transfer task in spicy, the client would often
	stop sending additional data, but it would not send a "CANCELLED"
	message to the guest. Because of this, the partial file would remain in
	the guest's downloads folder until the spice client disconnected, at
	which point the vdagent would remove the unfinshed file.

	This CANCELLED status message was only being sent if the task was
	canceled during the async file read operation. If you cancel a task,
	it's quite likely that it will happen during other operations
	(e.g. file_xfer_flush_async(), etc). In order to handle these scenarios
	(and make sure that the file gets canceled properly), send the
	FILE_XFER_STATUS message in spice_file_transfer_task_completed().

2016-04-07  Pavel Grunt  <pgrunt@redhat.com>

	Do not call spice_egl_cursor_set when egl is disabled
	Fix memory leaks of cursor:

	240 bytes in 1 blocks are possibly lost in loss record 10,786 of 12,521
	   at 0x4C2FA60: calloc (vg_replace_malloc.c:711)
	   by 0x3700F861: ralloc_size (ralloc.c:113)
	   by 0x36FD2D68: UnknownInlinedFun (list.h:83)
	   by 0x36FD2D68: (anonymous namespace)::builtin_variable_generator::add_const(char const*, int) (builtin_variables.cpp:578)
	   by 0x36FD4775: generate_constants (builtin_variables.cpp:725)
	   by 0x36FD4775: _mesa_glsl_initialize_variables(exec_list*, _mesa_glsl_parse_state*) (builtin_variables.cpp:1303)
	   by 0x36E03D26: create_new_program (ff_fragment_shader.cpp:1225)
	   by 0x36E03D26: _mesa_get_fixed_func_fragment_program (ff_fragment_shader.cpp:1295)
	   by 0x36E9A577: update_program (state.c:157)
	   by 0x36E9A577: _mesa_update_state_locked (state.c:473)
	   by 0x36E9A6A0: _mesa_update_state (state.c:504)
	   by 0x36EB05E4: teximage (teximage.c:2947)
	   by 0x36EB211F: _mesa_TexImage2D (teximage.c:3009)
	   by 0x4E5024F: spice_egl_cursor_set (spice-widget-egl.c:497)
	   by 0x4E4BFD7: cursor_set (spice-widget.c:2346)
	   by 0x50D6245: g_cclosure_user_marshal_VOID__INT_INT_INT_INT_POINTER (spice-marshal.c:245)

	Use g_clear_pointer if possible
	Acked-by: Eduardo Lima (Etrunko) <etrunko@redhat.com>

	Use g_clear_object if possible
	Acked-by: Eduardo Lima (Etrunko) <etrunko@redhat.com>

	Use g_object_unref instead of gdk_cursor_unref
	GdkCursor is GObject and gdk_cursor_unref has been deprecated since 3.0

	Acked-by: Eduardo Lima (Etrunko) <etrunko@redhat.com>

	Use GMutex instead of GStaticMutex
	Since GLib 2.32 GMutex can be statically allocated, so GStaticMutex has
	been deprecated.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Use GDK_VERSION_MAX_ALLOWED
	In order to avoid using a too new Gtk API.

	Taken from virt-viewer 4c4a43c61db60ac815c0bc66730fa0a9a1571103

	Acked-by: Eduardo Lima (Etrunko) <etrunko@redhat.com>

	Use GLIB_VERSION_MAX_ALLOWED
	In order to avoid using a too new GLib API.

	Taken from virt-viewer 96d120903f0b95d49642e58d4f796b4f62aa8b20

	Acked-by: Eduardo Lima (Etrunko) <etrunko@redhat.com>

2016-04-01  Pavel Grunt  <pgrunt@redhat.com>

	widget-egl: Define label only if can be used
	The label can be used only with GDK_WINDOWING_WAYLAND

	Silence -Wunused-label

2016-03-30  Pavel Grunt  <pgrunt@redhat.com>

	doc: Add description for spice_display_get_gl_scanout()
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	doc: Ignore spicy-connect
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	spice-file-transfer-task: Fix docstring
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	doc: channel stability should be Stable
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	doc: Remove private structs
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	usb-device-manager: Fix docstring
	Add description, "Since" and change the parameter name in the docstring
	to match parameter name in the function definition.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-03-30  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: Update symbol files
	The OSX-specific symbol files were not updated after the recent API
	additions/removals, and some removed symbols were still listed in
	map-file.

2016-03-29  Victor Toso  <victortoso@redhat.com>

	egl: fix leak when display is unrealize
	eglTerminate should be called on unrealize. This not yet fix all the
	leaks but reduces it significantly from 318kb to 74kb as definitely lost
	and around 1mb to 8kb as indirectly lost.

	4,096 bytes in 1 blocks are definitely lost in loss record
	9,762 of 9,882
	   at 0x35B19E40: drm_intel_gem_bo_map (intel_bufmgr_gem.c:1454)
	   by 0x35688320: can_write_oacontrol (intel_extensions.c:121)
	   by 0x35688320: intelInitExtensions (intel_extensions.c:279)
	   by 0x35651380: brwCreateContext (brw_context.c:875)
	   by 0x35602720: driCreateContextAttribs (dri_util.c:426)
	   by 0xF0C48B1: dri2_create_context (egl_dri2.c:1072)
	   by 0xF0BE727: eglCreateContext (eglapi.c:638)
	   by 0x5461D27: spice_egl_init (spice-widget-egl.c:256)
	   by 0x545B885: drawing_area_realize (spice-widget.c:581)
	   by 0xB431784: g_closure_invoke (gclosure.c:804)
	   by 0xB443A40: signal_emit_unlocked_R (gsignal.c:3629)
	   by 0xB44C92E: g_signal_emit_valist (gsignal.c:3385)
	   by 0xB44CC51: g_signal_emit (gsignal.c:3441)

	4,856 (32 direct, 4,824 indirect) bytes in 1 blocks are definitely lost
	in loss record 9,779 of 9,882
	   at 0x4C2A988: calloc (vg_replace_malloc.c:711)
	   by 0xF0BEEF7: _eglCreateArray (eglarray.c:71)
	   by 0xF0BF420: _eglLinkConfig (eglconfig.c:90)
	   by 0xF0C4F8D: dri2_add_config (egl_dri2.c:307)
	   by 0xF0C66EE: dri2_x11_add_configs_for_visuals (platform_x11.c:766)
	   by 0xF0C80EC: dri2_initialize_x11_dri3 (platform_x11.c:1319)
	   by 0xF0C80EC: dri2_initialize_x11 (platform_x11.c:1464)
	   by 0xF0C18FE: _eglMatchAndInitialize (egldriver.c:261)
	   by 0xF0C19B8: _eglMatchDriver (egldriver.c:292)
	   by 0xF0BDD31: eglInitialize (eglapi.c:482)
	   by 0x5461A76: spice_egl_init (spice-widget-egl.c:226)
	   by 0x545B885: drawing_area_realize (spice-widget.c:581)
	   by 0xB431784: g_closure_invoke (gclosure.c:804)

	5,921 (472 direct, 5,449 indirect) bytes in 1 blocks are definitely lost
	in loss record 9,794 of 9,882
	   at 0x4C2A988: calloc (vg_replace_malloc.c:711)
	   by 0xF0C7E0E: dri2_initialize_x11_dri3 (platform_x11.c:1267)
	   by 0xF0C7E0E: dri2_initialize_x11 (platform_x11.c:1464)
	   by 0xF0C18FE: _eglMatchAndInitialize (egldriver.c:261)
	   by 0xF0C19B8: _eglMatchDriver (egldriver.c:292)
	   by 0xF0BDD31: eglInitialize (eglapi.c:482)
	   by 0x5461A76: spice_egl_init (spice-widget-egl.c:226)
	   by 0x545B885: drawing_area_realize (spice-widget.c:581)
	   by 0xB431784: g_closure_invoke (gclosure.c:804)
	   by 0xB443A40: signal_emit_unlocked_R (gsignal.c:3629)
	   by 0xB44C92E: g_signal_emit_valist (gsignal.c:3385)
	   by 0xB44CC51: g_signal_emit (gsignal.c:3441)
	   by 0x5D2C9DB: gtk_widget_realize (gtkwidget.c:5454)

	16,384 bytes in 4 blocks are definitely lost in loss record 9,854 of 9,882
	   at 0x35B19E40: drm_intel_gem_bo_map (intel_bufmgr_gem.c:1454)
	   by 0x3568AB30: intel_miptree_map_raw (intel_mipmap_tree.c:2149)
	   by 0x3568CEE6: intel_miptree_map_gtt (intel_mipmap_tree.c:2182)
	   by 0x3568CEE6: intel_miptree_map (intel_mipmap_tree.c:2774)
	   by 0x35692851: intel_map_texture_image (intel_tex.c:227)
	   by 0x35447C3B: store_texsubimage (texstore.c:1069)
	   by 0x35447E9F: _mesa_store_teximage (texstore.c:1125)
	   by 0x3543D9BA: _mesa_get_fallback_texture (texobj.c:1056)
	   by 0x35443E1E: UnknownInlinedFun (texstate.c:562)
	   by 0x35443E1E: update_program_texture_state (texstate.c:587)
	   by 0x35443E1E: UnknownInlinedFun (texstate.c:726)
	   by 0x35443E1E: _mesa_update_texture (texstate.c:757)
	   by 0x35420809: _mesa_update_state_locked (state.c:430)
	   by 0x35420ED0: _mesa_update_state (state.c:504)
	   by 0x3535BF87: _mesa_Clear (clear.c:172)
	   by 0x546214F: spice_egl_update_display (spice-widget-egl.c:514)

	32,768 bytes in 1 blocks are definitely lost in loss record 9,864 of 9,882
	   at 0x35B19E40: drm_intel_gem_bo_map (intel_bufmgr_gem.c:1454)
	   by 0x35683E3C: intel_batchbuffer_reset (intel_batchbuffer.c:68)
	   by 0x35684052: brw_new_batch (intel_batchbuffer.c:164)
	   by 0x35684052: _intel_batchbuffer_flush.part.2 (intel_batchbuffer.c:397)
	   by 0x3568853B: can_write_oacontrol (intel_extensions.c:153)
	   by 0x3568853B: intelInitExtensions (intel_extensions.c:279)
	   by 0x35651380: brwCreateContext (brw_context.c:875)
	   by 0x35602720: driCreateContextAttribs (dri_util.c:426)
	   by 0xF0C48B1: dri2_create_context (egl_dri2.c:1072)
	   by 0xF0BE727: eglCreateContext (eglapi.c:638)
	   by 0x5461D27: spice_egl_init (spice-widget-egl.c:256)
	   by 0x545B885: drawing_area_realize (spice-widget.c:581)
	   by 0xB431784: g_closure_invoke (gclosure.c:804)
	   by 0xB443A40: signal_emit_unlocked_R (gsignal.c:3629)

	32,768 bytes in 1 blocks are definitely lost in loss record 9,865 of 9,882
	   at 0x35B19E40: drm_intel_gem_bo_map (intel_bufmgr_gem.c:1454)
	   by 0x35683E3C: intel_batchbuffer_reset (intel_batchbuffer.c:68)
	   by 0x35684052: brw_new_batch (intel_batchbuffer.c:164)
	   by 0x35684052: _intel_batchbuffer_flush.part.2 (intel_batchbuffer.c:397)
	   by 0x356887F3: can_do_pipelined_register_writes (intel_extensions.c:88)
	   by 0x356887F3: intelInitExtensions (intel_extensions.c:338)
	   by 0x35651380: brwCreateContext (brw_context.c:875)
	   by 0x35602720: driCreateContextAttribs (dri_util.c:426)
	   by 0xF0C48B1: dri2_create_context (egl_dri2.c:1072)
	   by 0xF0BE727: eglCreateContext (eglapi.c:638)
	   by 0x5461D27: spice_egl_init (spice-widget-egl.c:256)
	   by 0x545B885: drawing_area_realize (spice-widget.c:581)
	   by 0xB431784: g_closure_invoke (gclosure.c:804)
	   by 0xB443A40: signal_emit_unlocked_R (gsignal.c:3629)

	98,304 bytes in 3 blocks are definitely lost in loss record 9,872 of 9,882
	   at 0x35B19E40: drm_intel_gem_bo_map (intel_bufmgr_gem.c:1454)
	   by 0x35683E3C: intel_batchbuffer_reset (intel_batchbuffer.c:68)
	   by 0x35684052: brw_new_batch (intel_batchbuffer.c:164)
	   by 0x35684052: _intel_batchbuffer_flush.part.2 (intel_batchbuffer.c:397)
	   by 0x3564F834: intel_glFlush (brw_context.c:259)
	   by 0xF0C3DA0: dri2_make_current (egl_dri2.c:1189)
	   by 0xF0BAB1B: eglMakeCurrent (eglapi.c:703)
	   by 0x546274E: spice_widget_init_egl_win (spice-widget-egl.c:316)
	   by 0x546274E: spice_egl_realize_display (spice-widget-egl.c:333)
	   by 0x545B89F: drawing_area_realize (spice-widget.c:586)
	   by 0xB431784: g_closure_invoke (gclosure.c:804)
	   by 0xB443A40: signal_emit_unlocked_R (gsignal.c:3629)
	   by 0xB44C92E: g_signal_emit_valist (gsignal.c:3385)
	   by 0xB44CC51: g_signal_emit (gsignal.c:3441)

	131,072 bytes in 4 blocks are definitely lost in loss record 9,874 of 9,882
	   at 0x35B19E40: drm_intel_gem_bo_map (intel_bufmgr_gem.c:1454)
	   by 0x35683E3C: intel_batchbuffer_reset (intel_batchbuffer.c:68)
	   by 0x356848E8: intel_batchbuffer_init (intel_batchbuffer.c:45)
	   by 0x35651337: brwCreateContext (brw_context.c:848)
	   by 0x35602720: driCreateContextAttribs (dri_util.c:426)
	   by 0xF0C48B1: dri2_create_context (egl_dri2.c:1072)
	   by 0xF0BE727: eglCreateContext (eglapi.c:638)
	   by 0x5461D27: spice_egl_init (spice-widget-egl.c:256)
	   by 0x545B885: drawing_area_realize (spice-widget.c:581)
	   by 0xB431784: g_closure_invoke (gclosure.c:804)
	   by 0xB443A40: signal_emit_unlocked_R (gsignal.c:3629)
	   by 0xB44C92E: g_signal_emit_valist (gsignal.c:3385)

	1,080,655 (284 direct, 1,080,371 indirect) bytes in 1 blocks are
	definitely lost in loss record 9,881 of 9,882
	   at 0x4C2A988: calloc (vg_replace_malloc.c:711)
	   by 0x355A2221: ralloc_size (ralloc.c:113)
	   by 0x355A227D: rzalloc_size (ralloc.c:134)
	   by 0x355A2BEE: ra_alloc_reg_set (register_allocate.c:196)
	   by 0x356D79AA: brw_alloc_reg_set(brw_compiler*, int) (brw_fs_reg_allocate.cpp:159)
	   by 0x356D817D: brw_fs_alloc_reg_sets (brw_fs_reg_allocate.cpp:305)
	   by 0x356FDACC: brw_compiler_create (brw_shader.cpp:84)
	   by 0x35691995: intelInitScreen2 (intel_screen.c:1495)
	   by 0x35602A5E: driCreateNewScreen2 (dri_util.c:144)
	   by 0xF0C547B: dri2_create_screen (egl_dri2.c:674)
	   by 0xF0C808F: dri2_initialize_x11_dri3 (platform_x11.c:1303)
	   by 0xF0C808F: dri2_initialize_x11 (platform_x11.c:1464)
	   by 0xF0C18FE: _eglMatchAndInitialize (egldriver.c:261)

	Acked-by: Marc-André Lureau <mlureau@redhat.com>

2016-03-29  Pavel Grunt  <pgrunt@redhat.com>

	doc: Remove dropped functions
	Dropped in 70a00b8fcc2ca85d3601f6ac4895f906f9032e77

	Acked-by: Marc-André Lureau <mlureau@redhat.com>

	widget: Avoid combining ternary with another operators
	Logical operators like "&&" has higher precedency than "?:".
	Readiness of SpiceDisplay was wrongly determined due to missing
	parentheses around the ternary operator.

	Fixes:
	https://bugs.freedesktop.org/show_bug.cgi?id=94738
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-03-29  Marc-André Lureau  <marcandre.lureau@gmail.com>

	usb: fix build, missing ')'

2016-03-24  Jonathon Jongsma  <jjongsma@redhat.com>

	usb device widget: don't try to disconnect on failed connect
	When you try to redirect a usb device to the guest and it fails, we
	uncheck the checkbox for this device. This causes the 'clicked' signal
	to be emitted, which causes us to try to disconnect the device (which is
	not currently connected, since the connect operation failed).

	When we try to disconnect an unconnected device, the device manager
	leaks memory and gets left in an inconsistent state because we allocate
	the task data, call _set_redirecting(self, TRUE) and then return early
	with the following warning printed to the terminal:

	(lt-spicy:4638): GSpice-CRITICAL **: spice_usbredir_channel_disconnect_device_async: assertion 'channel != NULL' failed

	To avoid this, disable signal handlers for the checkbox 'clicked'
	signal while we're changing the checkbox state in response to a
	connection error. In addition, add an additional check to
	spice_usb_device_manager_disconnect_device_async() to ensure that the
	passed device is actually connected.

	SpiceUsbDeviceManager: propagate errors from sub-tasks
	_connect_device_async_cb() just turned TRUE unconditionally even if the
	sub-task had failed. Instead, introduce a
	_spice_usb_device_manager_connect_device_finish() function which passes
	up the result of the subtask.

2016-03-24  Dmitry Fleytman  <dfleytma@redhat.com>

	UsbDeviceManager: Deprecate synchronous disconnection method
	Asynchronous disconnection should be used instead.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-03-24  Kirill Moizik  <kmoizik@redhat.com>

	UsbDeviceWidget: Use asynchronous disconnect API
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	UsbDeviceWidget: Consider asynchronous redirection flows
	Gray out redirection controls while there are
	asynchronous redirection flows in progress.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	UsbDeviceWidget: Show info bar during redirection flows
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	usbredir: Disconnect USB device asynchronously
	Reviewed-by: Jonathon Jongsma <jjongsma@redhat.com>

	UsbDeviceManager: Track device disconnection operations in progress
	During device disconnection, unwanted hotplug events may happen.
	We need to ignore those therefore we track disconnection operations
	in progress.

	See also comment to commit
	"Do not process USB hotplug events while redirection is in progress"
	that introduces corresponding filtering out logic.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	UsbDeviceManager: Implement asynchronous disconnect device flow
	This commit introduces functions for asynchronous disconnection flows.
	Following commits will make use of those.

	Thread safety is ensured the same way it was done for connection
	flow in previous commits. Disconnect logic is protected by the same
	locks that protect connect/usbredir/channel management logic.

	UsbDeviceManager: Track device redirection operations in progress
	During device connection, unwanted hotplug events may happen.
	We need to ignore those therefore we track redirection operations
	in progress.

	See also comment to commit
	"Do not process USB hotplug events while redirection is in progress"
	that introduces corresponding filtering out logic.

	usbredir: Spawn a different thread for device redirection flow
	On Windows when using usbdk, opening and closing USB device handle,
	i.e. calling libusb_open()/libusb_unref_device() can block for a few
	seconds (3-5 second more specifically on patch author's HW).

	libusb_open() is called by spice_usbredir_channel_open_device().

	libusb_unref_device() is called implicitly via
	usbredirhost_set_device(..., NULL) from
	spice_usbredir_channel_disconnect_device().

	Both these calls happen on the main thread. If it blocks,
	this causes the UI to freeze.

	This commit makes sure libusb_open() is called from a different
	thread to avoid blocking the mainloop when usbdk is used.

	Following commits also move usbredirhost_set_device(..., NULL) call
	to separate threads.

	Since this commit introduces additional execution contexts running in
	parallel to the main thread there are thread safety concerns to be secured.
	Mainly there are 3 types of objects accessed by newly introduced threads:
	  1. libusb contexts
	  2. usbredir context
	  3. redirection channels

	Fortunately libusb accesses are either thread safe or already
	performed by a separate thread and protected by locks as needed.

	As for channels and usbredir, in order to achieve thread safety
	additional locks were introduced by previous patches
	in preparation to adding asynchronous contexts:

	1. Channel objects data accesses from different threads protected with a
	   new lock (device_connect_mutex);
	2. Handling usbredir messages protected by the same new lock in order to
	   ensure there are no messages processing flows in progress when device gets
	   connected or disconnected.

	usbredir: Protect data accessed by asynchronous redirection flows
	This commit adds locking to ensure thread safety required
	after start/stop redirection flows moved to separate threads.
	This is done in preparation to following commits that
	will introduce actual multithreaded access to corresponding
	routines.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	GUdevClient: Do not process USB hotplug events while redirection is in progress
	USB redirection flow on Windows includes a number of reset requests issued
	to the port that hosts the device deing redirected.

	Each port reset emulates device removal and reinsertion and produces
	corresponding hotplug events and a number of device list updates on
	different levels of USB stack and USB redirection engine.

	As a result, queriyng USB device list performed by spice-gtk's hotplug
	event handler may return inconsistent results if performed in parallel
	to redirection flow.

	This patch suppresses handling of USB hotplug events during redirection
	and injects a simulated hotplug event after redirection completion
	in order to properly process real device list changes in case they
	happened during the redirection flow.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	win-usb-dev: Track device redirection operations in progress
	This commit introduces redirecting property of GUdevClient

	This property indicates when a redirection operation
	is in progress on a device. It's set back to FALSE
	once the device is fully redirected to the guest.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	usbredir: Introduce mutex for device (dis)connection
	This commit introduces channel mutex to allow usage of
	channel objects in mutithreaded environments.

	This mutex will be used by future commits to protect
	thread unsafe usbredir functions and data structures.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-03-24  Dmitry Fleytman  <dmitry@daynix.com>

	win-usb-dev: Fix device (un)plug notification handler
	This patch fixes device list change notification handing
	logic for cases when more than one device being plugged
	or unplugged simultaneously.

	The simplest way to reproduce the problematic scenario
	is (un)plugging of a usb HUB with a few devices inserted.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	usb-dev-manager: Fix cbinfo leak in case of abnormal return
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	win-usbredir: Use UsbDk backend when available
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	win-usbredir: Do not use UsbClerk for non-WinUsb backends
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	win-usbredir: Move installer interaction logic to separate functions
	This is a refactoring done in preparation for the next commits.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	usbdk: Load hide rules for auto-redirected devices
	Hide rules order UsbDk to avoid showing specific USB
	devices to Windows PnP manager.

	Spice-gtk loads hide rules for devices that should be
	automatically redirected on connection to prevent Windows
	from showing "New Hardware Found" wizard window for USB
	devices that do not have driver on the local system.

	win-usbredir: Only match USB devices by VID:PID when WinUsb used
	In other cases match devices by BUS:ADDR.

	This commit introduces use_usbclerk flag which is set TRUE
	unconditionally for Windows builds for now. Next patches
	will introduce UsbDk backend integrartion which will set
	this flag in accordance to UsbDk presence on the system.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-03-24  Christophe Fergeau  <cfergeau@redhat.com>

	Add SpiceUsbDeviceManager parameter to device comparison functions
	This additional parameter is currently unused, but this is in
	preparation for the next commits.
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-03-24  Dmitry Fleytman  <dmitry@daynix.com>

	win-usbredir: Introduce UsbDk wrapper
	Introduce UsbDk API definitions and binding code.

	UsbDk API DLL is loaded dynamically and wrapped by
	a thin glue code layer. This approach was chosen in
	order to make spice-gtk functional without UsbDk
	installed.

	Next patches will introduce dynamic backend selection
	logic, i.e. spice-gtk will try to use UsbDk by
	default and fallback to the old WinUsb/usbclerk
	scheme in case UsbDk is not available.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-03-24  Marc-André Lureau  <marcandre.lureau@gmail.com>

	widget: modify update-area to not require primary surface
	If egl display is enabled, use GL scanout geometry to check intersection
	with the monitor area. This solves displaying GL display without
	software canvas (currently d->area is empty and gl drawing fails)

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	main: don't update display timer for unchanged config
	With virgl, set_monitor_ready() may be called each time the scanout is
	updated to set the monitor area. This will call
	spice_main_update_display(), and keep the timer postponed even if the
	monitor configuration didn't change. Treat unchanged configuration as a
	no-op and keep configuration timer unchanged. This fixes monitor
	autoconfig with virgl (when the display is regularly updated).

	It also solves/avoids problems with a guest running on wayland when the
	"resize-guest" property is TRUE.

	Fixes:
	https://bugzilla.redhat.com/show_bug.cgi?id=1266484

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	widget: update d->ready based on scanout image available
	d->ready is updated based on monitor area & canvas. In case of GL
	rendering, update it based on monitor area & scanout and add check
	before drawing update.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	egl: check and update scanout after egl init
	Once the egl/GL context are initialized, check if there is a scanout to
	associate to display widget. This solves races when scanout update is
	happening before the egl/GL context is ready.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	widget: make gl-scanout and update-monitor-area privately exported
	The following changes will call these functions from spice-widget-egl.c

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	display: return NULL in spice_display_get_gl_scanout()
	If there is no valid scanout, return NULL.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	widget: enable egl before updating scanout
	The GLArea is realized lazily, when it is made visible in
	set_egl_enabled(). The egl context is initialized once the GLArea is
	realized. Enable egl before updating the scanout.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	egl: check context is ready
	Add a new GL status field to check if the GL context is ready. This
	helps debugging races where GL is called before the context is ready.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	widget: remove superflous WIN32 check
	The egl call is already inside a X11 conditional block.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-03-24  Victor Toso  <victortoso@redhat.com>

	channel-main: fix leak on volume-sync
	7 bytes in 1 blocks are definitely lost in loss record 128 of 10,009
	   at 0x4C2A988: calloc (vg_replace_malloc.c:711)
	   by 0xB6C3200: g_malloc0 (gmem.c:124)
	   by 0x740BD5F: audio_playback_volume_info_cb (channel-main.c:1216)
	   by 0xB11D488: g_task_return_now (gtask.c:1107)
	   by 0xB11DCBD: g_task_return (gtask.c:1165)
	   by 0x742D1F5: spice_pulse_complete_all_async_tasks (spice-pulse.c:1034)
	   by 0x8B6B57C: ext_stream_restore_read_cb (ext-stream-restore.c:141)
	   by 0x10BA63C0: run_action (pdispatch.c:284)
	   by 0x10BA6722: pa_pdispatch_run (pdispatch.c:337)
	   by 0x8B6520D: pstream_packet_callback (context.c:338)
	   by 0x10BA8D7E: do_read (pstream.c:879)
	   by 0x10BAB39A: do_pstream_read_write (pstream.c:189)

	7 bytes in 1 blocks are definitely lost in loss record 129 of 10,009
	   at 0x4C2A988: calloc (vg_replace_malloc.c:711)
	   by 0xB6C3200: g_malloc0 (gmem.c:124)
	   by 0x740BFBF: audio_record_volume_info_cb (channel-main.c:1273)
	   by 0xB11D488: g_task_return_now (gtask.c:1107)
	   by 0xB11DCBD: g_task_return (gtask.c:1165)
	   by 0x742D1F5: spice_pulse_complete_all_async_tasks (spice-pulse.c:1034)
	   by 0x8B6B57C: ext_stream_restore_read_cb (ext-stream-restore.c:141)
	   by 0x10BA63C0: run_action (pdispatch.c:284)
	   by 0x10BA6722: pa_pdispatch_run (pdispatch.c:337)
	   by 0x8B6520D: pstream_packet_callback (context.c:338)
	   by 0x10BA8D7E: do_read (pstream.c:879)
	   by 0x10BAB39A: do_pstream_read_write (pstream.c:189)

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-03-23  Marc-André Lureau  <marcandre.lureau@gmail.com>

	widget: use allocation instead of window size
	Since spice-gtk 57df040cc, the SpiceDisplay no longer forces its own
	window. Get allocation instead of window size.  This fixes a "top
	border" issue in spicy with gtk+ >= 3.19.8.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	widget: offset draw updates by widget allocation if necessary
	According to gtk_widget_queue_draw_area() documentation:

	"The region here is specified in widget coordinates. Widget coordinates
	are a bit odd; for historical reasons, they are defined as
	widget->window coordinates for widgets that return TRUE for
	gtk_widget_get_has_window(), and are relative to widget->allocation.x ,
	widget->allocation.y otherwise."

	Since spice-gtk 57df040cc, the SpiceDisplay no longer forces its own
	window. During gtk+ 3.19.8, gtk stack also no longer use its own
	window (commit 9d0e8401). In order to make drawing update resilient to
	such changes, add a function applying offset if necessary.

	This solves drawing glitches and perceived slowness with spice-gtk git
	and gtk+ >= 3.19.8.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-03-23  Pavel Grunt  <pgrunt@redhat.com>

	spicy: Remove configure-event callback
	It is a leftover - see "Remove GnomeRR code"
	commit 30986505ba6041c293c38cb4b7f4b618a59f4716

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>
	Acked-by: Marc-André Lureau <mlureau@redhat.com>

2016-03-23  Frediano Ziglio  <fziglio@redhat.com>

	Avoid to access array with negative numbers

2016-03-22  Fabiano Fidêncio  <fidencio@redhat.com>

	vmcstream,gtask: Do idle ourself instead of leaving it to GTask's heuristic
	Seems that GTask heuristic only makes sense in a non-coroutine case.
	After opening a bug[0] on spice-gtk and a few discussions in the mailing
	list, seems that is completely fine for coroutine code to deal with the
	idle explicitly.

	Acked-by: Marc-André Lureau <mlureau@redhat.com>

	vmcstream,gtask: Fix crash when trying to use webdav
	Don't try to get the cancellable from a task that is, for sure (ensured
	by us), NULL. See the backtrace:

	 #0  0x00007ffff29cf250 in g_task_get_cancellable () at /lib64/libgio-2.0.so.0
	 #1  0x00007ffff78a9012 in spice_vmc_input_stream_read_all_async (stream=<optimized out>, buffer=0x7070f8, count=8, io_priority=<optimized out>, cancellable=0x7fffcc00a470, callback=0x7ffff788c190 <client_read_cb>, user_data=0x707b30) at vmcstream.c:187
	 #2  0x00007ffff788c0ab in start_demux (self=0x707b30) at channel-webdav.c:498
	 #3  0x00007ffff2700578 in g_closure_invoke () at /lib64/libgobject-2.0.so.0
	 #4  0x00007ffff27135f0 in signal_emit_unlocked_R () at /lib64/libgobject-2.0.so.0
	 #5  0x00007ffff271c43c in g_signal_emit_valist () at /lib64/libgobject-2.0.so.0
	 #6  0x00007ffff788acca in emit_main_context (opaque=0x7fffbfffe880) at gio-coroutine.c:200
	 #7  0x00007ffff242bab3 in g_main_context_dispatch () at /lib64/libglib-2.0.so.0
	 #8  0x00007ffff242be60 in g_main_context_iterate.isra () at /lib64/libglib-2.0.so.0
	 #9  0x00007ffff242c182 in g_main_loop_run () at /lib64/libglib-2.0.so.0
	 #10 0x0000000000405df6 in main (argc=<optimized out>, argv=<optimized out>) at spicy.c:1897

	It was pointed out during the review and, somehow, missed :-\

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-03-22  Jeremy White  <jwhite@codeweavers.com>

	Include gdk/gdkwayland.h anytime GDK_WINDOWING_WAYLAND is defined.
	A specific GTK version check is not appropriate for this particular include.
	This fixes compilation on Debian Jessie.

2016-03-22  Pavel Grunt  <pgrunt@redhat.com>

	Remove extra checks before g_cancellable_disconnect()
	If cancellable is NULL or handler_id is 0 the function does nothing.
	Acked-by: Victor Toso <victortoso@redhat.com>

	usb-device-manager: Remove invalid return annotation
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-03-22  snir sheriber  <ssheribe@redhat.com>

	usbredir_handle_msg: rename data to err_data
	To better reflect what this variable is used for and change the declare
	location such that it will be declared only if it should
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-03-21  Fabiano Fidêncio  <fidencio@redhat.com>

	mingw: Fix build failure due to epoxy/egl.h header
	epoxy/egl.h header is not provided by mingw-epoxy package.
	Let's avoid egl usage when building using mingw then.

	Acked-by: Marc-André Lureau <mlureau@redhat.com>

	channel-usbredir: Fix crash due to a Task returning earlier than expected
	g_task_return_error() has been completing the task immediately, not
	cleaning up/setting up the device state to STATE_DISCONNECTED. It's been
	causing a double free when trying to redirect a device without having
	the ACL permissions for doing it. See the backtrace:

	 #0  0x00007ffff24dc07d in g_type_check_instance_is_fundamentally_a (type_instance=type_instance@entry=0x14779d0, fundamental_type=fundamental_type@entry=80) at gtype.c:4032
	 #1  0x00007ffff24bc447 in g_object_unref (_object=0x14779d0) at gobject.c:3076
	 #2  0x00007ffff7bafc2a in connect_cb (gobject=0x87d9a0 [SpiceUsbDeviceManager], res=0x96f830, user_data=0x143e0e0)
	     at usb-device-widget.c:485
	 #3  0x00007ffff277f5a3 in g_task_return_now (task=0x96f830 [GTask]) at gtask.c:1106
	 #4  0x00007ffff277fc4e in g_task_return (task=0x96f830 [GTask], type=<optimized out>) at gtask.c:1164
	 #5  0x00007ffff786c277 in spice_usb_device_manager_channel_connect_cb (gobject=0x917940 [SpiceUsbredirChannel], channel_res=0x96f900, user_data=0x96f830) at usb-device-manager.c:1094
	 #6  0x00007ffff277f5a3 in g_task_return_now (task=0x96f900 [GTask]) at gtask.c:1106
	 #7  0x00007ffff277fc4e in g_task_return (task=0x96f900 [GTask], type=<optimized out>) at gtask.c:1164
	 #8  0x00007ffff786699c in spice_usbredir_channel_open_acl_cb (gobject=0xa73b00 [SpiceUsbAclHelper], acl_res=0x96f9d0, user_data=0x917940) at channel-usbredir.c:300
	 #9  0x00007ffff277f5a3 in g_task_return_now (task=0x96f9d0 [GTask]) at gtask.c:1106
	 #10 0x00007ffff277fc4e in g_task_return (task=0x96f9d0 [GTask], type=<optimized out>) at gtask.c:1164
	 #11 0x00007ffff27804d0 in g_task_return_new_error (task=0x96f9d0 [GTask], domain=<optimized out>, code=<optimized out>, format=<optimized out>) at gtask.c:1744
	 #12 0x00007ffff786eade in cb_out_watch (channel=0x1488740, cond=G_IO_IN, user_data=0xa73b00) at usb-acl-helper.c:128
	 #13 0x00007ffff21b8e3a in g_main_context_dispatch (context=0x647390) at gmain.c:3154
	 #14 0x00007ffff21b8e3a in g_main_context_dispatch (context=context@entry=0x647390) at gmain.c:3769
	 #15 0x00007ffff21b91d0 in g_main_context_iterate (context=0x647390, block=block@entry=1, dispatch=dispatch@entry=1, self=<optimized out>) at gmain.c:3840
	 #16 0x00007ffff21b94f2 in g_main_loop_run (loop=0x13d1ae0) at gmain.c:4034
	 #17 0x00007ffff3ca5440 in gtk_dialog_run () at /lib64/libgtk-3.so.0
	 #18 0x0000000000406a18 in menu_cb_select_usb_devices (action=0x9d62f0 [GtkAction], data=0x69aef0) at spicy.c:394
	 #22 0x00007ffff24d28ff in <emit signal ??? on instance 0x9d62f0 [GtkAction]> (instance=<optimized out>, signal_id=<optimized out>, detail=<optimized out>) at gsignal.c:3439
	     #19 0x00007ffff24b77a5 in g_closure_invoke (closure=0xa0d0c0, return_value=return_value@entry=0x0, n_param_values=1, param_values=param_values@entry=0x7fffffffcf70, invocation_hint=invocation_hint@entry=0x7fffffffcef0) at gclosure.c:801
	     #20 0x00007ffff24c9851 in signal_emit_unlocked_R (node=node@entry=0x63fc10, detail=detail@entry=0, instance=instance@entry=0x9d62f0, emission_return=emission_return@entry=0x0, instance_and_params=instance_and_params@entry=0x7fffffffcf70) at gsignal.c:3627
	     #21 0x00007ffff24d2530 in g_signal_emit_valist (instance=<optimized out>, signal_id=<optimized out>, detail=<optimized out>, var_args=var_args@entry=0x7fffffffd130) at gsignal.c:3383
	 #23 0x00007ffff3bc23b0 in _gtk_action_emit_activate () at /lib64/libgtk-3.so.0
	 #27 0x00007ffff24d28ff in <emit signal ??? on instance 0x9a8730 [GtkImageMenuItem]> (instance=<optimized out>, signal_id=<optimized out>, detail=<optimized out>) at gsignal.c:3439
	     #24 0x00007ffff24b77a5 in g_closure_invoke (closure=closure@entry=0x6607d0, return_value=return_value@entry=0x0, n_param_values=1, param_values=param_values@entry=0x7fffffffd3f0, invocation_hint=invocation_hint@entry=0x7fffffffd370) at gclosure.c:801
	     #25 0x00007ffff24c938c in signal_emit_unlocked_R (node=node@entry=0x661050, detail=detail@entry=0, instance=instance@entry=0x9a8730, emission_return=emission_return@entry=0x0, instance_and_params=instance_and_params@entry=0x7fffffffd3f0) at gsignal.c:3557
	     #26 0x00007ffff24d2530 in g_signal_emit_valist (instance=<optimized out>, signal_id=<optimized out>, detail=<optimized out>, var_args=var_args@entry=0x7fffffffd5b0) at gsignal.c:3383
	 #28 0x00007ffff3e7094e in gtk_widget_activate () at /lib64/libgtk-3.so.0
	 #29 0x00007ffff3d4e4f6 in gtk_menu_shell_activate_item () at /lib64/libgtk-3.so.0
	 #30 0x00007ffff3d4e824 in gtk_menu_shell_button_release () at /lib64/libgtk-3.so.0
	 #31 0x00007ffff3d30fda in _gtk_marshal_BOOLEAN__BOXEDv () at /lib64/libgtk-3.so.0
	 #32 0x00007ffff24b79d4 in _g_closure_invoke_va (closure=closure@entry=0x644d10, return_value=return_value@entry=0x7fffffffd900, instance=instance@entry=0x80faa0, args=args@entry=0x7fffffffd9d0, n_params=<optimized out>, param_types=0x644d40) at gclosure.c:864
	 #33 0x00007ffff24d1dd3 in g_signal_emit_valist (instance=0x80faa0, signal_id=<optimized out>, detail=0, var_args=var_args@entry=0x7fffffffd9d0) at gsignal.c:3292
	 #34 0x00007ffff24d28ff in g_signal_emit (instance=<optimized out>, signal_id=<optimized out>, detail=<optimized out>) at gsignal.c:3439
	 #35 0x00007ffff3e6e4bc in gtk_widget_event_internal () at /lib64/libgtk-3.so.0
	 #36 0x00007ffff3d2e34e in propagate_event () at /lib64/libgtk-3.so.0
	 #37 0x00007ffff3d300fc in gtk_main_do_event () at /lib64/libgtk-3.so.0
	 #38 0x00007ffff38a8e92 in gdk_event_source_dispatch () at /lib64/libgdk-3.so.0
	 #39 0x00007ffff21b8e3a in g_main_context_dispatch (context=0x647390) at gmain.c:3154
	 #40 0x00007ffff21b8e3a in g_main_context_dispatch (context=context@entry=0x647390) at gmain.c:3769
	 #41 0x00007ffff21b91d0 in g_main_context_iterate (context=0x647390, block=block@entry=1, dispatch=dispatch@entry=1, self=<optimized out>) at gmain.c:3840
	 #42 0x00007ffff21b94f2 in g_main_loop_run (loop=0x6e2730) at gmain.c:4034
	 #43 0x000000000040b2f9 in main (argc=1, argv=0x7fffffffde48) at spicy.c:1920

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-03-18  Pavel Grunt  <pgrunt@redhat.com>

	Adjust to Gtk+ 3.10
	Dependency since f9a1aad85fcc76dd76c454b51fbce5e07c9b145f

	Remove unneeded GTK_CHECK_VERSION guards

	Acked-by: Victor Toso <victortoso@redhat.com>

	Adjust to GLib 2.36
	Dependency since 8693e7d3f7de1ff102082212fa6e35fb1a252ef7

	Remove glib-compat files and most of GLIB_CHECK_VERSION guards

	Acked-by: Victor Toso <victortoso@redhat.com>

	Move strtok_r from glib-compat to spice-uri
	It is not glib specific and it is only used in spice-uri

	Acked-by: Victor Toso <victortoso@redhat.com>

	spice-util: Fix alignment
	Acked-by: Victor Toso <victortoso@redhat.com>

	usb-acl-helper: Remove extra check for NULL
	g_cancellable_cancel() and g_clear_object() can handle it

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-03-17  Pavel Grunt  <pgrunt@redhat.com>

	spicy: s/Automagic/Automatic/
	Acked-by: Eduardo Lima (Etrunko) <etrunko@redhat.com>

	spice-display: Remove auto-clipboard notify
	It was used to notify the (deprecated) auto-clipboard property of
	the SpiceDisplay everytime the SpiceGtkSession emits its auto-clipboard
	notify.

	The commit 70a00b8fcc2ca85d3601f6ac4895f906f9032e77 removed the property
	from SpiceDisplay causing a runtime warning:

	GLib-GObject-WARNING **: g_object_notify: object class 'SpiceDisplay' has no property named 'auto-clipboard'
	Acked-by: Eduardo Lima (Etrunko) <etrunko@redhat.com>

	display: Lower level of warning for empty monitor config
	It is a valid case when a guest requests to turn off monitors, eg:
	 xrandr --output Virtual-0 --off

	Related:
	https://bugzilla.redhat.com/show_bug.cgi?id=1061942

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-03-15  Marc-André Lureau  <marcandre.lureau@gmail.com>

	build-sys: fix 'Only <spice-client.h> can be included directly' warning
	Tests should be allowed to include directly private headers. Set
	__SPICE_CLIENT_H_INSIDE__ where necessary or include spice-client.h
	where possible.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	Lower gtk+ requirement to 3.10
	Make GtkGlArea optional allows to lower gtk+ requirement to
	3.10 (required for GtkStack). However, gl display is unsupported on
	wayland with gtk+ < 3.16.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	build-sys: remove epoxy from pc requires
	libepoxy doesn't need to figure in spice-gtk pkg-config requires, it's a
	private dependency.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2016-03-14  Fabiano Fidêncio  <fidencio@redhat.com>

	wocky-http-proxy: Use GTask instead of GSimpleAsyncResult
	Instead of using GSimpleAsyncResult, use the new GTask API, which is
	much more straightforward.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	win-usb-driver-install: Use GTask instead of GSimpleAsyncResult
	Instead of using GSimpleAsyncResult, use the new GTask API, which is
	much more straightforward.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	vmcstream: Use GTask instead of GSimpleAsyncResult
	Instead of using GSimpleAsyncResult, use the new GTask API, which is
	much more straightforward.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	usb-device-manager: Use GTask instead of GSimpleAsyncResult
	Instead of using GSimpleAsyncResult, use the new GTask API, which is
	much more straightforward.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	usb-acl-helper: Use GTask instead of GSimpleAsyncResult
	Instead of using GSimpleAsyncResult, use the new GTask API, which is
	much more straightforward.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	spice-pulse: Use GTask instead of GSimpleAsyncResult
	Instead of using GSimpleAsyncResult, use the new GTask API, which is
	much more straightforward.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	spice-gstaudio: Use GTask instead of GSimpleAsyncResult
	Instead of using GSimpleAsyncResult, use the new GTask API, which is
	much more straightforward.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	spice-channel: Use GTask instead of GSimpleAsyncResult
	Instead of using GSimpleAsyncResult, use the new GTask API, which is
	much more straightforward.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	smartcard-manager: Use GTask instead of GSimpleAsyncResult
	Instead of using GSimpleAsyncResult, use the new GTask API, which is
	much more straightforward.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	channel-usbredir: Use GTask instead of GSimpleAsyncResult
	Instead of using GSimpleAsyncResult, use the new GTask API, which is
	much more straightforward.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	channel-port: Use GTask instead of GSimpleAsyncResult
	Instead of using GSimpleAsyncResult, use the new GTask API, which is
	much more straightforward.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	channel-main: Use GTask instead of GSimpleAsyncResult
	Instead of using GSimpleAsyncResult, use the new GTask API, which is
	much more straightforward.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	channel-base: Use GTask instead of GSimpleAsyncResult
	Instead of using GSimpleAsyncResult, use the new GTask API, which is
	much more straightforward.
	For using the new GTask API, let's bump GIO (part of GLib) dependency
	version to 2.36, which is safe based on major distro support:
	- Debian Jessie: glib-2.42
	- RHEL-7.1: glib-2.40
	- SLES12: glib-2.38
	- Ubuntu LTS 14.04: glib-2.40

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-03-14  Marc-André Lureau  <marcandre.lureau@gmail.com>

	gtk: add GtkGLArea
	GtkGLArea is the proper modern way to have opengl in an gtk+
	application. Unfortunately, it may use various backends and interfaces
	to initialize it, but dmabuf image sharing requires egl atm.

	This patch keeps using our egl setup on X11, while it uses gtkglarea on
	known gdk backend based on egl, such as the wayland one. This brings
	wayland support for local gl to spice-gtk.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	gtk: use GtkStack
	Move the GtkDrawingArea in a GtkStack, so other widgets can be switched
	to for the display: the next patch adds a GtkGLArea for an opengl
	rendering. One can imagine other display widgets to show text etc..

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	gtk: require gtk+ 3.16
	3.16 is the minimal version for GtkGLArea widget, used in following
	patches.

	Drop conditional epoxy support, as it is now required by gtk+.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	gtk: drop deprecated stuff from spice-gtk
	Breaking ABI is a good time to remove deprecated code.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	Drop GTK+ 2.0
	Not so many systems require gtk+ 2.0 these days, let's move on.

	This drops the old python bindings (non-gir based), and the
	unsteady/experimental gtk2-only XShm support.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	gtk: make SpiceGrabSequence private
	Do not leak internals of SpiceGrabSequence in public headers. This makes also
	the class final, which let us extend more easily without fear of breaking ABI.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	gtk: make SpiceUsbDeviceWidget private
	Do not leak internals of SpiceUsbDeviceWidget in public headers. This makes also
	the class final, which let us extend more easily without fear of breaking ABI.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	gtk: make SpiceGtkSession private
	Do not leak internals of SpiceGtkSession in our headers. This makes also
	the class final, which let us extend more easily without fear of
	breaking ABI.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	gtk: make SpiceDisplay private
	Do not leak internals of SpiceDisplay in our headers. This makes also
	the class final, which let us extend more easily without fear of
	breaking ABI.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	build-sys: bump spice-gtk current version info
	The following patches need to break the ABI (in particular the parent of the
	SpiceDisplay widget).

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2016-03-11  Marc-André Lureau  <marcandre.lureau@gmail.com>

	build-sys: fix make check when polkit not available
	acl-helper needs polkit (and unix atm) to build.

	doc: add a bunch of Since: 0.31

	Prepare for v0.31 release

	logging: use more idiomatic spice-gtk logging
	spice-gtk uses SPICE_DEBUG for debug lines (for now), and prefer direct
	glib glog/g_warning.

	session: use debug message for optional key value
	This fixes make check failing because of recent spice-common logging
	switch to glib.

2016-03-11  Jonathon Jongsma  <jjongsma@redhat.com>

	Update POTFILES.skip
	spicy.desktop.in no longer exists.

	Add tests for usb-acl-helper

	usb-acl-helper: add env var for specifying acl helper binary
	Setting SPICE_USB_ACL_BINARY allows us to execute a custom mock acl
	helper binary for testing purposes.

	Rename spice_usb_acl_helper_open_acl() to _open_acl_async()
	Follow established practice and make the function's behavior more
	explicit.

	Remove spice_usb_acl_helper_close_acl()
	This function is now only called after the open_acl() task completes,
	and in that scenario it basically does the same thing that the
	SpiceUsbAclHelper destructor does, so it's pointless. Remove it.

	usb-acl-helper: Avoid deadlock when cancelled
	cancelled_cb() (which is triggered when the GCancellable's "cancelled"
	signal is emitted) called spice_usb_acl_helper_close_acl(), which calls
	spice_usb_acl_helper_cleanup(), which in turn calls
	g_cancellable_disconnect(). Calling g_cancellable_disconnect() from
	within a "cancelled" handler results in a dealock, as mentioned in the
	documentation. Instead of closing the acl here, simply cancel the task
	here. The cleanup() call will happen when the SpiceUsbAclHelper object
	is destroyed.

	Introduce spice_usb_acl_helper_cancel()
	This function explicitly cancels a open_acl() task. It is similar to
	close_acl(), but its behavior is more explicit. This function is very
	similar to the existing close_acl() function but it requires that the
	task has not already been completed. Also, although it releases its
	reference on priv->result to avoid circular references, it doesn't call
	cleanup(), preferring instead to wait for the destructor to clean up.
	This makes the close_acl() function essentially pointless and will be
	removed in the following commit.

2016-03-10  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Update spice-common submodule
	Pick codegen build fix

2016-02-23  Francois Gouget  <fgouget@codeweavers.com>

	spice-gtk: Fix the signedness of a couple of mm-time traces
	Acked-by: Marc-André Lureau <mlureau@redhat.com>

2016-02-23  Ignacio Casal Quinteiro  <icq@gnome.org>

	namedpipelistener: do not leak the error message

2016-02-18  Christophe Fergeau  <cfergeau@redhat.com>

	Simplify spice_usb_device_manager_device_to_libdev()
	The Windows-specific version duplicates some code from
	spice_usb_device_equal_libdev(), this commit
	switches to using that helper instead.

	Simplify spice_usb_device_equal_libdev()
	The Windows-specific version duplicates some code from
	spice_usb_device_manager_libdev_match(), this commit
	switches to using that helper instead.

2016-02-16  Marc-André Lureau  <mlureau@redhat.com>

	gtk: add spice-widget GL scanout support
	Hook to spice-glib events to show the GL scanout.

	The opengl context is created with egl, and is currently
	x11-only (supporting wayland with bare-egl doesn't seem trivial).

	Using GtkGLArea is left for a future series, since SpiceDisplay widget
	is a GtkDrawingArea and can't be replaced without breaking
	ABI. Furthermore, GtkGLArea won't work on non-egl contexts, so this
	approach is necessary on gtk+ < 3.16 or X11 (because gdk/x11 uses glx).

	Acked-by: Victor Toso <victortoso@redhat.com>
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-02-13  Marc-André Lureau  <mlureau@redhat.com>

	glib: add local GL scanout support
	Add spice-glib support for gl scanout messages.

	A note about SpiceGlScanout: it is struct with scanout details,
	registered as a boxed type, with associated gl-scanout property. That
	way, it doesn't need a seperate signal for change notification and the
	current scanout can be retrieve with gobject getter. Since boxed
	property are always duplicated by g_object_get(), an additional
	spice_display_get_gl_scanout() method returns the current scanout
	without duplication (that's what spice-gtk display widget will use).

2016-02-13  Marc-André Lureau  <marcandre.lureau@redhat.com>

	build-sys: check for epoxy-egl support
	The following code requires epoxy with egl support. Check for pkg-config
	and egl headers.

	Add spice_channel_unix_read_fd()
	Utility function used in the messages with socket ancillary fd.

2016-02-13  Marc-André Lureau  <marcandre.lureau@gmail.com>

	build-sys: bump to spice-protocol 0.12.11
	Needed for GL messages

2016-02-12  Fabiano Fidêncio  <fidencio@redhat.com>

	typo: s/GTask/GSimpleAsyncResult
	Seems that I messed up with cd0c1008316e90bce925e1448ffcabb366e88f8f
	while rebasing my GTask series on top of this patch, causing a build
	breakage due to non-intentional insertion of a GTask replacing a
	GSimpleAsyncResult.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Use #ifdef {HAVE,USE}_FOO instead of #if {HAVE,USE}_FOO
	While "#if USE_FOO" checks for the value of the variable USE_FOO,
	"#ifdef" checks whether USE_FOO is defined or not.

	It means, if we had something like: #define USE_FOO 0, we would have:
	 #if USE_FOO
	 /* Any code in here would NOT be compiled */
	 #endif

	 #ifdef USE_FOO
	 /* Any code in here would be compiled */
	 #endif

	No problem was faced on spice-gtk till now because either USE_FOO is not
	defined or defined as 1, but let's try to have it standardized.

	Acked-by: Eduardo Lima (Etrunko) <etrunko@redhat.com>

2016-02-03  Marc-André Lureau  <marcandre.lureau@gmail.com>

	gtk: replace configure-event for size-allocate
	For size-allocate, it's simpler to connect to the signal rather than
	override the default signal handler since there is no automatic chaining
	to parent handler otherwise. Doing this removes the need to have a
	window.

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-01-22  Fabiano Fidêncio  <fidencio@redhat.com>

	usb-device-{manager,widget}: Add counter of free channels
	As the message showed when the last usbredir channel is taken can be a
	bit confusing, let's add a counter of free channels to the widget's
	label.
	In order to add the counter, a new property for SpiceUsbDeviceManager
	was introduced ("free-channels").

	Related: rhbz#1298772

	Remove GSLice usage
	It's being slowly deprecated in glib
	https://bugzilla.gnome.org/show_bug.cgi?id=754687

2016-01-19  Victor Toso  <victortoso@redhat.com>

	gstaudio: set output parameter to NULL on error
	This is not really triggered in the current code but this is usually
	expected in case of errors; Also, the same function on record side
	already does this.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-01-14  Marc-André Lureau  <marcandre.lureau@gmail.com>

	build-sys: silence vala deprecated function usage warnings
	This silence usage of deprecated glib declarations from vala generated code.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2016-01-14  Marc-Andre Lureau  <marcandre.lureau@gmail.com>

	Update spice-common
	This is an update to fix build issues with spice-protocol.git.
	generated_server_demarshallers.c: In function
	‘parse_msgc_display_gl_draw_done’:
	generated_server_demarshallers.c:767:23: error:
	‘SpiceMsgcDisplayGlDrawDone’ undeclared (first use in this function)
	     mem_size = sizeof(SpiceMsgcDisplayGlDrawDone);
	...

	Also needed for upcoming gl-scanout messages.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-01-07  Victor Toso  <victortoso@redhat.com>

	channel-main: remove unused header rect.h
	It was included in be8ff99571478deb5c8d116134f65ed2b788dbd3 but with no
	use.

	Acked-by: Marc-André Lureau <mlureau@redhat.com>

2016-01-04  Marc-André Lureau  <marcandre.lureau@redhat.com>

	build-sys: remove xrandr
	Not needed anymore (probably since gnome-rr was removed in 30986505b)

2015-12-21  snir sheriber  <ssheribe@redhat.com>

	Grab keyboard based on session focus.
	When using multiple monitors moving mouse between monitors releases
	keyboard grab.

	Reproduce bug
	-Open multiple monitors remote-viewer session
	-Click on one of the monitors to get focus & keyboard-grab
	-Move mouse to another monitor and try keyboard command (do not click)
	At this point all keyboard commands are being executed on the client
	machine instead of the remote machine

	I added keyboard_has_focus and mouse_has_pointer variables at the
	session and now these properties are being tested for the session
	instead for the current widget (works also when using alt-tab).

	Resolves: rhbz#1275231

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2015-12-21  Lukas Venhoda  <lvenhoda@redhat.com>

	ppc: Fix spicy-screenshot colors on BE machines
	Save screenshot in proper endianess
	xRGB on LE machine and BGRx on BE machine
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	ppc: Fix colors on ppc when using GLZ
	Fixes color order on PowerPC when using GLZ image compression.
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2015-12-21  Fabiano Fidêncio  <fidencio@redhat.com>

	ppc: Fix message endianess

	ppc: Fix header endianess

2015-12-18  Pavel Grunt  <pgrunt@redhat.com>

	build-sys: Use sasl check from spice-common
	Support only libsasl2 providing libsasl2.pc file

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2015-12-10  Javier Celaya  <javier.celaya@flexvdi.com>

	Call spice_marshaller_flush on message write
	spice_marshaller_flush must be called before writing a message to
	calculate pointer offsets.

	This is only an issue when ptr submarshallers are used, which currently
	is only used by Tunnel::service_add. Since this is disabled by default,
	this buug is not going to be hit by the current codebase.

2015-12-09  Christophe Fergeau  <cfergeau@redhat.com>

	gst: Fix typo in preprocessor symbol
	When the GStreamer backend is used, HAVE_GSTAUDIO is defined, not
	HAVE_GST_AUDIO.

	smartcard: Fix compilation with older libcacard
	e0c2182937 dropped some #include from channel-smartcard.c and spicy.c as
	they were redundant with the headers already included from
	spice-common/common/messages.h. While this is true for the newer
	libcacard.h header, we need to include more headers to support older
	libcacard, or compilation breaks.

2015-12-09  Francois Gouget  <fgouget@codeweavers.com>

	spice-gtk: Recover from GStreamer audio initialization errors
	gst_init() will terminate the program in case of a failure so it's
	better to use gst_init_check() so we can recover from errors.

2015-12-08  Francois Gouget  <fgouget@codeweavers.com>

	build-sys: Warn about missing GStreamer 1.0 audio runtime elements
	Their absence should not be reported as an error since they are not
	needed for the build, but the developer will need them to test the code
	so it's appropriate to warn him.

2015-12-08  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: Check for GStreamer 1.0 audio with SPICE_CHECK_GSTREAMER()

2015-12-08  Francois Gouget  <fgouget@codeweavers.com>

	build-sys: Allow simultaneous support for Pulse and GStreamer audio
	Rather than GStreamer/PulseAudio backend being mutually exclusive at
	compile-time, this commit allows to enable both at the same time.
	PulseAudio will then be favoured, with a fallback to GStreamer if it's
	not available.
	Note that --with-audio is kept for backward compatibility.

2015-12-08  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Use libcacard.h if possible
	Drop unneeded includes (that are already undirectly included).

	Remove unmaintained spicy.nsis
	Remove gtkrc too, and cleanup EXTRA_DIST ($(desktop_in_files) is unused)

	Update spice-common
	For new libcacard.h usage

	Fix use after free of uri
	"path" points to "uri" memory, move free(uri) later.

	Found thanks to valgrind :)

2015-11-25  Christophe Fergeau  <cfergeau@redhat.com>

	Update spice-common submodule
	The next commit is going to use SPICE_WARNING which was added recently
	to spice-common

	This submodule update changes:

	Christophe Fergeau (5):
	      build-sys: Add gio-2.0 to SPICE_CHECK_GLIB2
	      build-sys: Fix error in SPICE_CHECK_LZ4 description
	      build-sys: Set automake conditional in SPICE_CHECK_SMARTCARD
	      build-sys: Rename SUPPORT_GL to HAVE_GL
	      build-sys: Add missing # to comment

	Francois Gouget (3):
	      build-sys: Add the SPICE_WARNING() and SPICE_PRINT_MESSAGES m4 macros
	      build-sys: Add SPICE_CHECK_GSTREAMER()
	      build-sys: Add SPICE_CHECK_GSTREAMER_ELEMENTS()

	Lukas Venhoda (4):
	      ssl-verify: Only check addr length when using IP addr
	      m4: Require glib version >= 2.22
	      ssl-verify: Changed IPv4 hostname to IPv6
	      canvas_base: Remove redundant switch case block

2015-11-25  Francois Gouget  <fgouget@codeweavers.com>

	build-sys: Use SPICE_WARNING() to issue the DBus warning

2015-11-24  Francois Gouget  <fgouget@codeweavers.com>

	build-sys: Prefix the configure audio GStreamer variables with GSTAUDIO_
	This lets us avoid naming conflicts when using GStreamer for other
	purposes.

	Acked-by: Victor Toso <victortoso@redhat.com>

2015-11-19  Jay.han  <ezzzehxx@gmail.com>

	file transfer: send cancel message when user cancels a transfer
	When a user cancel's a file transfer, we should send a STATUS_CANCELED
	message rather than an STATUS_ERROR message. The latter triggers a bug
	in the vdagent where the file remains opened by the vdagent in the guest
	and cannot be removed.

2015-11-19  Marek Kasik  <mkasik@redhat.com>

	Be more specific in the case of authentication error
	This patch adds SPICE_CLIENT_ERROR_AUTH_NEEDS_USERNAME error
	for the case when authentication fails because of missing username.
	This can happen when GSSAPI method is used.

	https://bugs.freedesktop.org/show_bug.cgi?id=92994

2015-11-18  Pavel Grunt  <pgrunt@redhat.com>

	spicy: Add support for changing compression

	channel-display: Add spice_display_change_preferred_compression

2015-11-11  Pavel Grunt  <pgrunt@redhat.com>

	Do not export symbol of non-existent function

2015-11-10  Jonathon Jongsma  <jjongsma@redhat.com>

	file xfer: Fix segfault when rebooting
	Recent changes to file transfer introduced a regression where the client
	would crash when rebooting a guest after performing a file transfer.
	This was caused because the SpiceFileTransferTask is freed when it is
	completed, but is not removed from the MainChannel's hash table. When we
	reboot the guest and lose our vdagent connection, we iterate through the
	list of tasks in the hash table and complete them. But since we did not
	remove the already-completed tasks from this hash table, this hash table
	contains already-freed memory.

	To fix the issue, take an extra ref for the async operations (so that
	completing the task won't free an object that is stored in the hash table). In
	addition, connect to the task's "finished" signal and remove it from the hash
	table when it becomes finished.

	Bug reported via email by Jay.han <ezzzehxx@gmail.com>. Valgrind report
	below:

	==6926== Invalid read of size 8
	==6926==    at 0x508177B: spice_file_transfer_task_completed (channel-main.c:2941)
	==6926==    by 0x50846DC: set_agent_connected (channel-main.c:462)
	==6926==    by 0x5073A43: spice_channel_recv_msg (spice-channel.c:1892)
	==6926==    by 0x5073BE3: spice_channel_iterate_read (spice-channel.c:2132)
	==6926==    by 0x5075D25: spice_channel_coroutine (spice-channel.c:2170)
	==6926==    by 0x50A6EFE: coroutine_trampoline (coroutine_ucontext.c:63)
	==6926==    by 0x50A6CC8: continuation_trampoline (continuation.c:55)
	==6926==    by 0x65C2B5F: ??? (in /lib/x86_64-linux-gnu/libc-2.19.so)
	==6926==    by 0x151331C7: ???
	==6926==  Address 0x29971fd8 is 168 bytes inside a block of size 184 free'd
	==6926==    at 0x4C2BDEC: free (in /usr/lib/valgrind/vgpreload_memcheck-amd64-linux.so)
	==6926==    by 0x5E33142: g_type_free_instance (in /usr/lib/x86_64-linux-gnu/libgobject-2.0.so.0.4000.0)
	==6926==    by 0x50815DA: file_xfer_close_cb (channel-main.c:1826)
	==6926==    by 0x5AEBD5C: ??? (in /usr/lib/x86_64-linux-gnu/libgio-2.0.so.0.4000.0)
	==6926==    by 0x5B0F41A: ??? (in /usr/lib/x86_64-linux-gnu/libgio-2.0.so.0.4000.0)
	==6926==    by 0x5B0F438: ??? (in /usr/lib/x86_64-linux-gnu/libgio-2.0.so.0.4000.0)
	==6926==    by 0x609BCE4: g_main_context_dispatch (in /lib/x86_64-linux-gnu/libglib-2.0.so.0.4000.0)
	==6926==    by 0x609C047: ??? (in /lib/x86_64-linux-gnu/libglib-2.0.so.0.4000.0)
	==6926==    by 0x609C309: g_main_loop_run (in /lib/x86_64-linux-gnu/libglib-2.0.so.0.4000.0)
	==6926==    by 0x4058AB: main (spicy.c:1858)

2015-11-10  Francois Gouget  <fgouget@codeweavers.com>

	build-sys: Remove some dead configure.ac DBus code
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2015-11-04  Francois Gouget  <fgouget@codeweavers.com>

	spice-gtk: Fix error handling in stream_get_current_frame()
	*data must always be set to NULL on error.

2015-10-30  Victor Toso  <victortoso@redhat.com>

	channel-usbredir: drop isoc packets on low bandwidth
	When channel wants to send much more data then the wire can handle, the
	queue grows fast. This patch does not limit the queue growth but
	introduces an internal API to check if queue size is too big.

	This internal API is used in usbredir_buffered_output_size_callback
	which is called before any isoc pacaket is queued in usbredir. The
	usbredir implements the logic to:
	 - only drop isoc packets
	 - while dropping packtes does still give us video frames from and above
	   10fps streams

	An easy way to test locally is sharing and webcam and with tc:
	    tc qdisc add dev lo root netem delay 100ms
	    tc qdisc change dev lo root netem delay 1000ms
	    tc qdisc del dev lo root netem

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1264156

2015-10-23  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: Remove unused conditional

	Adjust to spice-common spice-deps.m4 changes
	This commit updates spice-common to latest git master.
	Since the argument to the SPICE_CHECK_xxx macros is now unused, it's
	cleaner to remove it.

	Christophe Fergeau (3):
	      Add marshaller test case
	      build-sys: Use ${PKG_CONFIG} rather than pkg-config
	      build-sys: Rework SPICE_CHECK_* m4 macros

	Frediano Ziglio (1):
	      common: Fix typo in comment

	Javier Celaya (1):
	      Fix linearization of several marshallers with one item

2015-10-22  Jonathon Jongsma  <jjongsma@redhat.com>

	Remove noisy debug statement
	This isn't terribly useful for general debugging and makes the log
	pretty noisy when transferring large files.

	Don't print error message on successful file transfer
	In certain circumstances we were printing an error message even though
	the file transfer had completed successfully. It didn't cause any
	problems, but it pointed out an issue in the handling of outgoing agent
	messages.

	The described behavior was generally only encountered when there were multiple
	files being transferred at once, and most often when one or two files were
	significantly smaller than another file being transferred. For example, two
	20kB files and another 3MB file. The failure mechanism is basically as follows:

	For each file transfer, we read a chunk for the file and then we queue a series
	of messages to the guest and wait for them to be flushed before continuing to
	read a new chunk of the file. (Since the maximum agent message size is 2kB, each
	64kB chunk of file being read can generate up to 32 messages at a time). The
	file transfer task remains in "pending" state until the flush operation is
	complete. Since all agent messages go into a single channel-wide queue, waiting
	for the messages to be flushed meant waiting for *all* outgoing messages to be
	flushed, including those that were queued after we called flush_async().

	Since agent messages can only be sent if the client has enough agent tokens, it
	can take a little while for all queued messages to be sent.  This means that
	even if a file transfer task has sent out all of its data to the guest, it can
	be kept in "pending" state for some time if other file transfer tasks or other
	agent messages are added to the queue. In this situation, The guest might
	notice that it has received all of the data for a file transfer task and send a
	XFER_STATUS_SUCCESS message while we're still in "pending" state.

	This patch changes to code so that flush_async() only waits for the
	currently-queued messages to be sent. This means that it is not affected by any
	new messages that get added to the outgoing queue after we've called
	flush_async(). This means that the task will exit "pending" state immediately
	after sending out our last data packet.

	Fixes: rhbz#1265562

	MainChannel: move task free from finalize to dispose
	In order to avoid reference cycles, you're supposed to release
	references in dispose, especially to those objects that can hold
	references to yourself. This probably wasn't causing any leaks, since
	the file transfer tasks generally are not alive when the main channel is
	destroyed, but it's more proper.

2015-10-16  Jonathon Jongsma  <jjongsma@redhat.com>

	FileTransferTask: ensure we emit 'finished' signal
	In the case where a file cannot be opened for reading, we were not
	emitting a 'finished' signal to communicate the error to the client.

	I was intending to further fix this issue by 'rejecting' the drop (in
	SpiceDisplay) when the URI list contains invalid files (e.g.
	directories). This would prevent a 'new-file-transfer' signal from even
	being emitted for these invalid files. But this turns out to be not very
	useful since there's no real feedback given to the user to indicate why
	the drop failed. So it's probably better for client applications to get
	the 'new-file-transfer' and 'finished' signals so that they can present
	the error to the user to explain why the attempted transfer did not
	work.

2015-10-14  Christophe Fergeau  <cfergeau@redhat.com>

	Free display_cache in cache_unref
	Otherwise it will be leaked. There is no cache_ref function, or helper
	increasing a refcount/taking a reference so cache_unref really is a
	cache_free method.

	This fixes:

	==27687== 64 bytes in 4 blocks are definitely lost in loss record 250 of 435
	==27687==    at 0x4C28C50: malloc (vg_replace_malloc.c:299)
	==27687==    by 0xA6AF058: g_malloc (gmem.c:94)
	==27687==    by 0xA6C5982: g_slice_alloc (gslice.c:1007)
	==27687==    by 0x40F112: cache_new (spice-channel-cache.h:54)
	==27687==    by 0x40F112: cache_image_new (spice-channel-cache.h:64)
	==27687==    by 0x40F112: spice_session_init (spice-session.c:294)
	==27687==    by 0xA239B4A: g_type_create_instance (gtype.c:1870)
	==27687==    by 0xA21C31A: g_object_new_internal (gobject.c:1779)
	==27687==    by 0xA21DB10: g_object_newv (gobject.c:1926)
	==27687==    by 0xA21E3FB: g_object_new (gobject.c:1619)
	==27687==    by 0x40FF4D: spice_session_new (spice-session.c:1479)
	==27687==    by 0x40E678: test_session_uri (session.c:35)
	==27687==    by 0xA6CE47A: test_case_run (gtestutils.c:2158)
	==27687==    by 0xA6CE47A: g_test_run_suite_internal (gtestutils.c:2241)
	==27687==    by 0xA6CE642: g_test_run_suite_internal (gtestutils.c:2253)

	Rename display_cache::cache_unref to cache_free
	display_cache is no longer refcounted since commit c9d4773, but this is
	not an issue as even before, the fact that it was refcounted was not
	used as there was no corresponding cache_ref() call (and
	g_hash_table_ref() was not called directly either).
	As the next commit will free memory from cache_unref() rather than just
	releasing a reference, it's better to make it obvious that this method
	is a _free() method rather than an _unref() one.

2015-10-09  Jonathon Jongsma  <jjongsma@redhat.com>

	New file transfer API
	There were several shortcomings to the existing file transfer API,
	particularly in terms of monitoring ongoing file transfers. The major
	issue is that spice_main_file_copy_async() allows you to pass an array
	of files, but the progress callback does not provide a way to
	identify which file the callback is associated with. This makes it
	nearly impossible for an application to monitor file transfers.

	In addition, the SpiceDisplay widget automatically handles drag-and-drop
	actions on the widget, and initiates file transfers without allowing the
	application to specify a progress callback. So there's no way for an app
	to monitor file transfers that are initiated via drag and drop.

	http://lists.freedesktop.org/archives/spice-devel/2015-September/021931.html
	has a more detailed explanation of the issues.

	This change doesn't break the existing API, but adds some new API that
	will allow an application to monitor file transfer progress, even for
	transfers that are initiated within spice-gtk itself.

	- A new public SpiceFileTransferTask object is added.
	- The SpiceMainChannel object gains a "new-file-transfer" signal that is
	  emitted whenever a new file transfer is initiated. The
	  SpiceFileTransferTask object is passed to the signal handler.
	- The application can retain this object and monitor its 'progress'
	  property to be notified when the progress of the file transfer
	  changes. The SpiceFileTransferTask::finished signal indicates when the
	  given file transfer has completed. The application can also cancel the
	  file transfer by calling the _cancel() method.

	The 'spicy' test application has been updated to use this new API and
	display a simple dialog showing the progress of individual files.

	Fix progress monitoring in spice_main_file_copy_async
	spice_main_file_copy_async() allows you to pass a NULL-terminated array
	of files to transfer to the guest. It also allows you to pass a
	progress_callback function to monitor the progress of the transfer, but
	this progress callback is called separately for each file that is
	transferred, and there are no parameters that allow the caller to
	determine which file a given callback corresponds to. This makes it very
	difficult to monitor the progress.

	To make this more usable, I've changed it so that the progress callback
	doesn't simply report the number of bytes read and total size of the
	current file. Instead, we add up the status of all current transfers and
	report that value to the callback.

	Don't wrap included headers in G_BEGIN|END_DECLS
	Only the local declarations should be declared extern "C", otherwise it
	can result in unexpected errors such as this (encountered while re-ordering
	some include statements for a different patch):

	  CC       channel-inputs.lo
	In file included from /usr/include/glib-2.0/glib/gmacros.h:38:0,
	                 from /usr/lib64/glib-2.0/include/glibconfig.h:9,
	                 from /usr/include/glib-2.0/glib/gtypes.h:32,
	                 from /usr/include/glib-2.0/glib/galloca.h:32,
	                 from /usr/include/glib-2.0/glib.h:30,
	                 from /usr/include/glib-2.0/gobject/gbinding.h:28,
	                 from /usr/include/glib-2.0/glib-object.h:23,
	                 from /usr/include/glib-2.0/gio/gioenums.h:28,
	                 from /usr/include/glib-2.0/gio/giotypes.h:28,
	                 from /usr/include/glib-2.0/gio/gio.h:26,
	                 from ../../src/spice-channel.h:27,
	                 from ../../src/channel-inputs.h:25,
	                 from ../../src/channel-inputs.c:20:
	/usr/lib/gcc/x86_64-redhat-linux/4.9.2/include/stddef.h:147:1: error: expected '=', ',', ';', 'asm' or '__attribute__' before 'typedef'
	 typedef __PTRDIFF_TYPE__ ptrdiff_t;
	 ^

	Gtk applications should only include spice-client-gtk.h
	This header is the single include needed for all gtk-related
	functionality, similar to spice-client.h. Generate a compiler warning if
	a different header is included.

	Glib applications should only include spice-client.h
	Generate a compiler warning if an application attempts to include a
	different header.

2015-09-28  Jonathon Jongsma  <jjongsma@redhat.com>

	Fix documentation for spice_main_file_copy_async()
	'sources' should be a NULL-terminated array, but the parameter
	documentation treats it as if it is a single file object.

2015-09-25  Jonathon Jongsma  <jjongsma@redhat.com>

	Update NEWS for 0.30 release

	Move glib-compat.c to POTFILES.skip
	Since these messages are only used for terminal debug output, let's not
	waste time translating them.

2015-09-25  Pavel Grunt  <pgrunt@redhat.com>

	docs: Fix typos

	docs: Add missing symbol description strings

	docs: Description should be above 'Return'

	docs: Add missing parameter/field descriptions

	docs: Move SPICE_TYPE_USB_DEVICE to standard subsection

	docs: Add Version Information section

	docs: Update for missing symbols

	channel-main: Rename parameter to match docs

	channel-record: Use correct nick name for property

2015-09-23  Jonathon Jongsma  <jjongsma@redhat.com>

	Add glib-compat.c to POTFILES.in
	Some translatable strings were added in commit 8c37a340.

2015-09-18  sstuts  <sstutsma@redhat.com>

	Add "monitors config position" capability.
	This will allow Windows guests to determine if the client supports a
	monitors_config message from a multi-monitor guest that is not
	multi-headed, i.e., that has one monitor per driver.

	It keeps commit:8b0cd321d5a4d08ccba5845c5f2206e6f8032c1d
	from breaking if an updated win-qxl driver is paired with an older client.

	This resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1248189
	---
	Changed from v1: Removed a local commit that preceded this one.
	---
	Changed from v2: Changed name to "monitors config position"
	---

2015-09-15  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: Fix spice-protocol requirements in .pc file
	Commit d0ae58a8 added spice-protocol >= 0.12.10 to the Requires.private
	field in spice-client-glib.pc. However it's already present in the
	Requires field without a version check. Once spice-gtk is built and
	installed, building a program against spice-gtk needs spice-protocol,
	but no specific version of it, so we can drop the duplicate
	Requires.private requirement, and keep the unversioned one in Requires.

2015-09-10  Jonathon Jongsma  <jjongsma@redhat.com>

	Don't send monitors config when Display widget is created
	When a display channel is associated with a particular SpiceDisplay
	widget, it previously set the display to 'enabled' unconditionally.
	There is a couple of problems with this behavior.

	First, simply because a display widget has an associated display
	channel, it doesn't necessarily mean that the display is enabled. On
	linux guests, for instance, a display channel can have up to 4 displays
	for one channel, and perhaps only one of them is enabled. So, we
	shouldn't set the display to 'enabled' until we actually receive a
	monitors configuration message indicating that this display is enabled.

	The second problem is that this was triggering the client to send down a
	new monitors-config message to the server. This message is completely
	unnecessary since it is triggered by a message from the server. We
	should only be sending down new monitor configurations in response to
	changes from the client, not from the server.

	Add spice_main_update_display_enabled()
	This is a new function that allows the caller to decide whether to send
	the new status down to the server or not (analogous to the difference
	between spice_main_set_display() vs spice_man_update_display()).

	This new function is needed to reduce unnecessary MonitorsConfig
	messages from being sent to the server. Because spice-gtk does not
	maintain any display state internally, it depends on the application to
	maintain that state. Some state changes come from the server itself
	(e.g. the guest has changed resolution due to some activity within the
	guest), and some come from the application (e.g. the user has resized
	the window of the client). Changes that come from server updates do not
	need to be sent back down to the server, whereas those that originate
	from the application *do* need to be sent to the server.

2015-09-09  Pavel Grunt  <pgrunt@redhat.com>

	file-xfer: Simplify time handling
	Use g_get_monotonic_time() instead of g_date_time_new_now_local().
	g_get_monotonic_time doesn't suffer discontinuities and it is sufficient
	for our purposes. There is no need for the complexity of GDateTime.

2015-09-08  Victor Toso  <victortoso@redhat.com>

	audio: Do not volume-sync without audio
	In case audio backend is not initialized correctly or there isn't audio
	in the VM, we should not try to volume-sync.

	Fixes: https://bugzilla.redhat.com/show_bug.cgi?id=1257210

2015-08-25  Pavel Grunt  <pgrunt@redhat.com>

	file-xfer: Add debug messages about a file transfer progress
	During the file transfer debug messages about the progress are printed
	every 20 seconds for each of the file transfer tasks.

	Fixes:
	https://bugzilla.redhat.com/show_bug.cgi?id=1140512

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	glib-compat: Add g_format_size
	g_format_size_for_display is deprecated since glib 2.30. See glib commit
	afd1e3697065c1bd23fe9a1cacf43d8744d0bc9b

	g_format_size will be used in the following commit

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-08-21  Marc-André Lureau  <marcandre.lureau@redhat.com>

	session: update spice_session_connect() doc
	Update the documentation about the return value, and how to watch for
	connection success.

	Releated to:
	https://bugzilla.redhat.com/show_bug.cgi?id=1253848

2015-08-14  Christophe Fergeau  <cfergeau@redhat.com>

	Adjust to new SpiceImageCompress name
	This has been renamed to SpiceImageCompression in order to avoid clashes
	with older spice-server in the SPICE_IMAGE_COMPRESS_ namespace. This
	commit is a straight rename of SpiceImageCompress to
	SpiceImageCompression and SPICE_IMAGE_COMPRESS_ to
	SPICE_IMAGE_COMPRESSION_

	build-sys: Remove spice-protocol submodule
	It's seeing regular releases and is API stable, so we don't need to
	bundle it with spice-gtk

2015-08-05  Christophe Fergeau  <cfergeau@redhat.com>

	usbredir: Add a few debug logs
	Currently, spice-gtk debugging logs contain no traces of the
	values of the auto-redir/redir-on-connect filter, and it does not tell
	you about the vid/pid of the devices being connected/redirected.
	This commit adds the appropriate SPICE_DEBUG/CHANNEL_DEBUG calls so that
	this data is logged.

	channel: Don't warn when no CA is set
	Since v0.22~19 "Use system-wide trust certificate store", when neither
	SpiceSession::ca-file nor SpiceSession::ca are set, the system-wide
	CA store will be used to validate the SPICE certificates.
	However, there is still a g_warn_if_fail() checking that either ca or
	ca-file are set, which causes a runtime warning when trying to use the
	system-wide store. This commit removes it.

2015-08-03  Pavel Grunt  <pgrunt@redhat.com>

	Notify about existence of monitor for all display channels
	Windows guest can have disabled display on the display chanel #0, in
	that case it will not be listed in virt-viewer's "View->Displays" menu

	Resolves:
	https://bugs.freedesktop.org/show_bug.cgi?id=91489

2015-07-28  Sandy Stutsman  <sstutsma@redhat.com>

	Handle single headed monitors that have a non-zero x, y config
	Each monitor on a Windows guest is represented as a separate, single-headed
	device with its own framebuffer.  When there are multiple monitors, all
	monitors but one will have a non-zero xy config position.  But even in
	these cases the whole area (frame-buffer) of each monitor should be
	updated.

	Addresses: https://bugzilla.redhat.com/show_bug.cgi?id=1202419

2015-07-28  Jeremy White  <jwhite@codeweavers.com>

	Add the gtk libraries to the gtk-scandoc link line.
	This prevents a compile error on Debian Jessie, when building from git.

	This is fairly subtle, and Debian specific.  It only happens when you use
	autoreconf to generate a new libtool script.  Debian patches that script
	to require an explicit setting to link with all dependent libraries.

	It should be harmless on other distros, and it does save us Debian guys some
	hassle.

2015-07-13  Pavel Grunt  <pgrunt@redhat.com>

	Use g_return_val_if_fail instead of wrong g_return_if_fail
	The commit 4b5e6ec2114e1250c81027ebeac9cfe8d059153f introduced a function
	returning gboolean, g_return_val_if_fail() should be used instead of
	g_return_if_fail().

	Send monitor config if at least one monitor has dimensions
	If a client (virt-manager, spicy) is not setting display dimensions
	and the "resize-guest" property is disabled, spice-gtk sends a wrong
	monitor config message where all the monitors have width = heigh = 0
	when the agent connects. This message can confuse the guest, in that
	case the guest will change the resolution of its monitor.

	Regression since 28312b8d1e287a320851e8828825f2ca138d8b0b

	Resolves:
	https://bugzilla.redhat.com/show_bug.cgi?id=1240721

2015-07-10  Sandy Stutsman  <sstutsma@redhat.com>

	This adds reference counting to cached images.
	Windows guests with multi-monitors will often send down the same image
	via different channels.  If these instances are not counted,  one channel
	can delete an image before all the rest of the channels are finished with
	it. In this case, the client will hang.

	This can happen, for instance, when the Windows guest is updating the
	monitor's wallpaper. There is a driver instance for each monitor, so each
	one is sending down its own copy of the same image with the same id.  As
	one channel may be busier than another, the order that the client executes
	commands may not be the same order as the server issued them.  Here's what
	can happen:

	  On the server side:
	    Monitor 1 sends image A
	    Monitor 1 sends multiple rendering commands for image A
	    Monitor 1 removes image A
	    Monitor 2 sends image A
	    Monitor 2 sends rendering commands for image A
	  On the client side:
	    Monitor 1 adds image A to the cache
	    Monitor 1 starts rendering with image A
	    Monitor 2 adds image A to the cache - has same id, so image is replaced
	    Monitor 1 removes image A - image A is completely removed from cache
	    Monitor 2 render command hangs waiting for image A

	Addresses bug: https://bugzilla.redhat.com/show_bug.cgi?id=1194354

2015-07-06  Christophe Fergeau  <cfergeau@redhat.com>

	Update spice-protocol
	This will fix EL6 builds.

	Christophe Fergeau (1):
	      m4: Add compat AS_VAR_APPEND for older autoconf

	Lukas Venhoda (3):
	      ppc: Fix quic decode endianess
	      ppc: Fix lz magic endianess
	      ppc: Fix quic magic endianess

2015-06-30  Jonathon Jongsma  <jjongsma@redhat.com>

	Make monitors config debug output more clear
	Indicate whether the monitors config debug output is from sending or
	receiving new monitors configuration. You can tell this by looking at
	which channel is involved (main vs display), but making it more explicit
	is helpful for glancing through logs.

2015-06-29  Javier Celaya  <javier.celaya@flexvdi.com>

	Display: Send a preferred compression message on init.
	If the user prefers a specific compression algorithm, report it when
	setting up the display channel.

	Add a preferred-compression program option

	Spice-session: Add preferred-compression property.
	Also, depend on the spice-common commit that introduces the
	SpiceImageCompress enum.

2015-06-26  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: Fix build with automake < 1.13
	AC_CONFIG_MACRO_DIRS is not available with older automake versions,
	which causes autogen.sh failures on RHEL6. m4_include() can be used
	instead.

2015-06-25  Pavel Grunt  <pgrunt@redhat.com>

	Send monitor config if guest supports sparse monitors
	It is ok to send monitor configuration even for displays which are not
	disabled or enabled. Because the guest having support for the sparse
	monitor configuration (VD_AGENT_CAP_SPARSE_MONITORS_CONFIG) will not
	resize the monitor which is disabled / undefined.

	Fixes:
	https://bugs.freedesktop.org/show_bug.cgi?id=90914

	channel-main: Use enum to describe display state

2015-06-22  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: Use SPICE_CHECK_LZ4
	spice-common now has an m4 macro adding a --enable-lz4 option and
	doing the needed checks, so we can use it in configure.ac rather than
	duplicating it here.

	build-sys: Use SPICE_CHECK_SMARTCARD
	spice-common has an m4 macro adding a --enable-smartcard option and
	doing the needed checks, so we can use it in configure.ac rather than
	duplicating it here.

2015-06-19  Christophe Fergeau  <cfergeau@redhat.com>

	spicy-*: Remove translation support
	These are only meant to be test tools so they don't need to be
	translated.

2015-06-18  Lukas Venhoda  <lvenhoda@redhat.com>

	spicy: Enable recent chooser on windows
	Recent chooser is working correctly in windows.

	spicy: Replace duplicated code with a for loop
	Changed piece of code working with fixed size array into a for loop.

	spicy: Host and port (or tls) are now required
	Connect button is now non-sensitive when host and port (or tls) entry is empty.
	Pressing enter will now also NOT connect, when the entries are empty.

	spicy: Fixed reselecting in recent chooser
	Selecting an entry in the recent connections list, and then modifying
	the host/port/TLS port, and double-clicking on that same entry in the
	list would cause spicy to connect to the edited address rather than
	the one which was picked in the recent chooser.

	After this commit, the selection will be cleared from the recent
	chooser, and double-clicking on an entry after editing it will always
	trigger a 'selection-changed' signal, which will properly set the
	address to connect to.

	spicy: Changed the dialog into a window
	Changed connect dialog from GtkDialog to GtkWindow.

	Added the necessary signals and buttons, to keep then
	behaviour of a dialog (ESC to close, ENTER to submit).

	spicy_connect_dialog now returns TRUE and FALSE instead of 0 and -1.

	spicy: Move connect dialog to its own file
	Connect dialog from spicy is now in its own file.

	Renamed connect_dialog to spicy_connect_dialog.

	Added new file for translation.

2015-06-18  Victor Toso  <victortoso@redhat.com>

	spice-widget: keypress-delay set by env var

2015-06-15  Marc-André Lureau  <marcandre.lureau@redhat.com>

	Prepare for 0.29 release

	channel: check too long password
	Make sure that the password length is under the maximum lenght. If not
	report it as an authentication failure with an adapted message.

2015-06-15  Pavel Grunt  <pgrunt@redhat.com>

	configure: Try gstreamer audio backend if pulse is not available
	Disable audio if no backend is available and configure is used with
	the option '--with-audio=auto'

2015-06-09  Victor Toso  <victortoso@redhat.com>

	webdav: keep phodav requirements inside USE_PHODAV
	Commit 33d4016228798108250b0ef9173f2c4c719a5065 uses
	g_output_stream_write_all_async/finish which is on gio 2.44 version.
	This breaks the build on older systems even if --disable-webdav is used.

	Using #USE_PHODAV to wrap those functions that will not be called
	without --enable-webdav.

2015-06-09  Fabiano Fidêncio  <fidencio@redhat.com>

	spice-widget: Do not update display when resize-guest is disabled
	Updating the display causes weird behaviors in virt-viewer, like
	re-resizing to a previous monitor config when, after changing the
	display resolution (through System > PReferences > Displays). the agent
	reconnects.
	It is not perfect yet, because when the agent reconnects the guest
	resizes to the previous config and switch to the proper one, but this
	seems more like an agent bug than a spice-gtk one.

2015-06-08  Marc-André Lureau  <marcandre.lureau@redhat.com>

	channel: use class private handlers field
	Since spice-gtk requires glib 2.28, we can now fix a small FIXME.

	Since G_TYPE_CLASS_GET_PRIVATE is a bit expensive, it's still worth to
	cache it in klass->priv. However, there is no good place I can think of
	to put this. (channel_class_init() is called only once, and not per
	each subclass)

	Move gtk/ -> src/
	For historical reasons, the code was placed under gtk/ subdirectory.
	If it was always bugging you, bug no more!

	TODO: update
	Remove outdated items:
	- ChannelBaseAudio?,
	- GDI backend wouldn't work well with scaling (moved to fdo bug)

	Fix fdo link

2015-06-08  Pavel Grunt  <pgrunt@redhat.com>

	usb-device-manager: Avoid error when compiling with --disable-usbredir

2015-06-05  Marc-André Lureau  <marcandre.lureau@gmail.com>

	usb: remove useless assignments
	The struct is g_new0() already.

	win-usb: try to connect to usbclerk during init
	Fail early during initialization if the usbclerk service can't be
	reached.

	This changes the current behaviour that would retry to connect to
	usbclerk every time to perform an operation. Now, it will try each time
	the UsbDeviceManager is initialized.

	usb: do not return GError on programmer pre-condition checks
	Use regular g_return precondition checks.

	win-usb: remove useless function

	usb: misc code formatting

	usb: call win_usb_driver_new() during initable_init()
	Throw an error when initialization failed.

	usb: use SPICE_CLIENT_ERROR_ prefix
	To be consistent with GLib idioms, the code should use a common prefix for errors.

	usb: unref the device when it is no longer needed
	The current code unref() the device too early, it must be unref
	after it is no longer needed.

	win-usb: get rid of status code return in async ops

	win-usb: throw an error if reply.status == 0

	usb: use win-usb uninstall_finish()

	win-usb: rename async functions

	win-usb: introduce a spice_win_usb_driver_op_finish
	We want the exported functions to follow the gio async idom. Currently,
	both install() and uninstall() are paired with install_finish(). In the
	following patch we introduce uninstall_async() uninstall_finish() using
	that common internal op_finish() function. Then we correctly pair
	associated async/finish() calls.

	usb: remove useless declaration

2015-06-05  Victor Toso  <victortoso@redhat.com>

	tests: add test to check for zombie GSources
	Using g_pollable_input_stream_create_source to generage several dummy
	GSources in order to check if giopipe sets all of them to be dispatched.

	This test check for zombie GSources during a write_all/read_chunk
	operation.

	tests: add test to concurrent write to pipe
	Concurrent write is not supported and should fail. The GIO error is
	G_IO_ERROR_PENDING

	tests: pipe using _write_all_async function

	tests: remove read8_cb to use generic read_cb
	Both functions are basic the same so let's keep the generic one.

	webdav: write all buffer to client webdav
	Client's webdav can request less data (8192) then the amount sent by
	guest's webdav. Using g_output_stream_write_all_async in order to avoid
	losing data.

	giopipe: don't fail on create_source
	PipeInputStream and PipeOutputStream should not fail when creating
	GPollableStream source as this currently does not work with default
	write_all and read_all functions;

	In order to avoid creating zombie GSource in create_source of both
	PipeInputStream and PipeOutputStream, we track all created GSources and
	set them to be dispatched when data is available to read/write. It is
	worth to mention that concurrent write/read is not possible with current
	giopipe and only the last created GSource will read the data as it is
	dispatched first.

2015-06-03  Pavel Grunt  <pgrunt@redhat.com>

	session: Enable proxy when requested
	Disabling the proxy avoids usage of GProxyResolver to determine
	the necessary proxy protocol and to do the proxy negotiation.

2015-05-28  Marc-André Lureau  <marcandre.lureau@redhat.com>

	session: disable default socket proxy
	GSocketClient uses the system proxy by default, and it may end up using
	the system HTTP proxy with bad results if CONNECT is not
	supported. spice-gtk uses it's own SPICE_PROXY instead, and doesn't rely
	on GSocketClient default proxy but GProxyAddress instead. Disabling the
	default proxy solve a wrong proxy from being used.

	It may be worth to revisit this change if GSocketClient can be told to
	ignore proxies that are not eligible for Spice connections. (HTTP could
	be though, in which case it would be a user configuration issue)

	Fixes:
	https://bugzilla.redhat.com/show_bug.cgi?id=1040679

2015-05-21  Benjamin Gilbert  <bgilbert@cs.cmu.edu>

	Drop expansions of removed CFLAGS/LIBS variables

2015-05-21  Marc-André Lureau  <marcandre.lureau@redhat.com>

	iopipe: fix leak of streams
	g_simple_io_stream_new() do not steal references from us, unref the
	streams to avoid the leaks.

	Leak found by Victor Toso.

	==30787== 2,808 (648 direct, 2,160 indirect) bytes in 9 blocks are definitely lost in loss record 479 of 482
	==30787==    at 0x93AEBFD: g_type_create_instance (gtype.c:1849)
	==30787==    by 0x939128A: g_object_new_internal (gobject.c:1774)
	==30787==    by 0x9392AA0: g_object_newv (gobject.c:1921)
	==30787==    by 0x939338B: g_object_new (gobject.c:1614)
	==30787==    by 0x403B30: make_gio_pipe (giopipe.c:441)
	==30787==    by 0x403C8E: spice_make_pipe (giopipe.c:465)
	==30787==    by 0x4029B5: fixture_set_up (pipe.c:42)
	==30787==    by 0x9844EC8: test_case_run (gtestutils.c:2123)
	==30787==    by 0x9844EC8: g_test_run_suite_internal (gtestutils.c:2185)
	==30787==    by 0x984509A: g_test_run_suite_internal (gtestutils.c:2196)
	==30787==    by 0x98453FA: g_test_run_suite (gtestutils.c:2249)
	==30787==    by 0x9845430: g_test_run (gtestutils.c:1553)
	==30787==    by 0x402012: main (pipe.c:312)

2015-05-12  Marc-André Lureau  <marcandre.lureau@redhat.com>

	spicy: remove useless signal handlers
	There is no strong reason to have signal handlers in spicy (a test
	tool). Clean quit can be achieved through the File/Quit menu.

	Fixes:
	https://bugzilla.redhat.com/show_bug.cgi?id=1197175

2015-05-12  Lukas Venhoda  <lvenhoda@redhat.com>

	spice-gtk: Fixed build when using audio gstreamer
	Commit No. 63bf00275769928850113b4df205df08d6303b45 changed number of
	arguments of function playback_stop(), and didn't change call of this
	function on line 628.

	This would break building when using --with-audio=gstreamer

2015-05-07  Marc-André Lureau  <marcandre.lureau@redhat.com>

	webdav: check g_output_stream_write_all() return value
	Check g_output_stream_write_all() return value to silence a coverity
	CHECKED_RETURN warning

	usb: channel-new handler to be after default handlers
	Client usually connect to channel-new to connect their
	handlers, such as open-fd.

	The usbmanager channel-new handler will call channel_connect() on usbredir
	channels, which may call open-fd.

	However, open-fd can be emitted before the client had a chance to
	connect their handlers (from the channel-new callback).

	Connecting after the default handler solves this case.

	Fixes:
	https://bugzilla.gnome.org/show_bug.cgi?id=748665

	session: do not attempt to open_host if session changed
	Since channel can become session-less, let's check they still have the
	expected session when running the open-host idle.

	audio: stop playback on channel destroyed
	Ensure playback is stopped when the channel is destroyed.

	audio: use swapped channel handler for stop
	We are going to reuse playback_stop() in following commit.

	record: do not crash after record is stopped
	If spice_record_send_data() after a reset, last_frame is NULL and memcpy
	will crash.  Check if the recording was started if last_frame != NULL
	instead.

	 Program received signal SIGSEGV, Segmentation fault.
	 __memcpy_avx_unaligned () at ../sysdeps/x86_64/multiarch/memcpy-avx-unaligned.S:204
	 204                       vmovdqa %ymm0, (%rdi)
	 (gdb) bt
	 #0  __memcpy_avx_unaligned () at ../sysdeps/x86_64/multiarch/memcpy-avx-unaligned.S:204
	 #1  0x00007ffff44f57b5 in spice_record_send_data (channel=0x1228640, data=0x7fff9ad0f000, bytes=960, time=0) at channel-record.c:349
	 #2  0x00007ffff45162f0 in stream_read_callback (s=0xad8c00, length=960, data=<optimized out>) at spice-pulse.c:485
	 #3  0x00007ffff2ea0c76 in pstream_memblock_callback (p=<optimized out>, channel=<optimized out>, offset=0, seek=PA_SEEK_RELATIVE, chunk=0x7fffffffcf70, userdata=0x11e71c0) at pulse/context.c:411
	 #4  0x00007fffe8da8b4f in do_read (p=p@entry=0x123a050, re=re@entry=0x123a1d0) at pulsecore/pstream.c:906
	 #5  0x00007fffe8daae87 in do_pstream_read_write (p=0x123a050) at pulsecore/pstream.c:193
	 #6  0x00007ffff30e1bea in dispatch_func (source=0x1111e50, callback=<optimized out>, userdata=<optimized out>) at pulse/glib-mainloop.c:584
	 #7  0x00007fffed76b93b in g_main_dispatch (context=0x816ea0) at gmain.c:3122

	Fixes:
	https://bugzilla.redhat.com/show_bug.cgi?id=1215343

	playback: do not set mm time when session-less
	Channels do not hold a strong reference on the session (because session
	can be recycled after disconnect), do not print a warning if the channel
	is session-less when updating the delay.

	audio: emit stop when the channels are reset
	Ensure a hint is given to the client that the channel is reset.

	Unfortunately, since the handle may be asynchronous due to coroutine,
	the channel functions should be tolerant to a playback/record calls
	functions when the channel is stopped.

	audio: channel-new handler to be after default handlers
	Client usually connect to channel-new to connect their
	handlers, such as open-fd.

	The audio channel-new handler will call channel_connect() on audio
	channels, which may call open-fd.

	However, open-fd can be emitted before the client had a chance to
	connect their handlers (from the channel-new callback).

	Connecting after the default handler solves this case.

	Fixes:
	https://bugzilla.gnome.org/show_bug.cgi?id=747649

2015-04-30  Victor Toso  <victortoso@redhat.com>

	spice-pulse: compatibility with old pulse version
	The commit 37ba949716ebf441110330 breaks compatibility with old versions
	of libpulse as the volume and mute data in pa_source_output_info were
	available only from version 1.0.0 onwards. Using other API function for
	this which does not relay on audio per stream.

	spice-pulse: GSimpleAsyncResult compatibility
	Avoid breaking build with glib older then 2.32 which is when
	g_simple_async_result_set_check_cancellable was introduced.

	glib-compat: add G_SOURCE_REMOVE G_SOURCE_CONTINUE

2015-04-28  Fabiano Fidêncio  <fidencio@redhat.com>

	session: Get the lock modifiers from GdkKeymap
	A cleaner way to get the lock modifiers, without depend on the
	platform/backend used (as X or Wayland), is get them through GdkKeymap
	(and its _get{caps,num,scroll}_lock_state() functions).
	Unfortunately, get_scroll_lock_state() will only be present for Gtk+
	3.18.0 and when it becomes the minimal required version we can easily
	drop the old code.

2015-04-24  Victor Toso  <victortoso@redhat.com>

	agent: sync guest audio with client values
	Functions to sync volume and mute value when necessary. In this patch,
	only one sync is allowed after agent connect.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1012868

	audio: spice-gstaudio implements async volume-info
	Gstaudio rely on sink/src elements to get the volume/mute.
	(e.g. pulsesink and pulsesrc, the values are updated by PulseAudio
	itself when requested)

	audio: spice-pulse implement async volume-info
	In case of volume-sync between client and guest, we request volume-info
	from the availables streams and if the stream is not available we rely
	on ext-stream-restore.

	By using ext-stream-restore we can get the last stream data of the
	application that is stored by PulseAudio.

	Related: https://bugzilla.redhat.com/show_bug.cgi?id=1012868

	audio: spice-audio with get mute and volume
	Async functions to be implemented by spice-gstaudio and spice-pulse to
	get the updated volume and mute values for playback and record stream.

	Related: https://bugzilla.redhat.com/show_bug.cgi?id=1012868

	Update spice-common submodule
	This includes volume synchronization protocol;

2015-04-24  Pavel Grunt  <pgrunt@redhat.com>

	spice-widget: Do not invalidate cursor when display is not ready
	spice_display_get_scaling() gives wrong x, y coordinates and scaling
	when the display is not ready. The wrong values cause runtime
	warnings when disabling a virt-viewer's window:
	Gtk-CRITICAL **: gtk_widget_queue_draw_area: assertion 'width >= 0' failed

2015-04-16  Christophe Fergeau  <cfergeau@redhat.com>

	Fix GSocketAddress leak in proxy_lookup_ready()
	g_proxy_address_new() returns a new GProxyAddress, so we must unref it
	when no longer needed.

	This fixes:

	==6481== 234 (48 direct, 186 indirect) bytes in 1 blocks are definitely lost in loss record 10,062 of 10,
	==6481==    at 0x31FF230A58: g_type_create_instance (gtype.c:1849)
	==6481==    by 0x31FF21501A: g_object_new_internal (gobject.c:1774)
	==6481==    by 0x31FF216EB4: g_object_new_valist (gobject.c:2033)
	==6481==    by 0x31FF217220: g_object_new (gobject.c:1617)
	==6481==    by 0x3D4386F33A: g_proxy_address_new (gproxyaddress.c:325)
	==6481==    by 0x5717440: proxy_lookup_ready (spice-session.c:2011)
	==6481==    by 0x3D43885082: g_task_return_now (gtask.c:1088)
	==6481==    by 0x3D438850B8: complete_in_idle_cb (gtask.c:1102)
	==6481==    by 0x31FEE4A0B9: g_main_dispatch (gmain.c:3122)
	==6481==    by 0x31FEE4A0B9: g_main_context_dispatch (gmain.c:3737)
	==6481==    by 0x31FEE4A44F: g_main_context_iterate.isra.29 (gmain.c:3808)
	==6481==    by 0x31FEE4A771: g_main_loop_run (gmain.c:4002)
	==6481==    by 0x363AC06CC4: gtk_main (in /usr/lib64/libgtk-3.so.0.1600.1)

2015-04-15  Jonathon Jongsma  <jjongsma@redhat.com>

	Make update-symbol-files work when builddir != srcdir
	rewrite the update-symbol-files rule to use dependencies and automatic
	variables ($^) so that VPATH will allow make to find these files in the
	srcdir as well as the builddir.

2015-04-14  Marc-André Lureau  <marcandre.lureau@redhat.com>

	channel: HUP is not an error condition
	On local UNIX sockets, calling close() in the server side will result in
	a HUP condition on client side. Since this is not an error, but a normal
	termination, let's ignore it.

	A clean shutdown would involve a new message to tell the client to first
	close its end, in order to avoid the HUP. That way the client could
	distinguish normal termination from unexpected ones. That's a possible
	future minor enhancement (it seems it would only work with UNIX socket
	though)

	G_IO_IN seemed to be a leftover, it is left here but shouldn't be
	required.

	https://bugs.freedesktop.org/show_bug.cgi?id=90016

	channel: reset c->has_error when connected
	Whenever the channel socket is connected, c->has_error should be reset.
	Until now, only the regular open_host() case was reset, but client
	client provided fd must also reset the error state.

	It should be safe to move it after the "connected" label, since the
	ssl code doesn't need c->has_error.

	https://bugzilla.redhat.com/show_bug.cgi?id=1211063

2015-04-01  Victor Toso  <victortoso@redhat.com>

	audio: keep compatibility with old pulse version
	The commit 9ef68ecd1fd11dea626628 breaks compatibility with old versions
	of libpulse as the source_output functions were available from version
	1.0.0 onwards.

2015-03-27  Pavel Grunt  <pgrunt@redhat.com>

	channel-smartcard: Add missing USE_SMARTCARD checks
	In order to enable build without smartcard support

2015-03-25  Marc-André Lureau  <marcandre.lureau@redhat.com>

	smartcard: add reader and cards on channel up
	The smartcard manager reports reader/card events on insertion and
	removal. If a smartcard channel is created after those events, the
	channel state will not be in sync with the current reader/card state.
	Sync the state when the channel is up.

	Fixes:
	https://bugzilla.redhat.com/show_bug.cgi?id=1205171

	smartcard: connect object signal handlers with spice helper
	The smartcard manager may outlive the smartcard channels. Make sure the
	channel handlers are disconnected when the channel is free by using
	spice_g_signal_connect_object() helper. This fixes crashes when
	dispatching smartcard events on deleted channels.

	Related bug:
	https://bugzilla.redhat.com/show_bug.cgi?id=1205171

2015-03-23  Victor Toso  <victortoso@redhat.com>

	audio: use stream functions for pulse source
	The functions pa_context_set_source_output_mute/volume are specifically
	to change source stream volume/mute.
	I changed the warnings to be compatible to sink_input ones;

2015-03-23  Christophe Fergeau  <cfergeau@redhat.com>

	session: Tone down warning on TLS-only connections
	315c1a5 "session: Add more debugging logs" causes a g_warning() to be
	shown when attempting a TLS connection without specifying a non-TLS
	port.
	This commit makes the message more explicit, and switches it from being
	a warning to being a debug message.

2015-03-12  Pavel Grunt  <pgrunt@redhat.com>

	channel-usbredir: Do not stop event listening if SpiceSession does not exist
	Avoids Segfault when closing the connection just after the usb device redirection.

2015-03-04  Marc-André Lureau  <marcandre.lureau@redhat.com>

	build-sys: fix out-of-tree build from tarball
	There are generated files in build directory too. Fixes:

	CC       util.o
	In file included from ../../tests/session.c:3:0:
	../../gtk/spice-session.h:24:30: fatal error: spice-glib-enums.h:
	No such file or directory #include "spice-glib-enums.h"

	Prepare v0.28 release

2015-03-03  Marc-André Lureau  <marcandre.lureau@redhat.com>

	build-sys: fix required libsoup version for webdav support

	Revert spice-common change
	Commit 85ed268 shouldn't have change spice-common, my bad

	session: bind path and read-only to webdav server
	Keep the server property in sync with the session properties

	session: add share-dir-ro property
	Add a property to specify if share folder access is read-only.

	webdav: use a pipe to connect to server
	Instead of listening on TCP sockets, and proxying connections there,
	make the webdav server accept new connections from stream. The streams
	are user-space GIOStream pipe, one side is connected to the Spice webdav
	channel muxer/demuxer, the other side is a SoupSocket client.

	This makes the server not exposed any local public access, avoid the
	need for server threads, or proxying the connections through system
	sockets.

	Use libphodav-2 (breaks webdav server temporarily)
	This change breaks webdav server, since libphodav-2 no longer
	set up a TCP service running in a thread. It's up to the client
	to decide how best to accept and handle new connections.

	This commits remove all the hacks related to proxying the incoming
	connections to a TCP socket, and protected with a magic sequence.

	The following commit will use GIOStream pipes to handle each client
	connections.

	Add GIOStream-based pipe
	This code creates a pipe between 2 GIOStream, the input side read from
	the peer output side, and vice-versa.

	In the following patches, this will avoid the socket communication
	to exchange with the embedded webdav server.

	glib-2.0 >= 2.43.90 because GSimpleIOStream dependency.

2015-02-27  Victor Toso  <victortoso@redhat.com>

	tests: add spice-session test
	Checking if URIs are being parsed and generated correctly.

	session: accept argument in URI without value
	The examples below should be considered valid URIs:

	e.g: spice://localhost?port=5900&tls-port=
	e.g: spice://localhost?tls-port=&port=5900

	This patch deals with arguments with empty value;

2015-02-23  Pavel Grunt  <pgrunt@redhat.com>

	vncdisplaykeymap: Use XkbGetMap and XkbGetNames instead of XkbGetKeyboard
	XkbGetKeyboard does not work in XWayland (bfo#89240).

	Fixes https://bugs.freedesktop.org/show_bug.cgi?id=89105

2015-02-18  Marc-André Lureau  <marcandre.lureau@redhat.com>

	session: reset connection_id on switch-host
	The server expects no connection_id during link time, in order to
	realize a full reconnection.

	The alternative would be to assume that the destination server has the
	exact same channels and attempt to recreate and to reconnect them one by
	one. However, if the destination is slightly different (say,
	configuration or order of channels differs), this will likely fail. It's
	best to start with a new session without prior knowledge.

	channel: remove unused ChannelClass::channel_disconnect()
	This virtual method turns out to be unnecessary anymore, and
	was never override. channel_reset() is enough.

	channel: set c->has_error to finish coroutine
	It's unnecessary to call channel_disconnect() to finish the coroutine
	and disconnect. Use c->has_error instead, like the rest of channel error
	code.

	Call channel_reset() directly when finishing coroutine
	channel_disconnect() virtual method isn't overloaded by any
	channel, and can be replaced by the equivalent channel_reset()
	when finishing the coroutine.

	channel: reset migration state when calling channel_reset()
	channel_reset() is called in channel_disconnect(). We can just move that
	state change in channel_reset() in order to get rid of
	channel_disconnect().

	channel: use exisiting reconnection code when switching
	Switching for migration reason is similar to a reconnection during
	initial connection.

	A notable difference is that new code path doesn't schedule a
	delayed_unref callback. This is fine since the channel is still running
	and delayed_unref is mainly used for signaling disconnections and none
	should be emitted when switching.

	channel: reset channel state to unconnected
	After coroutine has exited, reset channel state to unconnected,
	this allows recycling a channel for reconnection, even in "normal"
	disconnect/reconnect cases.

	channel: remove useless precondition
	This precondition isn't useful, since the channel is already
	dereferenced before, and I've never seen an idle callback not passing
	the user_data correctly.

	channel: emit close event when coroutine has finished
	Move signaling of closed channel after the coroutine has exited in
	delayed_unref callback, similarly to error events, so it's easier to
	schedule reconnect since coroutine has terminated.

2015-02-16  Javier Celaya  <javier.celaya@flexvm.es>

	channel-port: Remove dependency cycle
	channel-port.h includes spice-client.h, that includes channel-webdav.h,
	that includes channel-port.h again. It's enough if channel-port.h
	includes spice-channel.h

	Without this change, if one tries to build a source file which only
	includes spice-port.h, the build fails with:

	In file included from /usr/include/spice-client-glib-2.0/spice-client.h:46:0,
	                 from /usr/include/spice-client-glib-2.0/channel-port.h:22,
	                 from ./port.c:1:
	/usr/include/spice-client-glib-2.0/channel-webdav.h:44:5: error: unknown type name 'SpicePortChannel'
	     SpicePortChannel parent;
	     ^
	/usr/include/spice-client-glib-2.0/channel-webdav.h:58:5: error: unknown type name 'SpicePortChannelClass'
	     SpicePortChannelClass parent_class;

2015-02-16  Pavel Grunt  <pgrunt@redhat.com>

	widget: Do not draw cursor if widget is not realized
	Silences the runtime warning in virt-viewer and gnome-boxes (bgo#744432):
	Gtk-CRITICAL **: gtk_widget_queue_draw_area: assertion 'width >= 0' failed

2015-02-12  Pavel Grunt  <pgrunt@redhat.com>

	widget: Send keys to guest when keyboard grab is released
	Keys should be sent to the guest if the widget has the focus even
	when the keyboard grab is released.

2015-02-06  Marc-André Lureau  <marcandre.lureau@redhat.com>

	webdav: fix checking for shared directory property
	Trivial fix for 6163828e8cb15d539c80cc3f0bfb5008be9b2247:
	Channel should be created if the shared-dir property is set.

2015-02-06  Benjamin Gilbert  <bgilbert@cs.cmu.edu>

